/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the M68k target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 3;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(M68kInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(M68kInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static M68kInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static M68kInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  void runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 3;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_IsPICBit = 0,
  Feature_IsNotPICBit = 1,
  Feature_AtLeastM68020Bit = 2,
};

PredicateBitset M68kInstructionSelector::
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const {
  PredicateBitset Features;
  if (TM.isPositionIndependent())
    Features.set(Feature_IsPICBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->atLeastM68020())
    Features.set(Feature_AtLeastM68020Bit);
  return Features;
}

void M68kInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const M68kSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset M68kInstructionSelector::
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features;
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

M68kInstructionSelector::ComplexMatcherMemFn
M68kInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool M68kInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_Mximm8_1to8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_Mximm16_1to8,
  GICXXPred_I64_Predicate_Mximm32_1to8,
};
bool M68kInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_Mximm8_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_Mximm16_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_Mximm32_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool M68kInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool M68kInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("M68kInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
M68kInstructionSelector::CustomRendererFn
M68kInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool M68kInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

void M68kInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("M68kInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *M68kInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(47), GIMT_Encode2(134), /*)*//*default:*//*Label 16*/ GIMT_Encode4(3608),
    /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(358),
    /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(613),
    /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(955), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(992),
    /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(1247),
    /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(1502), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ANYEXT*//*Label 6*/ GIMT_Encode4(1757),
    /*TargetOpcode::G_TRUNC*//*Label 7*/ GIMT_Encode4(1837),
    /*TargetOpcode::G_CONSTANT*//*Label 8*/ GIMT_Encode4(1883), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SEXT*//*Label 9*/ GIMT_Encode4(2113), GIMT_Encode4(0),
    /*TargetOpcode::G_ZEXT*//*Label 10*/ GIMT_Encode4(2193),
    /*TargetOpcode::G_SHL*//*Label 11*/ GIMT_Encode4(2273),
    /*TargetOpcode::G_LSHR*//*Label 12*/ GIMT_Encode4(2540),
    /*TargetOpcode::G_ASHR*//*Label 13*/ GIMT_Encode4(2807), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ROTR*//*Label 14*/ GIMT_Encode4(3074),
    /*TargetOpcode::G_ROTL*//*Label 15*/ GIMT_Encode4(3341),
    // Label 0: @358
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 20*/ GIMT_Encode4(612),
    /*GILLT_s8*//*Label 17*/ GIMT_Encode4(381),
    /*GILLT_s16*//*Label 18*/ GIMT_Encode4(458),
    /*GILLT_s32*//*Label 19*/ GIMT_Encode4(535),
    // Label 17: @381
    GIM_Try, /*On fail goto*//*Label 21*/ GIMT_Encode4(457),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 22*/ GIMT_Encode4(437), // Rule ID 692 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (ADD8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 692,
        GIR_Done,
      // Label 22: @437
      GIM_Try, /*On fail goto*//*Label 23*/ GIMT_Encode4(456), // Rule ID 680 //
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ADD8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 680,
        GIR_Done,
      // Label 23: @456
      GIM_Reject,
    // Label 21: @457
    GIM_Reject,
    // Label 18: @458
    GIM_Try, /*On fail goto*//*Label 24*/ GIMT_Encode4(534),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 25*/ GIMT_Encode4(514), // Rule ID 693 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (ADD16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 693,
        GIR_Done,
      // Label 25: @514
      GIM_Try, /*On fail goto*//*Label 26*/ GIMT_Encode4(533), // Rule ID 681 //
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ADD16dr:{ *:[i16] }:{ *:[i8] } MxXRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD16dr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 681,
        GIR_Done,
      // Label 26: @533
      GIM_Reject,
    // Label 24: @534
    GIM_Reject,
    // Label 19: @535
    GIM_Try, /*On fail goto*//*Label 27*/ GIMT_Encode4(611),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 28*/ GIMT_Encode4(591), // Rule ID 694 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (ADD32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 694,
        GIR_Done,
      // Label 28: @591
      GIM_Try, /*On fail goto*//*Label 29*/ GIMT_Encode4(610), // Rule ID 682 //
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ADD32dr:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ADD32dr),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 682,
        GIR_Done,
      // Label 29: @610
      GIM_Reject,
    // Label 27: @611
    GIM_Reject,
    // Label 20: @612
    GIM_Reject,
    // Label 1: @613
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 33*/ GIMT_Encode4(954),
    /*GILLT_s8*//*Label 30*/ GIMT_Encode4(636),
    /*GILLT_s16*//*Label 31*/ GIMT_Encode4(742),
    /*GILLT_s32*//*Label 32*/ GIMT_Encode4(848),
    // Label 30: @636
    GIM_Try, /*On fail goto*//*Label 34*/ GIMT_Encode4(741),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 35*/ GIMT_Encode4(683), // Rule ID 517 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i8] } 0:{ *:[i8] }, i8:{ *:[i8] }:$src)  =>  (NEG8d:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::NEG8d),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 517,
        GIR_Done,
      // Label 35: @683
      GIM_Try, /*On fail goto*//*Label 36*/ GIMT_Encode4(721), // Rule ID 731 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (SUB8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 731,
        GIR_Done,
      // Label 36: @721
      GIM_Try, /*On fail goto*//*Label 37*/ GIMT_Encode4(740), // Rule ID 719 //
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SUB8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 719,
        GIR_Done,
      // Label 37: @740
      GIM_Reject,
    // Label 34: @741
    GIM_Reject,
    // Label 31: @742
    GIM_Try, /*On fail goto*//*Label 38*/ GIMT_Encode4(847),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 39*/ GIMT_Encode4(789), // Rule ID 519 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i16] } 0:{ *:[i16] }, i16:{ *:[i16] }:$src)  =>  (NEG16d:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::NEG16d),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 519,
        GIR_Done,
      // Label 39: @789
      GIM_Try, /*On fail goto*//*Label 40*/ GIMT_Encode4(827), // Rule ID 732 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (SUB16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 732,
        GIR_Done,
      // Label 40: @827
      GIM_Try, /*On fail goto*//*Label 41*/ GIMT_Encode4(846), // Rule ID 720 //
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SUB16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 720,
        GIR_Done,
      // Label 41: @846
      GIM_Reject,
    // Label 38: @847
    GIM_Reject,
    // Label 32: @848
    GIM_Try, /*On fail goto*//*Label 42*/ GIMT_Encode4(953),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 43*/ GIMT_Encode4(895), // Rule ID 521 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG32d:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::NEG32d),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 521,
        GIR_Done,
      // Label 43: @895
      GIM_Try, /*On fail goto*//*Label 44*/ GIMT_Encode4(933), // Rule ID 733 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (SUB32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 733,
        GIR_Done,
      // Label 44: @933
      GIM_Try, /*On fail goto*//*Label 45*/ GIMT_Encode4(952), // Rule ID 721 //
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SUB32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SUB32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 721,
        GIR_Done,
      // Label 45: @952
      GIM_Reject,
    // Label 42: @953
    GIM_Reject,
    // Label 33: @954
    GIM_Reject,
    // Label 2: @955
    GIM_Try, /*On fail goto*//*Label 46*/ GIMT_Encode4(991), // Rule ID 670 //
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // (mul:{ *:[i32] } i32:{ *:[i32] }:$dst, i32:{ *:[i32] }:$opd)  =>  (SMULd32d32:{ *:[i32] }:{ *:[i8] } ?:{ *:[i32] }:$dst, ?:{ *:[i32] }:$opd)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SMULd32d32),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 670,
      GIR_Done,
    // Label 46: @991
    GIM_Reject,
    // Label 3: @992
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 50*/ GIMT_Encode4(1246),
    /*GILLT_s8*//*Label 47*/ GIMT_Encode4(1015),
    /*GILLT_s16*//*Label 48*/ GIMT_Encode4(1092),
    /*GILLT_s32*//*Label 49*/ GIMT_Encode4(1169),
    // Label 47: @1015
    GIM_Try, /*On fail goto*//*Label 51*/ GIMT_Encode4(1091),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 52*/ GIMT_Encode4(1071), // Rule ID 761 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (AND8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 761,
        GIR_Done,
      // Label 52: @1071
      GIM_Try, /*On fail goto*//*Label 53*/ GIMT_Encode4(1090), // Rule ID 758 //
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (AND8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 758,
        GIR_Done,
      // Label 53: @1090
      GIM_Reject,
    // Label 51: @1091
    GIM_Reject,
    // Label 48: @1092
    GIM_Try, /*On fail goto*//*Label 54*/ GIMT_Encode4(1168),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 55*/ GIMT_Encode4(1148), // Rule ID 762 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (AND16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 762,
        GIR_Done,
      // Label 55: @1148
      GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(1167), // Rule ID 759 //
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (AND16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 759,
        GIR_Done,
      // Label 56: @1167
      GIM_Reject,
    // Label 54: @1168
    GIM_Reject,
    // Label 49: @1169
    GIM_Try, /*On fail goto*//*Label 57*/ GIMT_Encode4(1245),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 58*/ GIMT_Encode4(1225), // Rule ID 763 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (AND32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 763,
        GIR_Done,
      // Label 58: @1225
      GIM_Try, /*On fail goto*//*Label 59*/ GIMT_Encode4(1244), // Rule ID 760 //
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (AND32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::AND32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 760,
        GIR_Done,
      // Label 59: @1244
      GIM_Reject,
    // Label 57: @1245
    GIM_Reject,
    // Label 50: @1246
    GIM_Reject,
    // Label 4: @1247
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 63*/ GIMT_Encode4(1501),
    /*GILLT_s8*//*Label 60*/ GIMT_Encode4(1270),
    /*GILLT_s16*//*Label 61*/ GIMT_Encode4(1347),
    /*GILLT_s32*//*Label 62*/ GIMT_Encode4(1424),
    // Label 60: @1270
    GIM_Try, /*On fail goto*//*Label 64*/ GIMT_Encode4(1346),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(1326), // Rule ID 767 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (OR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 767,
        GIR_Done,
      // Label 65: @1326
      GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(1345), // Rule ID 764 //
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (OR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 764,
        GIR_Done,
      // Label 66: @1345
      GIM_Reject,
    // Label 64: @1346
    GIM_Reject,
    // Label 61: @1347
    GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(1423),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(1403), // Rule ID 768 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (OR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 768,
        GIR_Done,
      // Label 68: @1403
      GIM_Try, /*On fail goto*//*Label 69*/ GIMT_Encode4(1422), // Rule ID 765 //
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (OR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 765,
        GIR_Done,
      // Label 69: @1422
      GIM_Reject,
    // Label 67: @1423
    GIM_Reject,
    // Label 62: @1424
    GIM_Try, /*On fail goto*//*Label 70*/ GIMT_Encode4(1500),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 71*/ GIMT_Encode4(1480), // Rule ID 769 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (OR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 769,
        GIR_Done,
      // Label 71: @1480
      GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1499), // Rule ID 766 //
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (OR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::OR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 766,
        GIR_Done,
      // Label 72: @1499
      GIM_Reject,
    // Label 70: @1500
    GIM_Reject,
    // Label 63: @1501
    GIM_Reject,
    // Label 5: @1502
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 76*/ GIMT_Encode4(1756),
    /*GILLT_s8*//*Label 73*/ GIMT_Encode4(1525),
    /*GILLT_s16*//*Label 74*/ GIMT_Encode4(1602),
    /*GILLT_s32*//*Label 75*/ GIMT_Encode4(1679),
    // Label 73: @1525
    GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1601),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(1581), // Rule ID 773 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (XOR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 773,
        GIR_Done,
      // Label 78: @1581
      GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(1600), // Rule ID 770 //
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (XOR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 770,
        GIR_Done,
      // Label 79: @1600
      GIM_Reject,
    // Label 77: @1601
    GIM_Reject,
    // Label 74: @1602
    GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(1678),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1658), // Rule ID 774 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (XOR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 774,
        GIR_Done,
      // Label 81: @1658
      GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1677), // Rule ID 771 //
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (XOR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 771,
        GIR_Done,
      // Label 82: @1677
      GIM_Reject,
    // Label 80: @1678
    GIM_Reject,
    // Label 75: @1679
    GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1755),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1735), // Rule ID 775 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (XOR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 775,
        GIR_Done,
      // Label 84: @1735
      GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1754), // Rule ID 772 //
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (XOR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::XOR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 772,
        GIR_Done,
      // Label 85: @1754
      GIM_Reject,
    // Label 83: @1755
    GIM_Reject,
    // Label 76: @1756
    GIM_Reject,
    // Label 6: @1757
    GIM_Try, /*On fail goto*//*Label 86*/ GIMT_Encode4(1836),
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 89*/ GIMT_Encode4(1835),
      /*GILLT_s8*//*Label 87*/ GIMT_Encode4(1785),
      /*GILLT_s16*//*Label 88*/ GIMT_Encode4(1810),
      // Label 87: @1785
      GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1809), // Rule ID 620 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
        // (anyext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 620,
        GIR_Done,
      // Label 90: @1809
      GIM_Reject,
      // Label 88: @1810
      GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1834), // Rule ID 624 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
        // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 624,
        GIR_Done,
      // Label 91: @1834
      GIM_Reject,
      // Label 89: @1835
      GIM_Reject,
    // Label 86: @1836
    GIM_Reject,
    // Label 7: @1837
    GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1882), // Rule ID 628 //
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // (trunc:{ *:[i16] } i32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } MxXRD32:{ *:[i32] }:$src, MxSubRegIndex16Lo:{ *:[i32] })
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // src
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(M68k::XR16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(M68k::XR32RegClassID),
      GIR_EraseFromParent, /*InsnID*/0,
      // GIR_Coverage, 628,
      GIR_Done,
    // Label 92: @1882
    GIM_Reject,
    // Label 8: @1883
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 96*/ GIMT_Encode4(2112),
    /*GILLT_s8*//*Label 93*/ GIMT_Encode4(1906),
    /*GILLT_s16*//*Label 94*/ GIMT_Encode4(1936),
    /*GILLT_s32*//*Label 95*/ GIMT_Encode4(2024),
    // Label 93: @1906
    GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1935), // Rule ID 84 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i8] }):$src  =>  (MOV8di:{ *:[i8] }:{ *:[i8] } (imm:{ *:[i8] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOV8di),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      GIR_EraseFromParent, /*InsnID*/0,
      // GIR_Coverage, 84,
      GIR_Done,
    // Label 97: @1935
    GIM_Reject,
    // Label 94: @1936
    GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1965), // Rule ID 80 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOV16ri),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      GIR_EraseFromParent, /*InsnID*/0,
      // GIR_Coverage, 80,
      GIR_Done,
    // Label 98: @1965
    GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1994), // Rule ID 82 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::AR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ai:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOV16ai),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      GIR_EraseFromParent, /*InsnID*/0,
      // GIR_Coverage, 82,
      GIR_Done,
    // Label 99: @1994
    GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(2023), // Rule ID 85 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16di:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOV16di),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      GIR_EraseFromParent, /*InsnID*/0,
      // GIR_Coverage, 85,
      GIR_Done,
    // Label 100: @2023
    GIM_Reject,
    // Label 95: @2024
    GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2053), // Rule ID 81 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOV32ri),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      GIR_EraseFromParent, /*InsnID*/0,
      // GIR_Coverage, 81,
      GIR_Done,
    // Label 101: @2053
    GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2082), // Rule ID 83 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::AR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ai:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOV32ai),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      GIR_EraseFromParent, /*InsnID*/0,
      // GIR_Coverage, 83,
      GIR_Done,
    // Label 102: @2082
    GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2111), // Rule ID 86 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32di:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOV32di),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      GIR_EraseFromParent, /*InsnID*/0,
      // GIR_Coverage, 86,
      GIR_Done,
    // Label 103: @2111
    GIM_Reject,
    // Label 96: @2112
    GIM_Reject,
    // Label 9: @2113
    GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2192),
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 107*/ GIMT_Encode4(2191),
      /*GILLT_s8*//*Label 105*/ GIMT_Encode4(2141),
      /*GILLT_s16*//*Label 106*/ GIMT_Encode4(2166),
      // Label 105: @2141
      GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2165), // Rule ID 591 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
        // (sext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d8),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 591,
        GIR_Done,
      // Label 108: @2165
      GIM_Reject,
      // Label 106: @2166
      GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(2190), // Rule ID 596 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
        // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVSXd32d16),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 596,
        GIR_Done,
      // Label 109: @2190
      GIM_Reject,
      // Label 107: @2191
      GIM_Reject,
    // Label 104: @2192
    GIM_Reject,
    // Label 10: @2193
    GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(2272),
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 113*/ GIMT_Encode4(2271),
      /*GILLT_s8*//*Label 111*/ GIMT_Encode4(2221),
      /*GILLT_s16*//*Label 112*/ GIMT_Encode4(2246),
      // Label 111: @2221
      GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(2245), // Rule ID 606 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
        // (zext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d8),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 606,
        GIR_Done,
      // Label 114: @2245
      GIM_Reject,
      // Label 112: @2246
      GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(2270), // Rule ID 611 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::XR32RegClassID),
        // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::MOVZXd32d16),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 611,
        GIR_Done,
      // Label 115: @2270
      GIM_Reject,
      // Label 113: @2271
      GIM_Reject,
    // Label 110: @2272
    GIM_Reject,
    // Label 11: @2273
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 119*/ GIMT_Encode4(2539),
    /*GILLT_s8*//*Label 116*/ GIMT_Encode4(2296),
    /*GILLT_s16*//*Label 117*/ GIMT_Encode4(2377),
    /*GILLT_s32*//*Label 118*/ GIMT_Encode4(2458),
    // Label 116: @2296
    GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2376),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2356), // Rule ID 343 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (SHL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 343,
        GIR_Done,
      // Label 121: @2356
      GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2375), // Rule ID 340 //
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SHL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 340,
        GIR_Done,
      // Label 122: @2375
      GIM_Reject,
    // Label 120: @2376
    GIM_Reject,
    // Label 117: @2377
    GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2457),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(2437), // Rule ID 344 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (SHL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 344,
        GIR_Done,
      // Label 124: @2437
      GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(2456), // Rule ID 341 //
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SHL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 341,
        GIR_Done,
      // Label 125: @2456
      GIM_Reject,
    // Label 123: @2457
    GIM_Reject,
    // Label 118: @2458
    GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(2538),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(2518), // Rule ID 345 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (SHL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 345,
        GIR_Done,
      // Label 127: @2518
      GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(2537), // Rule ID 342 //
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SHL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::SHL32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 342,
        GIR_Done,
      // Label 128: @2537
      GIM_Reject,
    // Label 126: @2538
    GIM_Reject,
    // Label 119: @2539
    GIM_Reject,
    // Label 12: @2540
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 132*/ GIMT_Encode4(2806),
    /*GILLT_s8*//*Label 129*/ GIMT_Encode4(2563),
    /*GILLT_s16*//*Label 130*/ GIMT_Encode4(2644),
    /*GILLT_s32*//*Label 131*/ GIMT_Encode4(2725),
    // Label 129: @2563
    GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2643),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2623), // Rule ID 349 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (LSR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 349,
        GIR_Done,
      // Label 134: @2623
      GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2642), // Rule ID 346 //
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (LSR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 346,
        GIR_Done,
      // Label 135: @2642
      GIM_Reject,
    // Label 133: @2643
    GIM_Reject,
    // Label 130: @2644
    GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2724),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2704), // Rule ID 350 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (LSR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 350,
        GIR_Done,
      // Label 137: @2704
      GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2723), // Rule ID 347 //
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (LSR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 347,
        GIR_Done,
      // Label 138: @2723
      GIM_Reject,
    // Label 136: @2724
    GIM_Reject,
    // Label 131: @2725
    GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2805),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2785), // Rule ID 351 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (LSR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 351,
        GIR_Done,
      // Label 140: @2785
      GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2804), // Rule ID 348 //
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (LSR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::LSR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 348,
        GIR_Done,
      // Label 141: @2804
      GIM_Reject,
    // Label 139: @2805
    GIM_Reject,
    // Label 132: @2806
    GIM_Reject,
    // Label 13: @2807
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 145*/ GIMT_Encode4(3073),
    /*GILLT_s8*//*Label 142*/ GIMT_Encode4(2830),
    /*GILLT_s16*//*Label 143*/ GIMT_Encode4(2911),
    /*GILLT_s32*//*Label 144*/ GIMT_Encode4(2992),
    // Label 142: @2830
    GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2910),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2890), // Rule ID 355 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ASR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 355,
        GIR_Done,
      // Label 147: @2890
      GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2909), // Rule ID 352 //
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ASR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 352,
        GIR_Done,
      // Label 148: @2909
      GIM_Reject,
    // Label 146: @2910
    GIM_Reject,
    // Label 143: @2911
    GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2991),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2971), // Rule ID 356 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ASR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 356,
        GIR_Done,
      // Label 150: @2971
      GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2990), // Rule ID 353 //
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ASR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 353,
        GIR_Done,
      // Label 151: @2990
      GIM_Reject,
    // Label 149: @2991
    GIM_Reject,
    // Label 144: @2992
    GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(3072),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(3052), // Rule ID 357 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ASR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 357,
        GIR_Done,
      // Label 153: @3052
      GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(3071), // Rule ID 354 //
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ASR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ASR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 354,
        GIR_Done,
      // Label 154: @3071
      GIM_Reject,
    // Label 152: @3072
    GIM_Reject,
    // Label 145: @3073
    GIM_Reject,
    // Label 14: @3074
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 158*/ GIMT_Encode4(3340),
    /*GILLT_s8*//*Label 155*/ GIMT_Encode4(3097),
    /*GILLT_s16*//*Label 156*/ GIMT_Encode4(3178),
    /*GILLT_s32*//*Label 157*/ GIMT_Encode4(3259),
    // Label 155: @3097
    GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3177),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3157), // Rule ID 367 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 367,
        GIR_Done,
      // Label 160: @3157
      GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3176), // Rule ID 364 //
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 364,
        GIR_Done,
      // Label 161: @3176
      GIM_Reject,
    // Label 159: @3177
    GIM_Reject,
    // Label 156: @3178
    GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3258),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3238), // Rule ID 368 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 368,
        GIR_Done,
      // Label 163: @3238
      GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3257), // Rule ID 365 //
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 365,
        GIR_Done,
      // Label 164: @3257
      GIM_Reject,
    // Label 162: @3258
    GIM_Reject,
    // Label 157: @3259
    GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(3339),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(3319), // Rule ID 369 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 369,
        GIR_Done,
      // Label 166: @3319
      GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(3338), // Rule ID 366 //
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROR32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 366,
        GIR_Done,
      // Label 167: @3338
      GIM_Reject,
    // Label 165: @3339
    GIM_Reject,
    // Label 158: @3340
    GIM_Reject,
    // Label 15: @3341
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 171*/ GIMT_Encode4(3607),
    /*GILLT_s8*//*Label 168*/ GIMT_Encode4(3364),
    /*GILLT_s16*//*Label 169*/ GIMT_Encode4(3445),
    /*GILLT_s32*//*Label 170*/ GIMT_Encode4(3526),
    // Label 168: @3364
    GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3444),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR8RegClassID),
      GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3424), // Rule ID 361 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm8_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL8di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 361,
        GIR_Done,
      // Label 173: @3424
      GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3443), // Rule ID 358 //
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL8dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 358,
        GIR_Done,
      // Label 174: @3443
      GIM_Reject,
    // Label 172: @3444
    GIM_Reject,
    // Label 169: @3445
    GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3525),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR16RegClassID),
      GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(3505), // Rule ID 362 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm16_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL16di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 362,
        GIR_Done,
      // Label 176: @3505
      GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(3524), // Rule ID 359 //
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL16dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 359,
        GIR_Done,
      // Label 177: @3524
      GIM_Reject,
    // Label 175: @3525
    GIM_Reject,
    // Label 170: @3526
    GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(3606),
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/GIMT_Encode2(M68k::DR32RegClassID),
      GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(3586), // Rule ID 363 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Mximm32_1to8),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL32di),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // DstI[dst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for M68k::CCR*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        GIR_EraseFromParent, /*InsnID*/0,
        // GIR_Coverage, 363,
        GIR_Done,
      // Label 179: @3586
      GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(3605), // Rule ID 360 //
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(M68k::ROL32dd),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(M68k::CCR), GIMT_Encode2(RegState::Dead),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 360,
        GIR_Done,
      // Label 180: @3605
      GIM_Reject,
    // Label 178: @3606
    GIM_Reject,
    // Label 171: @3607
    GIM_Reject,
    // Label 16: @3608
    GIM_Reject,
    }; // Size: 3609 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
