/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * M68k Disassembler                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTable80[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 0, 48, 9, 0, // Skip to: 2360
/* 8 */       MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11 */      MCD::OPC_FilterValue, 0, 65, 0, 0, // Skip to: 81
/* 16 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 19 */      MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 35
/* 24 */      MCD::OPC_CheckField, 24, 8, 0, 194, 55, 0, // Skip to: 14305
/* 31 */      MCD::OPC_Decode, 240, 3, 0, // Opcode: BTST32di
/* 35 */      MCD::OPC_FilterValue, 5, 18, 0, 0, // Skip to: 58
/* 40 */      MCD::OPC_CheckField, 24, 8, 0, 178, 55, 0, // Skip to: 14305
/* 47 */      MCD::OPC_CheckField, 3, 1, 0, 171, 55, 0, // Skip to: 14305
/* 54 */      MCD::OPC_Decode, 133, 10, 1, // Opcode: XOR8di
/* 58 */      MCD::OPC_FilterValue, 6, 162, 55, 0, // Skip to: 14305
/* 63 */      MCD::OPC_CheckField, 24, 8, 0, 155, 55, 0, // Skip to: 14305
/* 70 */      MCD::OPC_CheckField, 3, 1, 0, 148, 55, 0, // Skip to: 14305
/* 77 */      MCD::OPC_Decode, 191, 4, 2, // Opcode: CMP8di
/* 81 */      MCD::OPC_FilterValue, 1, 158, 0, 0, // Skip to: 244
/* 86 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 89 */      MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 112
/* 94 */      MCD::OPC_CheckField, 24, 8, 0, 124, 55, 0, // Skip to: 14305
/* 101 */     MCD::OPC_CheckField, 3, 1, 0, 117, 55, 0, // Skip to: 14305
/* 108 */     MCD::OPC_Decode, 246, 8, 3, // Opcode: OR8ji
/* 112 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 135
/* 117 */     MCD::OPC_CheckField, 24, 8, 0, 101, 55, 0, // Skip to: 14305
/* 124 */     MCD::OPC_CheckField, 3, 1, 0, 94, 55, 0, // Skip to: 14305
/* 131 */     MCD::OPC_Decode, 188, 3, 3, // Opcode: AND8ji
/* 135 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 158
/* 140 */     MCD::OPC_CheckField, 24, 8, 0, 78, 55, 0, // Skip to: 14305
/* 147 */     MCD::OPC_CheckField, 3, 1, 0, 71, 55, 0, // Skip to: 14305
/* 154 */     MCD::OPC_Decode, 241, 9, 3, // Opcode: SUB8ji
/* 158 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 181
/* 163 */     MCD::OPC_CheckField, 24, 8, 0, 55, 55, 0, // Skip to: 14305
/* 170 */     MCD::OPC_CheckField, 3, 1, 0, 48, 55, 0, // Skip to: 14305
/* 177 */     MCD::OPC_Decode, 144, 3, 3, // Opcode: ADD8ji
/* 181 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 221
/* 186 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 189 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 205
/* 194 */     MCD::OPC_CheckField, 24, 8, 0, 24, 55, 0, // Skip to: 14305
/* 201 */     MCD::OPC_Decode, 246, 3, 3, // Opcode: BTST8ji
/* 205 */     MCD::OPC_FilterValue, 1, 15, 55, 0, // Skip to: 14305
/* 210 */     MCD::OPC_CheckField, 24, 8, 0, 8, 55, 0, // Skip to: 14305
/* 217 */     MCD::OPC_Decode, 250, 3, 3, // Opcode: BTST8oi
/* 221 */     MCD::OPC_FilterValue, 6, 255, 54, 0, // Skip to: 14305
/* 226 */     MCD::OPC_CheckField, 24, 8, 0, 248, 54, 0, // Skip to: 14305
/* 233 */     MCD::OPC_CheckField, 3, 1, 0, 241, 54, 0, // Skip to: 14305
/* 240 */     MCD::OPC_Decode, 197, 4, 4, // Opcode: CMP8ji
/* 244 */     MCD::OPC_FilterValue, 2, 158, 0, 0, // Skip to: 407
/* 249 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 252 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 275
/* 257 */     MCD::OPC_CheckField, 24, 8, 0, 217, 54, 0, // Skip to: 14305
/* 264 */     MCD::OPC_CheckField, 3, 1, 1, 210, 54, 0, // Skip to: 14305
/* 271 */     MCD::OPC_Decode, 248, 8, 5, // Opcode: OR8pi
/* 275 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 298
/* 280 */     MCD::OPC_CheckField, 24, 8, 0, 194, 54, 0, // Skip to: 14305
/* 287 */     MCD::OPC_CheckField, 3, 1, 1, 187, 54, 0, // Skip to: 14305
/* 294 */     MCD::OPC_Decode, 190, 3, 5, // Opcode: AND8pi
/* 298 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 321
/* 303 */     MCD::OPC_CheckField, 24, 8, 0, 171, 54, 0, // Skip to: 14305
/* 310 */     MCD::OPC_CheckField, 3, 1, 1, 164, 54, 0, // Skip to: 14305
/* 317 */     MCD::OPC_Decode, 243, 9, 5, // Opcode: SUB8pi
/* 321 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 344
/* 326 */     MCD::OPC_CheckField, 24, 8, 0, 148, 54, 0, // Skip to: 14305
/* 333 */     MCD::OPC_CheckField, 3, 1, 1, 141, 54, 0, // Skip to: 14305
/* 340 */     MCD::OPC_Decode, 146, 3, 5, // Opcode: ADD8pi
/* 344 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 384
/* 349 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 352 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 368
/* 357 */     MCD::OPC_CheckField, 24, 8, 0, 117, 54, 0, // Skip to: 14305
/* 364 */     MCD::OPC_Decode, 242, 3, 3, // Opcode: BTST8ei
/* 368 */     MCD::OPC_FilterValue, 1, 108, 54, 0, // Skip to: 14305
/* 373 */     MCD::OPC_CheckField, 24, 8, 0, 101, 54, 0, // Skip to: 14305
/* 380 */     MCD::OPC_Decode, 252, 3, 5, // Opcode: BTST8pi
/* 384 */     MCD::OPC_FilterValue, 6, 92, 54, 0, // Skip to: 14305
/* 389 */     MCD::OPC_CheckField, 24, 8, 0, 85, 54, 0, // Skip to: 14305
/* 396 */     MCD::OPC_CheckField, 3, 1, 1, 78, 54, 0, // Skip to: 14305
/* 403 */     MCD::OPC_Decode, 199, 4, 6, // Opcode: CMP8pi
/* 407 */     MCD::OPC_FilterValue, 3, 39, 1, 0, // Skip to: 707
/* 412 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 415 */     MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 445
/* 420 */     MCD::OPC_CheckField, 40, 4, 8, 54, 54, 0, // Skip to: 14305
/* 427 */     MCD::OPC_CheckField, 24, 8, 0, 47, 54, 0, // Skip to: 14305
/* 434 */     MCD::OPC_CheckField, 3, 1, 0, 40, 54, 0, // Skip to: 14305
/* 441 */     MCD::OPC_Decode, 244, 8, 7, // Opcode: OR8fi
/* 445 */     MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 475
/* 450 */     MCD::OPC_CheckField, 40, 4, 8, 24, 54, 0, // Skip to: 14305
/* 457 */     MCD::OPC_CheckField, 24, 8, 0, 17, 54, 0, // Skip to: 14305
/* 464 */     MCD::OPC_CheckField, 3, 1, 0, 10, 54, 0, // Skip to: 14305
/* 471 */     MCD::OPC_Decode, 186, 3, 7, // Opcode: AND8fi
/* 475 */     MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 505
/* 480 */     MCD::OPC_CheckField, 40, 4, 8, 250, 53, 0, // Skip to: 14305
/* 487 */     MCD::OPC_CheckField, 24, 8, 0, 243, 53, 0, // Skip to: 14305
/* 494 */     MCD::OPC_CheckField, 3, 1, 0, 236, 53, 0, // Skip to: 14305
/* 501 */     MCD::OPC_Decode, 239, 9, 7, // Opcode: SUB8fi
/* 505 */     MCD::OPC_FilterValue, 3, 25, 0, 0, // Skip to: 535
/* 510 */     MCD::OPC_CheckField, 40, 4, 8, 220, 53, 0, // Skip to: 14305
/* 517 */     MCD::OPC_CheckField, 24, 8, 0, 213, 53, 0, // Skip to: 14305
/* 524 */     MCD::OPC_CheckField, 3, 1, 0, 206, 53, 0, // Skip to: 14305
/* 531 */     MCD::OPC_Decode, 142, 3, 7, // Opcode: ADD8fi
/* 535 */     MCD::OPC_FilterValue, 4, 73, 0, 0, // Skip to: 613
/* 540 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 543 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 566
/* 548 */     MCD::OPC_CheckField, 40, 4, 8, 182, 53, 0, // Skip to: 14305
/* 555 */     MCD::OPC_CheckField, 24, 8, 0, 175, 53, 0, // Skip to: 14305
/* 562 */     MCD::OPC_Decode, 244, 3, 7, // Opcode: BTST8fi
/* 566 */     MCD::OPC_FilterValue, 1, 166, 53, 0, // Skip to: 14305
/* 571 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 574 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 590
/* 579 */     MCD::OPC_CheckField, 24, 8, 0, 151, 53, 0, // Skip to: 14305
/* 586 */     MCD::OPC_Decode, 254, 3, 8, // Opcode: BTST8qi
/* 590 */     MCD::OPC_FilterValue, 3, 142, 53, 0, // Skip to: 14305
/* 595 */     MCD::OPC_CheckField, 40, 4, 8, 135, 53, 0, // Skip to: 14305
/* 602 */     MCD::OPC_CheckField, 24, 8, 0, 128, 53, 0, // Skip to: 14305
/* 609 */     MCD::OPC_Decode, 248, 3, 9, // Opcode: BTST8ki
/* 613 */     MCD::OPC_FilterValue, 6, 119, 53, 0, // Skip to: 14305
/* 618 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 621 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 644
/* 626 */     MCD::OPC_CheckField, 40, 4, 8, 104, 53, 0, // Skip to: 14305
/* 633 */     MCD::OPC_CheckField, 24, 8, 0, 97, 53, 0, // Skip to: 14305
/* 640 */     MCD::OPC_Decode, 196, 4, 10, // Opcode: CMP8fi
/* 644 */     MCD::OPC_FilterValue, 1, 88, 53, 0, // Skip to: 14305
/* 649 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 652 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 668
/* 657 */     MCD::OPC_CheckField, 24, 8, 0, 73, 53, 0, // Skip to: 14305
/* 664 */     MCD::OPC_Decode, 188, 4, 11, // Opcode: CMP8bi
/* 668 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 684
/* 673 */     MCD::OPC_CheckField, 24, 8, 0, 57, 53, 0, // Skip to: 14305
/* 680 */     MCD::OPC_Decode, 200, 4, 12, // Opcode: CMP8qi
/* 684 */     MCD::OPC_FilterValue, 3, 48, 53, 0, // Skip to: 14305
/* 689 */     MCD::OPC_CheckField, 40, 4, 8, 41, 53, 0, // Skip to: 14305
/* 696 */     MCD::OPC_CheckField, 24, 8, 0, 34, 53, 0, // Skip to: 14305
/* 703 */     MCD::OPC_Decode, 198, 4, 13, // Opcode: CMP8ki
/* 707 */     MCD::OPC_FilterValue, 4, 51, 0, 0, // Skip to: 763
/* 712 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 715 */     MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 731
/* 720 */     MCD::OPC_CheckField, 24, 8, 0, 10, 53, 0, // Skip to: 14305
/* 727 */     MCD::OPC_Decode, 198, 3, 0, // Opcode: BCHG32di
/* 731 */     MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 747
/* 736 */     MCD::OPC_CheckField, 3, 1, 0, 250, 52, 0, // Skip to: 14305
/* 743 */     MCD::OPC_Decode, 129, 10, 14, // Opcode: XOR16di
/* 747 */     MCD::OPC_FilterValue, 6, 241, 52, 0, // Skip to: 14305
/* 752 */     MCD::OPC_CheckField, 3, 1, 0, 234, 52, 0, // Skip to: 14305
/* 759 */     MCD::OPC_Decode, 164, 4, 15, // Opcode: CMP16di
/* 763 */     MCD::OPC_FilterValue, 5, 123, 0, 0, // Skip to: 891
/* 768 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 771 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 787
/* 776 */     MCD::OPC_CheckField, 3, 1, 0, 210, 52, 0, // Skip to: 14305
/* 783 */     MCD::OPC_Decode, 219, 8, 16, // Opcode: OR16ji
/* 787 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 803
/* 792 */     MCD::OPC_CheckField, 3, 1, 0, 194, 52, 0, // Skip to: 14305
/* 799 */     MCD::OPC_Decode, 161, 3, 16, // Opcode: AND16ji
/* 803 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 819
/* 808 */     MCD::OPC_CheckField, 3, 1, 0, 178, 52, 0, // Skip to: 14305
/* 815 */     MCD::OPC_Decode, 206, 9, 16, // Opcode: SUB16ji
/* 819 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 835
/* 824 */     MCD::OPC_CheckField, 3, 1, 0, 162, 52, 0, // Skip to: 14305
/* 831 */     MCD::OPC_Decode, 237, 2, 16, // Opcode: ADD16ji
/* 835 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 875
/* 840 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 843 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 859
/* 848 */     MCD::OPC_CheckField, 24, 8, 0, 138, 52, 0, // Skip to: 14305
/* 855 */     MCD::OPC_Decode, 204, 3, 3, // Opcode: BCHG8ji
/* 859 */     MCD::OPC_FilterValue, 1, 129, 52, 0, // Skip to: 14305
/* 864 */     MCD::OPC_CheckField, 24, 8, 0, 122, 52, 0, // Skip to: 14305
/* 871 */     MCD::OPC_Decode, 206, 3, 3, // Opcode: BCHG8oi
/* 875 */     MCD::OPC_FilterValue, 6, 113, 52, 0, // Skip to: 14305
/* 880 */     MCD::OPC_CheckField, 3, 1, 0, 106, 52, 0, // Skip to: 14305
/* 887 */     MCD::OPC_Decode, 171, 4, 17, // Opcode: CMP16ji
/* 891 */     MCD::OPC_FilterValue, 6, 123, 0, 0, // Skip to: 1019
/* 896 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 899 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 915
/* 904 */     MCD::OPC_CheckField, 3, 1, 1, 82, 52, 0, // Skip to: 14305
/* 911 */     MCD::OPC_Decode, 221, 8, 18, // Opcode: OR16pi
/* 915 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 931
/* 920 */     MCD::OPC_CheckField, 3, 1, 1, 66, 52, 0, // Skip to: 14305
/* 927 */     MCD::OPC_Decode, 163, 3, 18, // Opcode: AND16pi
/* 931 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 947
/* 936 */     MCD::OPC_CheckField, 3, 1, 1, 50, 52, 0, // Skip to: 14305
/* 943 */     MCD::OPC_Decode, 208, 9, 18, // Opcode: SUB16pi
/* 947 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 963
/* 952 */     MCD::OPC_CheckField, 3, 1, 1, 34, 52, 0, // Skip to: 14305
/* 959 */     MCD::OPC_Decode, 239, 2, 18, // Opcode: ADD16pi
/* 963 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1003
/* 968 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 971 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 987
/* 976 */     MCD::OPC_CheckField, 24, 8, 0, 10, 52, 0, // Skip to: 14305
/* 983 */     MCD::OPC_Decode, 200, 3, 3, // Opcode: BCHG8ei
/* 987 */     MCD::OPC_FilterValue, 1, 1, 52, 0, // Skip to: 14305
/* 992 */     MCD::OPC_CheckField, 24, 8, 0, 250, 51, 0, // Skip to: 14305
/* 999 */     MCD::OPC_Decode, 208, 3, 5, // Opcode: BCHG8pi
/* 1003 */    MCD::OPC_FilterValue, 6, 241, 51, 0, // Skip to: 14305
/* 1008 */    MCD::OPC_CheckField, 3, 1, 1, 234, 51, 0, // Skip to: 14305
/* 1015 */    MCD::OPC_Decode, 173, 4, 19, // Opcode: CMP16pi
/* 1019 */    MCD::OPC_FilterValue, 7, 191, 0, 0, // Skip to: 1215
/* 1024 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1027 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1050
/* 1032 */    MCD::OPC_CheckField, 40, 4, 8, 210, 51, 0, // Skip to: 14305
/* 1039 */    MCD::OPC_CheckField, 3, 1, 0, 203, 51, 0, // Skip to: 14305
/* 1046 */    MCD::OPC_Decode, 217, 8, 20, // Opcode: OR16fi
/* 1050 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 1073
/* 1055 */    MCD::OPC_CheckField, 40, 4, 8, 187, 51, 0, // Skip to: 14305
/* 1062 */    MCD::OPC_CheckField, 3, 1, 0, 180, 51, 0, // Skip to: 14305
/* 1069 */    MCD::OPC_Decode, 159, 3, 20, // Opcode: AND16fi
/* 1073 */    MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1096
/* 1078 */    MCD::OPC_CheckField, 40, 4, 8, 164, 51, 0, // Skip to: 14305
/* 1085 */    MCD::OPC_CheckField, 3, 1, 0, 157, 51, 0, // Skip to: 14305
/* 1092 */    MCD::OPC_Decode, 204, 9, 20, // Opcode: SUB16fi
/* 1096 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1119
/* 1101 */    MCD::OPC_CheckField, 40, 4, 8, 141, 51, 0, // Skip to: 14305
/* 1108 */    MCD::OPC_CheckField, 3, 1, 0, 134, 51, 0, // Skip to: 14305
/* 1115 */    MCD::OPC_Decode, 235, 2, 20, // Opcode: ADD16fi
/* 1119 */    MCD::OPC_FilterValue, 4, 25, 0, 0, // Skip to: 1149
/* 1124 */    MCD::OPC_CheckField, 40, 4, 8, 118, 51, 0, // Skip to: 14305
/* 1131 */    MCD::OPC_CheckField, 24, 8, 0, 111, 51, 0, // Skip to: 14305
/* 1138 */    MCD::OPC_CheckField, 3, 1, 0, 104, 51, 0, // Skip to: 14305
/* 1145 */    MCD::OPC_Decode, 202, 3, 7, // Opcode: BCHG8fi
/* 1149 */    MCD::OPC_FilterValue, 6, 95, 51, 0, // Skip to: 14305
/* 1154 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1157 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1173
/* 1162 */    MCD::OPC_CheckField, 40, 4, 8, 80, 51, 0, // Skip to: 14305
/* 1169 */    MCD::OPC_Decode, 170, 4, 21, // Opcode: CMP16fi
/* 1173 */    MCD::OPC_FilterValue, 1, 71, 51, 0, // Skip to: 14305
/* 1178 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1181 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1190
/* 1186 */    MCD::OPC_Decode, 162, 4, 22, // Opcode: CMP16bi
/* 1190 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1199
/* 1195 */    MCD::OPC_Decode, 174, 4, 23, // Opcode: CMP16qi
/* 1199 */    MCD::OPC_FilterValue, 3, 45, 51, 0, // Skip to: 14305
/* 1204 */    MCD::OPC_CheckField, 40, 4, 8, 38, 51, 0, // Skip to: 14305
/* 1211 */    MCD::OPC_Decode, 172, 4, 24, // Opcode: CMP16ki
/* 1215 */    MCD::OPC_FilterValue, 8, 51, 0, 0, // Skip to: 1271
/* 1220 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1223 */    MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 1239
/* 1228 */    MCD::OPC_CheckField, 24, 8, 0, 14, 51, 0, // Skip to: 14305
/* 1235 */    MCD::OPC_Decode, 210, 3, 0, // Opcode: BCLR32di
/* 1239 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 1255
/* 1244 */    MCD::OPC_CheckField, 3, 1, 0, 254, 50, 0, // Skip to: 14305
/* 1251 */    MCD::OPC_Decode, 131, 10, 25, // Opcode: XOR32di
/* 1255 */    MCD::OPC_FilterValue, 6, 245, 50, 0, // Skip to: 14305
/* 1260 */    MCD::OPC_CheckField, 3, 1, 0, 238, 50, 0, // Skip to: 14305
/* 1267 */    MCD::OPC_Decode, 177, 4, 26, // Opcode: CMP32di
/* 1271 */    MCD::OPC_FilterValue, 9, 123, 0, 0, // Skip to: 1399
/* 1276 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1279 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1295
/* 1284 */    MCD::OPC_CheckField, 3, 1, 0, 214, 50, 0, // Skip to: 14305
/* 1291 */    MCD::OPC_Decode, 233, 8, 27, // Opcode: OR32ji
/* 1295 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1311
/* 1300 */    MCD::OPC_CheckField, 3, 1, 0, 198, 50, 0, // Skip to: 14305
/* 1307 */    MCD::OPC_Decode, 175, 3, 27, // Opcode: AND32ji
/* 1311 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1327
/* 1316 */    MCD::OPC_CheckField, 3, 1, 0, 182, 50, 0, // Skip to: 14305
/* 1323 */    MCD::OPC_Decode, 228, 9, 27, // Opcode: SUB32ji
/* 1327 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1343
/* 1332 */    MCD::OPC_CheckField, 3, 1, 0, 166, 50, 0, // Skip to: 14305
/* 1339 */    MCD::OPC_Decode, 131, 3, 27, // Opcode: ADD32ji
/* 1343 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1383
/* 1348 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1351 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1367
/* 1356 */    MCD::OPC_CheckField, 24, 8, 0, 142, 50, 0, // Skip to: 14305
/* 1363 */    MCD::OPC_Decode, 216, 3, 3, // Opcode: BCLR8ji
/* 1367 */    MCD::OPC_FilterValue, 1, 133, 50, 0, // Skip to: 14305
/* 1372 */    MCD::OPC_CheckField, 24, 8, 0, 126, 50, 0, // Skip to: 14305
/* 1379 */    MCD::OPC_Decode, 218, 3, 3, // Opcode: BCLR8oi
/* 1383 */    MCD::OPC_FilterValue, 6, 117, 50, 0, // Skip to: 14305
/* 1388 */    MCD::OPC_CheckField, 3, 1, 0, 110, 50, 0, // Skip to: 14305
/* 1395 */    MCD::OPC_Decode, 184, 4, 28, // Opcode: CMP32ji
/* 1399 */    MCD::OPC_FilterValue, 10, 123, 0, 0, // Skip to: 1527
/* 1404 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1407 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1423
/* 1412 */    MCD::OPC_CheckField, 3, 1, 1, 86, 50, 0, // Skip to: 14305
/* 1419 */    MCD::OPC_Decode, 235, 8, 29, // Opcode: OR32pi
/* 1423 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1439
/* 1428 */    MCD::OPC_CheckField, 3, 1, 1, 70, 50, 0, // Skip to: 14305
/* 1435 */    MCD::OPC_Decode, 177, 3, 29, // Opcode: AND32pi
/* 1439 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1455
/* 1444 */    MCD::OPC_CheckField, 3, 1, 1, 54, 50, 0, // Skip to: 14305
/* 1451 */    MCD::OPC_Decode, 230, 9, 29, // Opcode: SUB32pi
/* 1455 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1471
/* 1460 */    MCD::OPC_CheckField, 3, 1, 1, 38, 50, 0, // Skip to: 14305
/* 1467 */    MCD::OPC_Decode, 133, 3, 29, // Opcode: ADD32pi
/* 1471 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1511
/* 1476 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1479 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1495
/* 1484 */    MCD::OPC_CheckField, 24, 8, 0, 14, 50, 0, // Skip to: 14305
/* 1491 */    MCD::OPC_Decode, 212, 3, 3, // Opcode: BCLR8ei
/* 1495 */    MCD::OPC_FilterValue, 1, 5, 50, 0, // Skip to: 14305
/* 1500 */    MCD::OPC_CheckField, 24, 8, 0, 254, 49, 0, // Skip to: 14305
/* 1507 */    MCD::OPC_Decode, 220, 3, 5, // Opcode: BCLR8pi
/* 1511 */    MCD::OPC_FilterValue, 6, 245, 49, 0, // Skip to: 14305
/* 1516 */    MCD::OPC_CheckField, 3, 1, 1, 238, 49, 0, // Skip to: 14305
/* 1523 */    MCD::OPC_Decode, 186, 4, 30, // Opcode: CMP32pi
/* 1527 */    MCD::OPC_FilterValue, 11, 191, 0, 0, // Skip to: 1723
/* 1532 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1535 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1558
/* 1540 */    MCD::OPC_CheckField, 56, 4, 8, 214, 49, 0, // Skip to: 14305
/* 1547 */    MCD::OPC_CheckField, 3, 1, 0, 207, 49, 0, // Skip to: 14305
/* 1554 */    MCD::OPC_Decode, 231, 8, 31, // Opcode: OR32fi
/* 1558 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 1581
/* 1563 */    MCD::OPC_CheckField, 56, 4, 8, 191, 49, 0, // Skip to: 14305
/* 1570 */    MCD::OPC_CheckField, 3, 1, 0, 184, 49, 0, // Skip to: 14305
/* 1577 */    MCD::OPC_Decode, 173, 3, 31, // Opcode: AND32fi
/* 1581 */    MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1604
/* 1586 */    MCD::OPC_CheckField, 56, 4, 8, 168, 49, 0, // Skip to: 14305
/* 1593 */    MCD::OPC_CheckField, 3, 1, 0, 161, 49, 0, // Skip to: 14305
/* 1600 */    MCD::OPC_Decode, 226, 9, 31, // Opcode: SUB32fi
/* 1604 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1627
/* 1609 */    MCD::OPC_CheckField, 56, 4, 8, 145, 49, 0, // Skip to: 14305
/* 1616 */    MCD::OPC_CheckField, 3, 1, 0, 138, 49, 0, // Skip to: 14305
/* 1623 */    MCD::OPC_Decode, 129, 3, 31, // Opcode: ADD32fi
/* 1627 */    MCD::OPC_FilterValue, 4, 25, 0, 0, // Skip to: 1657
/* 1632 */    MCD::OPC_CheckField, 40, 4, 8, 122, 49, 0, // Skip to: 14305
/* 1639 */    MCD::OPC_CheckField, 24, 8, 0, 115, 49, 0, // Skip to: 14305
/* 1646 */    MCD::OPC_CheckField, 3, 1, 0, 108, 49, 0, // Skip to: 14305
/* 1653 */    MCD::OPC_Decode, 214, 3, 7, // Opcode: BCLR8fi
/* 1657 */    MCD::OPC_FilterValue, 6, 99, 49, 0, // Skip to: 14305
/* 1662 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1665 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1681
/* 1670 */    MCD::OPC_CheckField, 56, 4, 8, 84, 49, 0, // Skip to: 14305
/* 1677 */    MCD::OPC_Decode, 183, 4, 32, // Opcode: CMP32fi
/* 1681 */    MCD::OPC_FilterValue, 1, 75, 49, 0, // Skip to: 14305
/* 1686 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1689 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1698
/* 1694 */    MCD::OPC_Decode, 175, 4, 33, // Opcode: CMP32bi
/* 1698 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1707
/* 1703 */    MCD::OPC_Decode, 187, 4, 34, // Opcode: CMP32qi
/* 1707 */    MCD::OPC_FilterValue, 3, 49, 49, 0, // Skip to: 14305
/* 1712 */    MCD::OPC_CheckField, 56, 4, 8, 42, 49, 0, // Skip to: 14305
/* 1719 */    MCD::OPC_Decode, 185, 4, 35, // Opcode: CMP32ki
/* 1723 */    MCD::OPC_FilterValue, 12, 18, 0, 0, // Skip to: 1746
/* 1728 */    MCD::OPC_CheckField, 24, 8, 0, 26, 49, 0, // Skip to: 14305
/* 1735 */    MCD::OPC_CheckField, 9, 3, 4, 19, 49, 0, // Skip to: 14305
/* 1742 */    MCD::OPC_Decode, 225, 3, 0, // Opcode: BSET32di
/* 1746 */    MCD::OPC_FilterValue, 13, 148, 0, 0, // Skip to: 1899
/* 1751 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1754 */    MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 1794
/* 1759 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1762 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1778
/* 1767 */    MCD::OPC_CheckField, 24, 8, 0, 243, 48, 0, // Skip to: 14305
/* 1774 */    MCD::OPC_Decode, 231, 3, 3, // Opcode: BSET8ji
/* 1778 */    MCD::OPC_FilterValue, 1, 234, 48, 0, // Skip to: 14305
/* 1783 */    MCD::OPC_CheckField, 24, 8, 0, 227, 48, 0, // Skip to: 14305
/* 1790 */    MCD::OPC_Decode, 233, 3, 3, // Opcode: BSET8oi
/* 1794 */    MCD::OPC_FilterValue, 5, 30, 0, 0, // Skip to: 1829
/* 1799 */    MCD::OPC_CheckPredicate, 0, 213, 48, 0, // Skip to: 14305
/* 1804 */    MCD::OPC_CheckField, 25, 7, 0, 206, 48, 0, // Skip to: 14305
/* 1811 */    MCD::OPC_CheckField, 19, 3, 0, 199, 48, 0, // Skip to: 14305
/* 1818 */    MCD::OPC_CheckField, 3, 1, 0, 192, 48, 0, // Skip to: 14305
/* 1825 */    MCD::OPC_Decode, 161, 4, 36, // Opcode: CAS8
/* 1829 */    MCD::OPC_FilterValue, 6, 30, 0, 0, // Skip to: 1864
/* 1834 */    MCD::OPC_CheckPredicate, 0, 178, 48, 0, // Skip to: 14305
/* 1839 */    MCD::OPC_CheckField, 25, 7, 0, 171, 48, 0, // Skip to: 14305
/* 1846 */    MCD::OPC_CheckField, 19, 3, 0, 164, 48, 0, // Skip to: 14305
/* 1853 */    MCD::OPC_CheckField, 3, 1, 0, 157, 48, 0, // Skip to: 14305
/* 1860 */    MCD::OPC_Decode, 159, 4, 37, // Opcode: CAS16
/* 1864 */    MCD::OPC_FilterValue, 7, 148, 48, 0, // Skip to: 14305
/* 1869 */    MCD::OPC_CheckPredicate, 0, 143, 48, 0, // Skip to: 14305
/* 1874 */    MCD::OPC_CheckField, 25, 7, 0, 136, 48, 0, // Skip to: 14305
/* 1881 */    MCD::OPC_CheckField, 19, 3, 0, 129, 48, 0, // Skip to: 14305
/* 1888 */    MCD::OPC_CheckField, 3, 1, 0, 122, 48, 0, // Skip to: 14305
/* 1895 */    MCD::OPC_Decode, 160, 4, 38, // Opcode: CAS32
/* 1899 */    MCD::OPC_FilterValue, 14, 49, 0, 0, // Skip to: 1953
/* 1904 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1907 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1930
/* 1912 */    MCD::OPC_CheckField, 24, 8, 0, 98, 48, 0, // Skip to: 14305
/* 1919 */    MCD::OPC_CheckField, 9, 3, 4, 91, 48, 0, // Skip to: 14305
/* 1926 */    MCD::OPC_Decode, 227, 3, 3, // Opcode: BSET8ei
/* 1930 */    MCD::OPC_FilterValue, 1, 82, 48, 0, // Skip to: 14305
/* 1935 */    MCD::OPC_CheckField, 24, 8, 0, 75, 48, 0, // Skip to: 14305
/* 1942 */    MCD::OPC_CheckField, 9, 3, 4, 68, 48, 0, // Skip to: 14305
/* 1949 */    MCD::OPC_Decode, 235, 3, 5, // Opcode: BSET8pi
/* 1953 */    MCD::OPC_FilterValue, 15, 32, 0, 0, // Skip to: 1990
/* 1958 */    MCD::OPC_CheckField, 40, 4, 8, 52, 48, 0, // Skip to: 14305
/* 1965 */    MCD::OPC_CheckField, 24, 8, 0, 45, 48, 0, // Skip to: 14305
/* 1972 */    MCD::OPC_CheckField, 9, 3, 4, 38, 48, 0, // Skip to: 14305
/* 1979 */    MCD::OPC_CheckField, 3, 1, 0, 31, 48, 0, // Skip to: 14305
/* 1986 */    MCD::OPC_Decode, 229, 3, 7, // Opcode: BSET8fi
/* 1990 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1999
/* 1995 */    MCD::OPC_Decode, 239, 3, 39, // Opcode: BTST32dd
/* 1999 */    MCD::OPC_FilterValue, 17, 21, 0, 0, // Skip to: 2025
/* 2004 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2007 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2016
/* 2012 */    MCD::OPC_Decode, 245, 3, 40, // Opcode: BTST8jd
/* 2016 */    MCD::OPC_FilterValue, 1, 252, 47, 0, // Skip to: 14305
/* 2021 */    MCD::OPC_Decode, 249, 3, 40, // Opcode: BTST8od
/* 2025 */    MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 2051
/* 2030 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2033 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2042
/* 2038 */    MCD::OPC_Decode, 241, 3, 40, // Opcode: BTST8ed
/* 2042 */    MCD::OPC_FilterValue, 1, 226, 47, 0, // Skip to: 14305
/* 2047 */    MCD::OPC_Decode, 251, 3, 41, // Opcode: BTST8pd
/* 2051 */    MCD::OPC_FilterValue, 19, 52, 0, 0, // Skip to: 2108
/* 2056 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2059 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2075
/* 2064 */    MCD::OPC_CheckField, 24, 4, 8, 202, 47, 0, // Skip to: 14305
/* 2071 */    MCD::OPC_Decode, 243, 3, 42, // Opcode: BTST8fd
/* 2075 */    MCD::OPC_FilterValue, 1, 193, 47, 0, // Skip to: 14305
/* 2080 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2083 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2092
/* 2088 */    MCD::OPC_Decode, 253, 3, 43, // Opcode: BTST8qd
/* 2092 */    MCD::OPC_FilterValue, 3, 176, 47, 0, // Skip to: 14305
/* 2097 */    MCD::OPC_CheckField, 24, 4, 8, 169, 47, 0, // Skip to: 14305
/* 2104 */    MCD::OPC_Decode, 247, 3, 44, // Opcode: BTST8kd
/* 2108 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 2117
/* 2113 */    MCD::OPC_Decode, 197, 3, 39, // Opcode: BCHG32dd
/* 2117 */    MCD::OPC_FilterValue, 21, 21, 0, 0, // Skip to: 2143
/* 2122 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2125 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2134
/* 2130 */    MCD::OPC_Decode, 203, 3, 40, // Opcode: BCHG8jd
/* 2134 */    MCD::OPC_FilterValue, 1, 134, 47, 0, // Skip to: 14305
/* 2139 */    MCD::OPC_Decode, 205, 3, 40, // Opcode: BCHG8od
/* 2143 */    MCD::OPC_FilterValue, 22, 21, 0, 0, // Skip to: 2169
/* 2148 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2151 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2160
/* 2156 */    MCD::OPC_Decode, 199, 3, 40, // Opcode: BCHG8ed
/* 2160 */    MCD::OPC_FilterValue, 1, 108, 47, 0, // Skip to: 14305
/* 2165 */    MCD::OPC_Decode, 207, 3, 41, // Opcode: BCHG8pd
/* 2169 */    MCD::OPC_FilterValue, 23, 18, 0, 0, // Skip to: 2192
/* 2174 */    MCD::OPC_CheckField, 24, 4, 8, 92, 47, 0, // Skip to: 14305
/* 2181 */    MCD::OPC_CheckField, 3, 1, 0, 85, 47, 0, // Skip to: 14305
/* 2188 */    MCD::OPC_Decode, 201, 3, 42, // Opcode: BCHG8fd
/* 2192 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 2201
/* 2197 */    MCD::OPC_Decode, 209, 3, 39, // Opcode: BCLR32dd
/* 2201 */    MCD::OPC_FilterValue, 25, 21, 0, 0, // Skip to: 2227
/* 2206 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2209 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2218
/* 2214 */    MCD::OPC_Decode, 215, 3, 40, // Opcode: BCLR8jd
/* 2218 */    MCD::OPC_FilterValue, 1, 50, 47, 0, // Skip to: 14305
/* 2223 */    MCD::OPC_Decode, 217, 3, 40, // Opcode: BCLR8od
/* 2227 */    MCD::OPC_FilterValue, 26, 21, 0, 0, // Skip to: 2253
/* 2232 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2235 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2244
/* 2240 */    MCD::OPC_Decode, 211, 3, 40, // Opcode: BCLR8ed
/* 2244 */    MCD::OPC_FilterValue, 1, 24, 47, 0, // Skip to: 14305
/* 2249 */    MCD::OPC_Decode, 219, 3, 41, // Opcode: BCLR8pd
/* 2253 */    MCD::OPC_FilterValue, 27, 18, 0, 0, // Skip to: 2276
/* 2258 */    MCD::OPC_CheckField, 24, 4, 8, 8, 47, 0, // Skip to: 14305
/* 2265 */    MCD::OPC_CheckField, 3, 1, 0, 1, 47, 0, // Skip to: 14305
/* 2272 */    MCD::OPC_Decode, 213, 3, 42, // Opcode: BCLR8fd
/* 2276 */    MCD::OPC_FilterValue, 28, 4, 0, 0, // Skip to: 2285
/* 2281 */    MCD::OPC_Decode, 224, 3, 39, // Opcode: BSET32dd
/* 2285 */    MCD::OPC_FilterValue, 29, 21, 0, 0, // Skip to: 2311
/* 2290 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2293 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2302
/* 2298 */    MCD::OPC_Decode, 230, 3, 40, // Opcode: BSET8jd
/* 2302 */    MCD::OPC_FilterValue, 1, 222, 46, 0, // Skip to: 14305
/* 2307 */    MCD::OPC_Decode, 232, 3, 40, // Opcode: BSET8od
/* 2311 */    MCD::OPC_FilterValue, 30, 21, 0, 0, // Skip to: 2337
/* 2316 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2319 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2328
/* 2324 */    MCD::OPC_Decode, 226, 3, 40, // Opcode: BSET8ed
/* 2328 */    MCD::OPC_FilterValue, 1, 196, 46, 0, // Skip to: 14305
/* 2333 */    MCD::OPC_Decode, 234, 3, 41, // Opcode: BSET8pd
/* 2337 */    MCD::OPC_FilterValue, 31, 187, 46, 0, // Skip to: 14305
/* 2342 */    MCD::OPC_CheckField, 24, 4, 8, 180, 46, 0, // Skip to: 14305
/* 2349 */    MCD::OPC_CheckField, 3, 1, 0, 173, 46, 0, // Skip to: 14305
/* 2356 */    MCD::OPC_Decode, 228, 3, 42, // Opcode: BSET8fd
/* 2360 */    MCD::OPC_FilterValue, 1, 254, 4, 0, // Skip to: 3643
/* 2365 */    MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 2368 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2377
/* 2373 */    MCD::OPC_Decode, 218, 7, 45, // Opcode: MOV8dd
/* 2377 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2386
/* 2382 */    MCD::OPC_Decode, 222, 7, 46, // Opcode: MOV8dj
/* 2386 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 2395
/* 2391 */    MCD::OPC_Decode, 224, 7, 46, // Opcode: MOV8do
/* 2395 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 2404
/* 2400 */    MCD::OPC_Decode, 219, 7, 46, // Opcode: MOV8de
/* 2404 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 2413
/* 2409 */    MCD::OPC_Decode, 225, 7, 47, // Opcode: MOV8dp
/* 2413 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 2429
/* 2418 */    MCD::OPC_CheckField, 24, 4, 8, 104, 46, 0, // Skip to: 14305
/* 2425 */    MCD::OPC_Decode, 220, 7, 48, // Opcode: MOV8df
/* 2429 */    MCD::OPC_FilterValue, 7, 53, 0, 0, // Skip to: 2487
/* 2434 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2437 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2446
/* 2442 */    MCD::OPC_Decode, 217, 7, 49, // Opcode: MOV8db
/* 2446 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2455
/* 2451 */    MCD::OPC_Decode, 226, 7, 50, // Opcode: MOV8dq
/* 2455 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2471
/* 2460 */    MCD::OPC_CheckField, 24, 4, 8, 62, 46, 0, // Skip to: 14305
/* 2467 */    MCD::OPC_Decode, 223, 7, 51, // Opcode: MOV8dk
/* 2471 */    MCD::OPC_FilterValue, 4, 53, 46, 0, // Skip to: 14305
/* 2476 */    MCD::OPC_CheckField, 24, 8, 0, 46, 46, 0, // Skip to: 14305
/* 2483 */    MCD::OPC_Decode, 221, 7, 52, // Opcode: MOV8di
/* 2487 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 2496
/* 2492 */    MCD::OPC_Decode, 248, 7, 53, // Opcode: MOV8jd
/* 2496 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 2505
/* 2501 */    MCD::OPC_Decode, 252, 7, 54, // Opcode: MOV8jj
/* 2505 */    MCD::OPC_FilterValue, 19, 4, 0, 0, // Skip to: 2514
/* 2510 */    MCD::OPC_Decode, 254, 7, 54, // Opcode: MOV8jo
/* 2514 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 2523
/* 2519 */    MCD::OPC_Decode, 249, 7, 54, // Opcode: MOV8je
/* 2523 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 2532
/* 2528 */    MCD::OPC_Decode, 255, 7, 55, // Opcode: MOV8jp
/* 2532 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 2548
/* 2537 */    MCD::OPC_CheckField, 24, 4, 8, 241, 45, 0, // Skip to: 14305
/* 2544 */    MCD::OPC_Decode, 250, 7, 56, // Opcode: MOV8jf
/* 2548 */    MCD::OPC_FilterValue, 23, 53, 0, 0, // Skip to: 2606
/* 2553 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2556 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2565
/* 2561 */    MCD::OPC_Decode, 247, 7, 57, // Opcode: MOV8jb
/* 2565 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2574
/* 2570 */    MCD::OPC_Decode, 128, 8, 58, // Opcode: MOV8jq
/* 2574 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2590
/* 2579 */    MCD::OPC_CheckField, 24, 4, 8, 199, 45, 0, // Skip to: 14305
/* 2586 */    MCD::OPC_Decode, 253, 7, 59, // Opcode: MOV8jk
/* 2590 */    MCD::OPC_FilterValue, 4, 190, 45, 0, // Skip to: 14305
/* 2595 */    MCD::OPC_CheckField, 24, 8, 0, 183, 45, 0, // Skip to: 14305
/* 2602 */    MCD::OPC_Decode, 251, 7, 60, // Opcode: MOV8ji
/* 2606 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 2615
/* 2611 */    MCD::OPC_Decode, 140, 8, 53, // Opcode: MOV8od
/* 2615 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 2624
/* 2620 */    MCD::OPC_Decode, 144, 8, 54, // Opcode: MOV8oj
/* 2624 */    MCD::OPC_FilterValue, 27, 4, 0, 0, // Skip to: 2633
/* 2629 */    MCD::OPC_Decode, 146, 8, 54, // Opcode: MOV8oo
/* 2633 */    MCD::OPC_FilterValue, 28, 4, 0, 0, // Skip to: 2642
/* 2638 */    MCD::OPC_Decode, 141, 8, 54, // Opcode: MOV8oe
/* 2642 */    MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 2651
/* 2647 */    MCD::OPC_Decode, 147, 8, 55, // Opcode: MOV8op
/* 2651 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 2667
/* 2656 */    MCD::OPC_CheckField, 24, 4, 8, 122, 45, 0, // Skip to: 14305
/* 2663 */    MCD::OPC_Decode, 142, 8, 56, // Opcode: MOV8of
/* 2667 */    MCD::OPC_FilterValue, 31, 53, 0, 0, // Skip to: 2725
/* 2672 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2675 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2684
/* 2680 */    MCD::OPC_Decode, 139, 8, 57, // Opcode: MOV8ob
/* 2684 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2693
/* 2689 */    MCD::OPC_Decode, 148, 8, 58, // Opcode: MOV8oq
/* 2693 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2709
/* 2698 */    MCD::OPC_CheckField, 24, 4, 8, 80, 45, 0, // Skip to: 14305
/* 2705 */    MCD::OPC_Decode, 145, 8, 59, // Opcode: MOV8ok
/* 2709 */    MCD::OPC_FilterValue, 4, 71, 45, 0, // Skip to: 14305
/* 2714 */    MCD::OPC_CheckField, 24, 8, 0, 64, 45, 0, // Skip to: 14305
/* 2721 */    MCD::OPC_Decode, 143, 8, 60, // Opcode: MOV8oi
/* 2725 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 2734
/* 2730 */    MCD::OPC_Decode, 228, 7, 53, // Opcode: MOV8ed
/* 2734 */    MCD::OPC_FilterValue, 34, 4, 0, 0, // Skip to: 2743
/* 2739 */    MCD::OPC_Decode, 232, 7, 54, // Opcode: MOV8ej
/* 2743 */    MCD::OPC_FilterValue, 35, 4, 0, 0, // Skip to: 2752
/* 2748 */    MCD::OPC_Decode, 234, 7, 54, // Opcode: MOV8eo
/* 2752 */    MCD::OPC_FilterValue, 36, 4, 0, 0, // Skip to: 2761
/* 2757 */    MCD::OPC_Decode, 229, 7, 54, // Opcode: MOV8ee
/* 2761 */    MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 2770
/* 2766 */    MCD::OPC_Decode, 235, 7, 55, // Opcode: MOV8ep
/* 2770 */    MCD::OPC_FilterValue, 38, 11, 0, 0, // Skip to: 2786
/* 2775 */    MCD::OPC_CheckField, 24, 4, 8, 3, 45, 0, // Skip to: 14305
/* 2782 */    MCD::OPC_Decode, 230, 7, 56, // Opcode: MOV8ef
/* 2786 */    MCD::OPC_FilterValue, 39, 53, 0, 0, // Skip to: 2844
/* 2791 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2794 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2803
/* 2799 */    MCD::OPC_Decode, 227, 7, 57, // Opcode: MOV8eb
/* 2803 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2812
/* 2808 */    MCD::OPC_Decode, 236, 7, 58, // Opcode: MOV8eq
/* 2812 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2828
/* 2817 */    MCD::OPC_CheckField, 24, 4, 8, 217, 44, 0, // Skip to: 14305
/* 2824 */    MCD::OPC_Decode, 233, 7, 59, // Opcode: MOV8ek
/* 2828 */    MCD::OPC_FilterValue, 4, 208, 44, 0, // Skip to: 14305
/* 2833 */    MCD::OPC_CheckField, 24, 8, 0, 201, 44, 0, // Skip to: 14305
/* 2840 */    MCD::OPC_Decode, 231, 7, 60, // Opcode: MOV8ei
/* 2844 */    MCD::OPC_FilterValue, 40, 4, 0, 0, // Skip to: 2853
/* 2849 */    MCD::OPC_Decode, 150, 8, 61, // Opcode: MOV8pd
/* 2853 */    MCD::OPC_FilterValue, 42, 4, 0, 0, // Skip to: 2862
/* 2858 */    MCD::OPC_Decode, 154, 8, 62, // Opcode: MOV8pj
/* 2862 */    MCD::OPC_FilterValue, 43, 4, 0, 0, // Skip to: 2871
/* 2867 */    MCD::OPC_Decode, 156, 8, 62, // Opcode: MOV8po
/* 2871 */    MCD::OPC_FilterValue, 44, 4, 0, 0, // Skip to: 2880
/* 2876 */    MCD::OPC_Decode, 151, 8, 62, // Opcode: MOV8pe
/* 2880 */    MCD::OPC_FilterValue, 45, 4, 0, 0, // Skip to: 2889
/* 2885 */    MCD::OPC_Decode, 157, 8, 63, // Opcode: MOV8pp
/* 2889 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 2905
/* 2894 */    MCD::OPC_CheckField, 24, 4, 8, 140, 44, 0, // Skip to: 14305
/* 2901 */    MCD::OPC_Decode, 152, 8, 64, // Opcode: MOV8pf
/* 2905 */    MCD::OPC_FilterValue, 47, 53, 0, 0, // Skip to: 2963
/* 2910 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2913 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2922
/* 2918 */    MCD::OPC_Decode, 149, 8, 65, // Opcode: MOV8pb
/* 2922 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2931
/* 2927 */    MCD::OPC_Decode, 158, 8, 66, // Opcode: MOV8pq
/* 2931 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2947
/* 2936 */    MCD::OPC_CheckField, 24, 4, 8, 98, 44, 0, // Skip to: 14305
/* 2943 */    MCD::OPC_Decode, 155, 8, 67, // Opcode: MOV8pk
/* 2947 */    MCD::OPC_FilterValue, 4, 89, 44, 0, // Skip to: 14305
/* 2952 */    MCD::OPC_CheckField, 24, 8, 0, 82, 44, 0, // Skip to: 14305
/* 2959 */    MCD::OPC_Decode, 153, 8, 68, // Opcode: MOV8pi
/* 2963 */    MCD::OPC_FilterValue, 48, 11, 0, 0, // Skip to: 2979
/* 2968 */    MCD::OPC_CheckField, 24, 4, 8, 66, 44, 0, // Skip to: 14305
/* 2975 */    MCD::OPC_Decode, 238, 7, 69, // Opcode: MOV8fd
/* 2979 */    MCD::OPC_FilterValue, 50, 11, 0, 0, // Skip to: 2995
/* 2984 */    MCD::OPC_CheckField, 24, 4, 8, 50, 44, 0, // Skip to: 14305
/* 2991 */    MCD::OPC_Decode, 242, 7, 70, // Opcode: MOV8fj
/* 2995 */    MCD::OPC_FilterValue, 51, 11, 0, 0, // Skip to: 3011
/* 3000 */    MCD::OPC_CheckField, 24, 4, 8, 34, 44, 0, // Skip to: 14305
/* 3007 */    MCD::OPC_Decode, 244, 7, 70, // Opcode: MOV8fo
/* 3011 */    MCD::OPC_FilterValue, 52, 11, 0, 0, // Skip to: 3027
/* 3016 */    MCD::OPC_CheckField, 24, 4, 8, 18, 44, 0, // Skip to: 14305
/* 3023 */    MCD::OPC_Decode, 239, 7, 70, // Opcode: MOV8fe
/* 3027 */    MCD::OPC_FilterValue, 53, 11, 0, 0, // Skip to: 3043
/* 3032 */    MCD::OPC_CheckField, 40, 4, 8, 2, 44, 0, // Skip to: 14305
/* 3039 */    MCD::OPC_Decode, 245, 7, 71, // Opcode: MOV8fp
/* 3043 */    MCD::OPC_FilterValue, 54, 18, 0, 0, // Skip to: 3066
/* 3048 */    MCD::OPC_CheckField, 40, 4, 8, 242, 43, 0, // Skip to: 14305
/* 3055 */    MCD::OPC_CheckField, 24, 4, 8, 235, 43, 0, // Skip to: 14305
/* 3062 */    MCD::OPC_Decode, 240, 7, 72, // Opcode: MOV8ff
/* 3066 */    MCD::OPC_FilterValue, 55, 81, 0, 0, // Skip to: 3152
/* 3071 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 3074 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3090
/* 3079 */    MCD::OPC_CheckField, 56, 4, 8, 211, 43, 0, // Skip to: 14305
/* 3086 */    MCD::OPC_Decode, 237, 7, 73, // Opcode: MOV8fb
/* 3090 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3106
/* 3095 */    MCD::OPC_CheckField, 40, 4, 8, 195, 43, 0, // Skip to: 14305
/* 3102 */    MCD::OPC_Decode, 246, 7, 74, // Opcode: MOV8fq
/* 3106 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 3129
/* 3111 */    MCD::OPC_CheckField, 40, 4, 8, 179, 43, 0, // Skip to: 14305
/* 3118 */    MCD::OPC_CheckField, 24, 4, 8, 172, 43, 0, // Skip to: 14305
/* 3125 */    MCD::OPC_Decode, 243, 7, 75, // Opcode: MOV8fk
/* 3129 */    MCD::OPC_FilterValue, 4, 163, 43, 0, // Skip to: 14305
/* 3134 */    MCD::OPC_CheckField, 40, 4, 8, 156, 43, 0, // Skip to: 14305
/* 3141 */    MCD::OPC_CheckField, 24, 8, 0, 149, 43, 0, // Skip to: 14305
/* 3148 */    MCD::OPC_Decode, 241, 7, 76, // Opcode: MOV8fi
/* 3152 */    MCD::OPC_FilterValue, 56, 37, 0, 0, // Skip to: 3194
/* 3157 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3160 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3169
/* 3165 */    MCD::OPC_Decode, 208, 7, 77, // Opcode: MOV8bd
/* 3169 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3178
/* 3174 */    MCD::OPC_Decode, 160, 8, 78, // Opcode: MOV8qd
/* 3178 */    MCD::OPC_FilterValue, 3, 114, 43, 0, // Skip to: 14305
/* 3183 */    MCD::OPC_CheckField, 24, 4, 8, 107, 43, 0, // Skip to: 14305
/* 3190 */    MCD::OPC_Decode, 130, 8, 79, // Opcode: MOV8kd
/* 3194 */    MCD::OPC_FilterValue, 58, 37, 0, 0, // Skip to: 3236
/* 3199 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3202 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3211
/* 3207 */    MCD::OPC_Decode, 212, 7, 28, // Opcode: MOV8bj
/* 3211 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3220
/* 3216 */    MCD::OPC_Decode, 164, 8, 17, // Opcode: MOV8qj
/* 3220 */    MCD::OPC_FilterValue, 3, 72, 43, 0, // Skip to: 14305
/* 3225 */    MCD::OPC_CheckField, 24, 4, 8, 65, 43, 0, // Skip to: 14305
/* 3232 */    MCD::OPC_Decode, 134, 8, 80, // Opcode: MOV8kj
/* 3236 */    MCD::OPC_FilterValue, 59, 37, 0, 0, // Skip to: 3278
/* 3241 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3244 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3253
/* 3249 */    MCD::OPC_Decode, 214, 7, 28, // Opcode: MOV8bo
/* 3253 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3262
/* 3258 */    MCD::OPC_Decode, 166, 8, 17, // Opcode: MOV8qo
/* 3262 */    MCD::OPC_FilterValue, 3, 30, 43, 0, // Skip to: 14305
/* 3267 */    MCD::OPC_CheckField, 24, 4, 8, 23, 43, 0, // Skip to: 14305
/* 3274 */    MCD::OPC_Decode, 136, 8, 80, // Opcode: MOV8ko
/* 3278 */    MCD::OPC_FilterValue, 60, 37, 0, 0, // Skip to: 3320
/* 3283 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3286 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3295
/* 3291 */    MCD::OPC_Decode, 209, 7, 28, // Opcode: MOV8be
/* 3295 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3304
/* 3300 */    MCD::OPC_Decode, 161, 8, 17, // Opcode: MOV8qe
/* 3304 */    MCD::OPC_FilterValue, 3, 244, 42, 0, // Skip to: 14305
/* 3309 */    MCD::OPC_CheckField, 24, 4, 8, 237, 42, 0, // Skip to: 14305
/* 3316 */    MCD::OPC_Decode, 131, 8, 80, // Opcode: MOV8ke
/* 3320 */    MCD::OPC_FilterValue, 61, 37, 0, 0, // Skip to: 3362
/* 3325 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3328 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3337
/* 3333 */    MCD::OPC_Decode, 215, 7, 81, // Opcode: MOV8bp
/* 3337 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3346
/* 3342 */    MCD::OPC_Decode, 167, 8, 82, // Opcode: MOV8qp
/* 3346 */    MCD::OPC_FilterValue, 3, 202, 42, 0, // Skip to: 14305
/* 3351 */    MCD::OPC_CheckField, 40, 4, 8, 195, 42, 0, // Skip to: 14305
/* 3358 */    MCD::OPC_Decode, 137, 8, 83, // Opcode: MOV8kp
/* 3362 */    MCD::OPC_FilterValue, 62, 58, 0, 0, // Skip to: 3425
/* 3367 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3370 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3386
/* 3375 */    MCD::OPC_CheckField, 24, 4, 8, 171, 42, 0, // Skip to: 14305
/* 3382 */    MCD::OPC_Decode, 210, 7, 84, // Opcode: MOV8bf
/* 3386 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3402
/* 3391 */    MCD::OPC_CheckField, 24, 4, 8, 155, 42, 0, // Skip to: 14305
/* 3398 */    MCD::OPC_Decode, 162, 8, 85, // Opcode: MOV8qf
/* 3402 */    MCD::OPC_FilterValue, 3, 146, 42, 0, // Skip to: 14305
/* 3407 */    MCD::OPC_CheckField, 40, 4, 8, 139, 42, 0, // Skip to: 14305
/* 3414 */    MCD::OPC_CheckField, 24, 4, 8, 132, 42, 0, // Skip to: 14305
/* 3421 */    MCD::OPC_Decode, 132, 8, 86, // Opcode: MOV8kf
/* 3425 */    MCD::OPC_FilterValue, 63, 123, 42, 0, // Skip to: 14305
/* 3430 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 3433 */    MCD::OPC_FilterValue, 1, 37, 0, 0, // Skip to: 3475
/* 3438 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3441 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3450
/* 3446 */    MCD::OPC_Decode, 207, 7, 87, // Opcode: MOV8bb
/* 3450 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3459
/* 3455 */    MCD::OPC_Decode, 159, 8, 88, // Opcode: MOV8qb
/* 3459 */    MCD::OPC_FilterValue, 3, 89, 42, 0, // Skip to: 14305
/* 3464 */    MCD::OPC_CheckField, 56, 4, 8, 82, 42, 0, // Skip to: 14305
/* 3471 */    MCD::OPC_Decode, 129, 8, 89, // Opcode: MOV8kb
/* 3475 */    MCD::OPC_FilterValue, 2, 37, 0, 0, // Skip to: 3517
/* 3480 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3483 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3492
/* 3488 */    MCD::OPC_Decode, 216, 7, 90, // Opcode: MOV8bq
/* 3492 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3501
/* 3497 */    MCD::OPC_Decode, 168, 8, 91, // Opcode: MOV8qq
/* 3501 */    MCD::OPC_FilterValue, 3, 47, 42, 0, // Skip to: 14305
/* 3506 */    MCD::OPC_CheckField, 40, 4, 8, 40, 42, 0, // Skip to: 14305
/* 3513 */    MCD::OPC_Decode, 138, 8, 92, // Opcode: MOV8kq
/* 3517 */    MCD::OPC_FilterValue, 3, 58, 0, 0, // Skip to: 3580
/* 3522 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3525 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3541
/* 3530 */    MCD::OPC_CheckField, 24, 4, 8, 16, 42, 0, // Skip to: 14305
/* 3537 */    MCD::OPC_Decode, 213, 7, 93, // Opcode: MOV8bk
/* 3541 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3557
/* 3546 */    MCD::OPC_CheckField, 24, 4, 8, 0, 42, 0, // Skip to: 14305
/* 3553 */    MCD::OPC_Decode, 165, 8, 94, // Opcode: MOV8qk
/* 3557 */    MCD::OPC_FilterValue, 3, 247, 41, 0, // Skip to: 14305
/* 3562 */    MCD::OPC_CheckField, 40, 4, 8, 240, 41, 0, // Skip to: 14305
/* 3569 */    MCD::OPC_CheckField, 24, 4, 8, 233, 41, 0, // Skip to: 14305
/* 3576 */    MCD::OPC_Decode, 135, 8, 95, // Opcode: MOV8kk
/* 3580 */    MCD::OPC_FilterValue, 4, 224, 41, 0, // Skip to: 14305
/* 3585 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3588 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 3604
/* 3593 */    MCD::OPC_CheckField, 24, 8, 0, 209, 41, 0, // Skip to: 14305
/* 3600 */    MCD::OPC_Decode, 211, 7, 96, // Opcode: MOV8bi
/* 3604 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 3620
/* 3609 */    MCD::OPC_CheckField, 24, 8, 0, 193, 41, 0, // Skip to: 14305
/* 3616 */    MCD::OPC_Decode, 163, 8, 8, // Opcode: MOV8qi
/* 3620 */    MCD::OPC_FilterValue, 3, 184, 41, 0, // Skip to: 14305
/* 3625 */    MCD::OPC_CheckField, 40, 4, 8, 177, 41, 0, // Skip to: 14305
/* 3632 */    MCD::OPC_CheckField, 24, 8, 0, 170, 41, 0, // Skip to: 14305
/* 3639 */    MCD::OPC_Decode, 133, 8, 9, // Opcode: MOV8ki
/* 3643 */    MCD::OPC_FilterValue, 2, 178, 7, 0, // Skip to: 5618
/* 3648 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 3651 */    MCD::OPC_FilterValue, 0, 94, 1, 0, // Skip to: 4006
/* 3656 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3659 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 3718
/* 3664 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3667 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3683
/* 3672 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 3703
/* 3679 */    MCD::OPC_Decode, 223, 6, 97, // Opcode: MOV32dd
/* 3683 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 3703
/* 3688 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 3699
/* 3695 */    MCD::OPC_Decode, 191, 6, 54, // Opcode: MOV32aa
/* 3699 */    MCD::OPC_Decode, 188, 7, 98, // Opcode: MOV32ra
/* 3703 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 3714
/* 3710 */    MCD::OPC_Decode, 209, 6, 99, // Opcode: MOV32ar
/* 3714 */    MCD::OPC_Decode, 206, 7, 100, // Opcode: MOV32rr
/* 3718 */    MCD::OPC_FilterValue, 1, 63, 0, 0, // Skip to: 3786
/* 3723 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3726 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3756
/* 3731 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3734 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3743
/* 3739 */    MCD::OPC_Decode, 130, 7, 101, // Opcode: MOV32jd
/* 3743 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3752
/* 3748 */    MCD::OPC_Decode, 128, 7, 54, // Opcode: MOV32ja
/* 3752 */    MCD::OPC_Decode, 139, 7, 99, // Opcode: MOV32jr
/* 3756 */    MCD::OPC_FilterValue, 1, 48, 41, 0, // Skip to: 14305
/* 3761 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3764 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3773
/* 3769 */    MCD::OPC_Decode, 154, 7, 101, // Opcode: MOV32od
/* 3773 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3782
/* 3778 */    MCD::OPC_Decode, 152, 7, 54, // Opcode: MOV32oa
/* 3782 */    MCD::OPC_Decode, 163, 7, 99, // Opcode: MOV32or
/* 3786 */    MCD::OPC_FilterValue, 2, 63, 0, 0, // Skip to: 3854
/* 3791 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3794 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3824
/* 3799 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3802 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3811
/* 3807 */    MCD::OPC_Decode, 234, 6, 101, // Opcode: MOV32ed
/* 3811 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3820
/* 3816 */    MCD::OPC_Decode, 232, 6, 54, // Opcode: MOV32ea
/* 3820 */    MCD::OPC_Decode, 243, 6, 99, // Opcode: MOV32er
/* 3824 */    MCD::OPC_FilterValue, 1, 236, 40, 0, // Skip to: 14305
/* 3829 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3832 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3841
/* 3837 */    MCD::OPC_Decode, 166, 7, 102, // Opcode: MOV32pd
/* 3841 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3850
/* 3846 */    MCD::OPC_Decode, 164, 7, 62, // Opcode: MOV32pa
/* 3850 */    MCD::OPC_Decode, 175, 7, 103, // Opcode: MOV32pr
/* 3854 */    MCD::OPC_FilterValue, 3, 206, 40, 0, // Skip to: 14305
/* 3859 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3862 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 3900
/* 3867 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3870 */    MCD::OPC_FilterValue, 8, 190, 40, 0, // Skip to: 14305
/* 3875 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3878 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3887
/* 3883 */    MCD::OPC_Decode, 246, 6, 104, // Opcode: MOV32fd
/* 3887 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3896
/* 3892 */    MCD::OPC_Decode, 244, 6, 70, // Opcode: MOV32fa
/* 3896 */    MCD::OPC_Decode, 255, 6, 105, // Opcode: MOV32fr
/* 3900 */    MCD::OPC_FilterValue, 1, 160, 40, 0, // Skip to: 14305
/* 3905 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3908 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 3938
/* 3913 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3916 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3925
/* 3921 */    MCD::OPC_Decode, 212, 6, 26, // Opcode: MOV32bd
/* 3925 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3934
/* 3930 */    MCD::OPC_Decode, 210, 6, 28, // Opcode: MOV32ba
/* 3934 */    MCD::OPC_Decode, 221, 6, 106, // Opcode: MOV32br
/* 3938 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 3968
/* 3943 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3946 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3955
/* 3951 */    MCD::OPC_Decode, 178, 7, 107, // Opcode: MOV32qd
/* 3955 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3964
/* 3960 */    MCD::OPC_Decode, 176, 7, 17, // Opcode: MOV32qa
/* 3964 */    MCD::OPC_Decode, 187, 7, 108, // Opcode: MOV32qr
/* 3968 */    MCD::OPC_FilterValue, 3, 92, 40, 0, // Skip to: 14305
/* 3973 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3976 */    MCD::OPC_FilterValue, 8, 84, 40, 0, // Skip to: 14305
/* 3981 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3984 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3993
/* 3989 */    MCD::OPC_Decode, 142, 7, 109, // Opcode: MOV32kd
/* 3993 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4002
/* 3998 */    MCD::OPC_Decode, 140, 7, 80, // Opcode: MOV32ka
/* 4002 */    MCD::OPC_Decode, 151, 7, 110, // Opcode: MOV32kr
/* 4006 */    MCD::OPC_FilterValue, 1, 75, 1, 0, // Skip to: 4342
/* 4011 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4014 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 4082
/* 4019 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4022 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 4052
/* 4027 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4030 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4039
/* 4035 */    MCD::OPC_Decode, 227, 6, 111, // Opcode: MOV32dj
/* 4039 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4048
/* 4044 */    MCD::OPC_Decode, 199, 6, 54, // Opcode: MOV32aj
/* 4048 */    MCD::OPC_Decode, 196, 7, 98, // Opcode: MOV32rj
/* 4052 */    MCD::OPC_FilterValue, 1, 8, 40, 0, // Skip to: 14305
/* 4057 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4060 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4069
/* 4065 */    MCD::OPC_Decode, 229, 6, 111, // Opcode: MOV32do
/* 4069 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4078
/* 4074 */    MCD::OPC_Decode, 203, 6, 54, // Opcode: MOV32ao
/* 4078 */    MCD::OPC_Decode, 200, 7, 98, // Opcode: MOV32ro
/* 4082 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 4142
/* 4087 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4090 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4116
/* 4095 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4098 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4107
/* 4103 */    MCD::OPC_Decode, 134, 7, 54, // Opcode: MOV32jj
/* 4107 */    MCD::OPC_FilterValue, 1, 209, 39, 0, // Skip to: 14305
/* 4112 */    MCD::OPC_Decode, 158, 7, 54, // Opcode: MOV32oj
/* 4116 */    MCD::OPC_FilterValue, 1, 200, 39, 0, // Skip to: 14305
/* 4121 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4124 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4133
/* 4129 */    MCD::OPC_Decode, 136, 7, 54, // Opcode: MOV32jo
/* 4133 */    MCD::OPC_FilterValue, 1, 183, 39, 0, // Skip to: 14305
/* 4138 */    MCD::OPC_Decode, 160, 7, 54, // Opcode: MOV32oo
/* 4142 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 4202
/* 4147 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4150 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4176
/* 4155 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4158 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4167
/* 4163 */    MCD::OPC_Decode, 238, 6, 54, // Opcode: MOV32ej
/* 4167 */    MCD::OPC_FilterValue, 1, 149, 39, 0, // Skip to: 14305
/* 4172 */    MCD::OPC_Decode, 170, 7, 62, // Opcode: MOV32pj
/* 4176 */    MCD::OPC_FilterValue, 1, 140, 39, 0, // Skip to: 14305
/* 4181 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4184 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4193
/* 4189 */    MCD::OPC_Decode, 240, 6, 54, // Opcode: MOV32eo
/* 4193 */    MCD::OPC_FilterValue, 1, 123, 39, 0, // Skip to: 14305
/* 4198 */    MCD::OPC_Decode, 172, 7, 62, // Opcode: MOV32po
/* 4202 */    MCD::OPC_FilterValue, 3, 114, 39, 0, // Skip to: 14305
/* 4207 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4210 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 4276
/* 4215 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4218 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4234
/* 4223 */    MCD::OPC_CheckField, 24, 4, 8, 91, 39, 0, // Skip to: 14305
/* 4230 */    MCD::OPC_Decode, 250, 6, 70, // Opcode: MOV32fj
/* 4234 */    MCD::OPC_FilterValue, 1, 82, 39, 0, // Skip to: 14305
/* 4239 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4242 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4251
/* 4247 */    MCD::OPC_Decode, 216, 6, 28, // Opcode: MOV32bj
/* 4251 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4260
/* 4256 */    MCD::OPC_Decode, 182, 7, 17, // Opcode: MOV32qj
/* 4260 */    MCD::OPC_FilterValue, 3, 56, 39, 0, // Skip to: 14305
/* 4265 */    MCD::OPC_CheckField, 24, 4, 8, 49, 39, 0, // Skip to: 14305
/* 4272 */    MCD::OPC_Decode, 146, 7, 80, // Opcode: MOV32kj
/* 4276 */    MCD::OPC_FilterValue, 1, 40, 39, 0, // Skip to: 14305
/* 4281 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4284 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4300
/* 4289 */    MCD::OPC_CheckField, 24, 4, 8, 25, 39, 0, // Skip to: 14305
/* 4296 */    MCD::OPC_Decode, 252, 6, 70, // Opcode: MOV32fo
/* 4300 */    MCD::OPC_FilterValue, 1, 16, 39, 0, // Skip to: 14305
/* 4305 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4308 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4317
/* 4313 */    MCD::OPC_Decode, 218, 6, 28, // Opcode: MOV32bo
/* 4317 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4326
/* 4322 */    MCD::OPC_Decode, 184, 7, 17, // Opcode: MOV32qo
/* 4326 */    MCD::OPC_FilterValue, 3, 246, 38, 0, // Skip to: 14305
/* 4331 */    MCD::OPC_CheckField, 24, 4, 8, 239, 38, 0, // Skip to: 14305
/* 4338 */    MCD::OPC_Decode, 148, 7, 80, // Opcode: MOV32ko
/* 4342 */    MCD::OPC_FilterValue, 2, 75, 1, 0, // Skip to: 4678
/* 4347 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4350 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 4418
/* 4355 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4358 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 4388
/* 4363 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4366 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4375
/* 4371 */    MCD::OPC_Decode, 224, 6, 111, // Opcode: MOV32de
/* 4375 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4384
/* 4380 */    MCD::OPC_Decode, 194, 6, 54, // Opcode: MOV32ae
/* 4384 */    MCD::OPC_Decode, 191, 7, 98, // Opcode: MOV32re
/* 4388 */    MCD::OPC_FilterValue, 1, 184, 38, 0, // Skip to: 14305
/* 4393 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4396 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4405
/* 4401 */    MCD::OPC_Decode, 230, 6, 112, // Opcode: MOV32dp
/* 4405 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4414
/* 4410 */    MCD::OPC_Decode, 205, 6, 55, // Opcode: MOV32ap
/* 4414 */    MCD::OPC_Decode, 202, 7, 113, // Opcode: MOV32rp
/* 4418 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 4478
/* 4423 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4426 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4452
/* 4431 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4434 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4443
/* 4439 */    MCD::OPC_Decode, 131, 7, 54, // Opcode: MOV32je
/* 4443 */    MCD::OPC_FilterValue, 1, 129, 38, 0, // Skip to: 14305
/* 4448 */    MCD::OPC_Decode, 155, 7, 54, // Opcode: MOV32oe
/* 4452 */    MCD::OPC_FilterValue, 1, 120, 38, 0, // Skip to: 14305
/* 4457 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4460 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4469
/* 4465 */    MCD::OPC_Decode, 137, 7, 55, // Opcode: MOV32jp
/* 4469 */    MCD::OPC_FilterValue, 1, 103, 38, 0, // Skip to: 14305
/* 4474 */    MCD::OPC_Decode, 161, 7, 55, // Opcode: MOV32op
/* 4478 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 4538
/* 4483 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4486 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 4512
/* 4491 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4494 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4503
/* 4499 */    MCD::OPC_Decode, 235, 6, 54, // Opcode: MOV32ee
/* 4503 */    MCD::OPC_FilterValue, 1, 69, 38, 0, // Skip to: 14305
/* 4508 */    MCD::OPC_Decode, 167, 7, 62, // Opcode: MOV32pe
/* 4512 */    MCD::OPC_FilterValue, 1, 60, 38, 0, // Skip to: 14305
/* 4517 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4520 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4529
/* 4525 */    MCD::OPC_Decode, 241, 6, 55, // Opcode: MOV32ep
/* 4529 */    MCD::OPC_FilterValue, 1, 43, 38, 0, // Skip to: 14305
/* 4534 */    MCD::OPC_Decode, 173, 7, 63, // Opcode: MOV32pp
/* 4538 */    MCD::OPC_FilterValue, 3, 34, 38, 0, // Skip to: 14305
/* 4543 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4546 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 4612
/* 4551 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4554 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4570
/* 4559 */    MCD::OPC_CheckField, 24, 4, 8, 11, 38, 0, // Skip to: 14305
/* 4566 */    MCD::OPC_Decode, 247, 6, 70, // Opcode: MOV32fe
/* 4570 */    MCD::OPC_FilterValue, 1, 2, 38, 0, // Skip to: 14305
/* 4575 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4578 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4587
/* 4583 */    MCD::OPC_Decode, 213, 6, 28, // Opcode: MOV32be
/* 4587 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4596
/* 4592 */    MCD::OPC_Decode, 179, 7, 17, // Opcode: MOV32qe
/* 4596 */    MCD::OPC_FilterValue, 3, 232, 37, 0, // Skip to: 14305
/* 4601 */    MCD::OPC_CheckField, 24, 4, 8, 225, 37, 0, // Skip to: 14305
/* 4608 */    MCD::OPC_Decode, 143, 7, 80, // Opcode: MOV32ke
/* 4612 */    MCD::OPC_FilterValue, 1, 216, 37, 0, // Skip to: 14305
/* 4617 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4620 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4636
/* 4625 */    MCD::OPC_CheckField, 40, 4, 8, 201, 37, 0, // Skip to: 14305
/* 4632 */    MCD::OPC_Decode, 253, 6, 71, // Opcode: MOV32fp
/* 4636 */    MCD::OPC_FilterValue, 1, 192, 37, 0, // Skip to: 14305
/* 4641 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4644 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4653
/* 4649 */    MCD::OPC_Decode, 219, 6, 81, // Opcode: MOV32bp
/* 4653 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4662
/* 4658 */    MCD::OPC_Decode, 185, 7, 82, // Opcode: MOV32qp
/* 4662 */    MCD::OPC_FilterValue, 3, 166, 37, 0, // Skip to: 14305
/* 4667 */    MCD::OPC_CheckField, 40, 4, 8, 159, 37, 0, // Skip to: 14305
/* 4674 */    MCD::OPC_Decode, 149, 7, 83, // Opcode: MOV32kp
/* 4678 */    MCD::OPC_FilterValue, 3, 150, 37, 0, // Skip to: 14305
/* 4683 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4686 */    MCD::OPC_FilterValue, 0, 177, 0, 0, // Skip to: 4868
/* 4691 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4694 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 4732
/* 4699 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4702 */    MCD::OPC_FilterValue, 8, 126, 37, 0, // Skip to: 14305
/* 4707 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4710 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4719
/* 4715 */    MCD::OPC_Decode, 225, 6, 114, // Opcode: MOV32df
/* 4719 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4728
/* 4724 */    MCD::OPC_Decode, 196, 6, 56, // Opcode: MOV32af
/* 4728 */    MCD::OPC_Decode, 193, 7, 115, // Opcode: MOV32rf
/* 4732 */    MCD::OPC_FilterValue, 1, 96, 37, 0, // Skip to: 14305
/* 4737 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4740 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 4770
/* 4745 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4748 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4757
/* 4753 */    MCD::OPC_Decode, 222, 6, 116, // Opcode: MOV32db
/* 4757 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4766
/* 4762 */    MCD::OPC_Decode, 192, 6, 57, // Opcode: MOV32ab
/* 4766 */    MCD::OPC_Decode, 189, 7, 117, // Opcode: MOV32rb
/* 4770 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 4800
/* 4775 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4778 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4787
/* 4783 */    MCD::OPC_Decode, 231, 6, 118, // Opcode: MOV32dq
/* 4787 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4796
/* 4792 */    MCD::OPC_Decode, 207, 6, 58, // Opcode: MOV32aq
/* 4796 */    MCD::OPC_Decode, 204, 7, 119, // Opcode: MOV32rq
/* 4800 */    MCD::OPC_FilterValue, 3, 33, 0, 0, // Skip to: 4838
/* 4805 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4808 */    MCD::OPC_FilterValue, 8, 20, 37, 0, // Skip to: 14305
/* 4813 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4816 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4825
/* 4821 */    MCD::OPC_Decode, 228, 6, 120, // Opcode: MOV32dk
/* 4825 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4834
/* 4830 */    MCD::OPC_Decode, 201, 6, 59, // Opcode: MOV32ak
/* 4834 */    MCD::OPC_Decode, 198, 7, 121, // Opcode: MOV32rk
/* 4838 */    MCD::OPC_FilterValue, 4, 246, 36, 0, // Skip to: 14305
/* 4843 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4846 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4855
/* 4851 */    MCD::OPC_Decode, 226, 6, 116, // Opcode: MOV32di
/* 4855 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4864
/* 4860 */    MCD::OPC_Decode, 198, 6, 57, // Opcode: MOV32ai
/* 4864 */    MCD::OPC_Decode, 195, 7, 117, // Opcode: MOV32ri
/* 4868 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 5042
/* 4873 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4876 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 4916
/* 4881 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4884 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4900
/* 4889 */    MCD::OPC_CheckField, 24, 4, 8, 193, 36, 0, // Skip to: 14305
/* 4896 */    MCD::OPC_Decode, 132, 7, 56, // Opcode: MOV32jf
/* 4900 */    MCD::OPC_FilterValue, 1, 184, 36, 0, // Skip to: 14305
/* 4905 */    MCD::OPC_CheckField, 24, 4, 8, 177, 36, 0, // Skip to: 14305
/* 4912 */    MCD::OPC_Decode, 156, 7, 56, // Opcode: MOV32of
/* 4916 */    MCD::OPC_FilterValue, 1, 168, 36, 0, // Skip to: 14305
/* 4921 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4924 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 4950
/* 4929 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4932 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4941
/* 4937 */    MCD::OPC_Decode, 129, 7, 57, // Opcode: MOV32jb
/* 4941 */    MCD::OPC_FilterValue, 1, 143, 36, 0, // Skip to: 14305
/* 4946 */    MCD::OPC_Decode, 153, 7, 57, // Opcode: MOV32ob
/* 4950 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 4976
/* 4955 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4958 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4967
/* 4963 */    MCD::OPC_Decode, 138, 7, 58, // Opcode: MOV32jq
/* 4967 */    MCD::OPC_FilterValue, 1, 117, 36, 0, // Skip to: 14305
/* 4972 */    MCD::OPC_Decode, 162, 7, 58, // Opcode: MOV32oq
/* 4976 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 5016
/* 4981 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4984 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5000
/* 4989 */    MCD::OPC_CheckField, 24, 4, 8, 93, 36, 0, // Skip to: 14305
/* 4996 */    MCD::OPC_Decode, 135, 7, 59, // Opcode: MOV32jk
/* 5000 */    MCD::OPC_FilterValue, 1, 84, 36, 0, // Skip to: 14305
/* 5005 */    MCD::OPC_CheckField, 24, 4, 8, 77, 36, 0, // Skip to: 14305
/* 5012 */    MCD::OPC_Decode, 159, 7, 59, // Opcode: MOV32ok
/* 5016 */    MCD::OPC_FilterValue, 4, 68, 36, 0, // Skip to: 14305
/* 5021 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5024 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5033
/* 5029 */    MCD::OPC_Decode, 133, 7, 57, // Opcode: MOV32ji
/* 5033 */    MCD::OPC_FilterValue, 1, 51, 36, 0, // Skip to: 14305
/* 5038 */    MCD::OPC_Decode, 157, 7, 57, // Opcode: MOV32oi
/* 5042 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 5216
/* 5047 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5050 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 5090
/* 5055 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5058 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5074
/* 5063 */    MCD::OPC_CheckField, 24, 4, 8, 19, 36, 0, // Skip to: 14305
/* 5070 */    MCD::OPC_Decode, 236, 6, 56, // Opcode: MOV32ef
/* 5074 */    MCD::OPC_FilterValue, 1, 10, 36, 0, // Skip to: 14305
/* 5079 */    MCD::OPC_CheckField, 24, 4, 8, 3, 36, 0, // Skip to: 14305
/* 5086 */    MCD::OPC_Decode, 168, 7, 64, // Opcode: MOV32pf
/* 5090 */    MCD::OPC_FilterValue, 1, 250, 35, 0, // Skip to: 14305
/* 5095 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 5098 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 5124
/* 5103 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5106 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5115
/* 5111 */    MCD::OPC_Decode, 233, 6, 57, // Opcode: MOV32eb
/* 5115 */    MCD::OPC_FilterValue, 1, 225, 35, 0, // Skip to: 14305
/* 5120 */    MCD::OPC_Decode, 165, 7, 65, // Opcode: MOV32pb
/* 5124 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 5150
/* 5129 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5132 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5141
/* 5137 */    MCD::OPC_Decode, 242, 6, 58, // Opcode: MOV32eq
/* 5141 */    MCD::OPC_FilterValue, 1, 199, 35, 0, // Skip to: 14305
/* 5146 */    MCD::OPC_Decode, 174, 7, 66, // Opcode: MOV32pq
/* 5150 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 5190
/* 5155 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5158 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5174
/* 5163 */    MCD::OPC_CheckField, 24, 4, 8, 175, 35, 0, // Skip to: 14305
/* 5170 */    MCD::OPC_Decode, 239, 6, 59, // Opcode: MOV32ek
/* 5174 */    MCD::OPC_FilterValue, 1, 166, 35, 0, // Skip to: 14305
/* 5179 */    MCD::OPC_CheckField, 24, 4, 8, 159, 35, 0, // Skip to: 14305
/* 5186 */    MCD::OPC_Decode, 171, 7, 67, // Opcode: MOV32pk
/* 5190 */    MCD::OPC_FilterValue, 4, 150, 35, 0, // Skip to: 14305
/* 5195 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5198 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5207
/* 5203 */    MCD::OPC_Decode, 237, 6, 57, // Opcode: MOV32ei
/* 5207 */    MCD::OPC_FilterValue, 1, 133, 35, 0, // Skip to: 14305
/* 5212 */    MCD::OPC_Decode, 169, 7, 65, // Opcode: MOV32pi
/* 5216 */    MCD::OPC_FilterValue, 3, 124, 35, 0, // Skip to: 14305
/* 5221 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5224 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 5318
/* 5229 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5232 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 5255
/* 5237 */    MCD::OPC_CheckField, 40, 4, 8, 101, 35, 0, // Skip to: 14305
/* 5244 */    MCD::OPC_CheckField, 24, 4, 8, 94, 35, 0, // Skip to: 14305
/* 5251 */    MCD::OPC_Decode, 248, 6, 72, // Opcode: MOV32ff
/* 5255 */    MCD::OPC_FilterValue, 1, 85, 35, 0, // Skip to: 14305
/* 5260 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5263 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 5279
/* 5268 */    MCD::OPC_CheckField, 24, 4, 8, 70, 35, 0, // Skip to: 14305
/* 5275 */    MCD::OPC_Decode, 214, 6, 84, // Opcode: MOV32bf
/* 5279 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 5295
/* 5284 */    MCD::OPC_CheckField, 24, 4, 8, 54, 35, 0, // Skip to: 14305
/* 5291 */    MCD::OPC_Decode, 180, 7, 85, // Opcode: MOV32qf
/* 5295 */    MCD::OPC_FilterValue, 3, 45, 35, 0, // Skip to: 14305
/* 5300 */    MCD::OPC_CheckField, 40, 4, 8, 38, 35, 0, // Skip to: 14305
/* 5307 */    MCD::OPC_CheckField, 24, 4, 8, 31, 35, 0, // Skip to: 14305
/* 5314 */    MCD::OPC_Decode, 144, 7, 86, // Opcode: MOV32kf
/* 5318 */    MCD::OPC_FilterValue, 1, 22, 35, 0, // Skip to: 14305
/* 5323 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 5326 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 5392
/* 5331 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5334 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5350
/* 5339 */    MCD::OPC_CheckField, 56, 4, 8, 255, 34, 0, // Skip to: 14305
/* 5346 */    MCD::OPC_Decode, 245, 6, 73, // Opcode: MOV32fb
/* 5350 */    MCD::OPC_FilterValue, 1, 246, 34, 0, // Skip to: 14305
/* 5355 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5358 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5367
/* 5363 */    MCD::OPC_Decode, 211, 6, 87, // Opcode: MOV32bb
/* 5367 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5376
/* 5372 */    MCD::OPC_Decode, 177, 7, 88, // Opcode: MOV32qb
/* 5376 */    MCD::OPC_FilterValue, 3, 220, 34, 0, // Skip to: 14305
/* 5381 */    MCD::OPC_CheckField, 56, 4, 8, 213, 34, 0, // Skip to: 14305
/* 5388 */    MCD::OPC_Decode, 141, 7, 89, // Opcode: MOV32kb
/* 5392 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 5458
/* 5397 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5400 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5416
/* 5405 */    MCD::OPC_CheckField, 40, 4, 8, 189, 34, 0, // Skip to: 14305
/* 5412 */    MCD::OPC_Decode, 254, 6, 74, // Opcode: MOV32fq
/* 5416 */    MCD::OPC_FilterValue, 1, 180, 34, 0, // Skip to: 14305
/* 5421 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5424 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5433
/* 5429 */    MCD::OPC_Decode, 220, 6, 90, // Opcode: MOV32bq
/* 5433 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5442
/* 5438 */    MCD::OPC_Decode, 186, 7, 91, // Opcode: MOV32qq
/* 5442 */    MCD::OPC_FilterValue, 3, 154, 34, 0, // Skip to: 14305
/* 5447 */    MCD::OPC_CheckField, 40, 4, 8, 147, 34, 0, // Skip to: 14305
/* 5454 */    MCD::OPC_Decode, 150, 7, 92, // Opcode: MOV32kq
/* 5458 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 5552
/* 5463 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5466 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 5489
/* 5471 */    MCD::OPC_CheckField, 40, 4, 8, 123, 34, 0, // Skip to: 14305
/* 5478 */    MCD::OPC_CheckField, 24, 4, 8, 116, 34, 0, // Skip to: 14305
/* 5485 */    MCD::OPC_Decode, 251, 6, 75, // Opcode: MOV32fk
/* 5489 */    MCD::OPC_FilterValue, 1, 107, 34, 0, // Skip to: 14305
/* 5494 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5497 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 5513
/* 5502 */    MCD::OPC_CheckField, 24, 4, 8, 92, 34, 0, // Skip to: 14305
/* 5509 */    MCD::OPC_Decode, 217, 6, 93, // Opcode: MOV32bk
/* 5513 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 5529
/* 5518 */    MCD::OPC_CheckField, 24, 4, 8, 76, 34, 0, // Skip to: 14305
/* 5525 */    MCD::OPC_Decode, 183, 7, 94, // Opcode: MOV32qk
/* 5529 */    MCD::OPC_FilterValue, 3, 67, 34, 0, // Skip to: 14305
/* 5534 */    MCD::OPC_CheckField, 40, 4, 8, 60, 34, 0, // Skip to: 14305
/* 5541 */    MCD::OPC_CheckField, 24, 4, 8, 53, 34, 0, // Skip to: 14305
/* 5548 */    MCD::OPC_Decode, 147, 7, 95, // Opcode: MOV32kk
/* 5552 */    MCD::OPC_FilterValue, 4, 44, 34, 0, // Skip to: 14305
/* 5557 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5560 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5576
/* 5565 */    MCD::OPC_CheckField, 56, 4, 8, 29, 34, 0, // Skip to: 14305
/* 5572 */    MCD::OPC_Decode, 249, 6, 73, // Opcode: MOV32fi
/* 5576 */    MCD::OPC_FilterValue, 1, 20, 34, 0, // Skip to: 14305
/* 5581 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5584 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5593
/* 5589 */    MCD::OPC_Decode, 215, 6, 87, // Opcode: MOV32bi
/* 5593 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5602
/* 5598 */    MCD::OPC_Decode, 181, 7, 88, // Opcode: MOV32qi
/* 5602 */    MCD::OPC_FilterValue, 3, 250, 33, 0, // Skip to: 14305
/* 5607 */    MCD::OPC_CheckField, 56, 4, 8, 243, 33, 0, // Skip to: 14305
/* 5614 */    MCD::OPC_Decode, 145, 7, 89, // Opcode: MOV32ki
/* 5618 */    MCD::OPC_FilterValue, 3, 225, 7, 0, // Skip to: 7640
/* 5623 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 5626 */    MCD::OPC_FilterValue, 0, 114, 1, 0, // Skip to: 6001
/* 5631 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5634 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 5693
/* 5639 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5642 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5658
/* 5647 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 5678
/* 5654 */    MCD::OPC_Decode, 200, 5, 122, // Opcode: MOV16dd
/* 5658 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 5678
/* 5663 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 5674
/* 5670 */    MCD::OPC_Decode, 157, 5, 123, // Opcode: MOV16aa
/* 5674 */    MCD::OPC_Decode, 172, 6, 124, // Opcode: MOV16ra
/* 5678 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 5689
/* 5685 */    MCD::OPC_Decode, 175, 5, 125, // Opcode: MOV16ar
/* 5689 */    MCD::OPC_Decode, 190, 6, 126, // Opcode: MOV16rr
/* 5693 */    MCD::OPC_FilterValue, 1, 67, 0, 0, // Skip to: 5765
/* 5698 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5701 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 5733
/* 5706 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5709 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5718
/* 5714 */    MCD::OPC_Decode, 238, 5, 127, // Opcode: MOV16jd
/* 5718 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5728
/* 5723 */    MCD::OPC_Decode, 235, 5, 128, 1, // Opcode: MOV16ja
/* 5728 */    MCD::OPC_Decode, 247, 5, 129, 1, // Opcode: MOV16jr
/* 5733 */    MCD::OPC_FilterValue, 1, 119, 33, 0, // Skip to: 14305
/* 5738 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5741 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5750
/* 5746 */    MCD::OPC_Decode, 136, 6, 127, // Opcode: MOV16od
/* 5750 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5760
/* 5755 */    MCD::OPC_Decode, 133, 6, 128, 1, // Opcode: MOV16oa
/* 5760 */    MCD::OPC_Decode, 145, 6, 129, 1, // Opcode: MOV16or
/* 5765 */    MCD::OPC_FilterValue, 2, 68, 0, 0, // Skip to: 5838
/* 5770 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5773 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 5805
/* 5778 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5781 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5790
/* 5786 */    MCD::OPC_Decode, 212, 5, 127, // Opcode: MOV16ed
/* 5790 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5800
/* 5795 */    MCD::OPC_Decode, 209, 5, 128, 1, // Opcode: MOV16ea
/* 5800 */    MCD::OPC_Decode, 221, 5, 129, 1, // Opcode: MOV16er
/* 5805 */    MCD::OPC_FilterValue, 1, 47, 33, 0, // Skip to: 14305
/* 5810 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5813 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5823
/* 5818 */    MCD::OPC_Decode, 149, 6, 130, 1, // Opcode: MOV16pd
/* 5823 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5833
/* 5828 */    MCD::OPC_Decode, 146, 6, 131, 1, // Opcode: MOV16pa
/* 5833 */    MCD::OPC_Decode, 158, 6, 132, 1, // Opcode: MOV16pr
/* 5838 */    MCD::OPC_FilterValue, 3, 14, 33, 0, // Skip to: 14305
/* 5843 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5846 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 5887
/* 5851 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5854 */    MCD::OPC_FilterValue, 8, 254, 32, 0, // Skip to: 14305
/* 5859 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5862 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5872
/* 5867 */    MCD::OPC_Decode, 225, 5, 133, 1, // Opcode: MOV16fd
/* 5872 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5882
/* 5877 */    MCD::OPC_Decode, 222, 5, 134, 1, // Opcode: MOV16fa
/* 5882 */    MCD::OPC_Decode, 234, 5, 135, 1, // Opcode: MOV16fr
/* 5887 */    MCD::OPC_FilterValue, 1, 221, 32, 0, // Skip to: 14305
/* 5892 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5895 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 5928
/* 5900 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5903 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5913
/* 5908 */    MCD::OPC_Decode, 179, 5, 136, 1, // Opcode: MOV16bd
/* 5913 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5923
/* 5918 */    MCD::OPC_Decode, 176, 5, 137, 1, // Opcode: MOV16ba
/* 5923 */    MCD::OPC_Decode, 188, 5, 138, 1, // Opcode: MOV16br
/* 5928 */    MCD::OPC_FilterValue, 2, 27, 0, 0, // Skip to: 5960
/* 5933 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5936 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5945
/* 5941 */    MCD::OPC_Decode, 162, 6, 15, // Opcode: MOV16qd
/* 5945 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5955
/* 5950 */    MCD::OPC_Decode, 159, 6, 139, 1, // Opcode: MOV16qa
/* 5955 */    MCD::OPC_Decode, 171, 6, 140, 1, // Opcode: MOV16qr
/* 5960 */    MCD::OPC_FilterValue, 3, 148, 32, 0, // Skip to: 14305
/* 5965 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5968 */    MCD::OPC_FilterValue, 8, 140, 32, 0, // Skip to: 14305
/* 5973 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5976 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5986
/* 5981 */    MCD::OPC_Decode, 251, 5, 141, 1, // Opcode: MOV16kd
/* 5986 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5996
/* 5991 */    MCD::OPC_Decode, 248, 5, 142, 1, // Opcode: MOV16ka
/* 5996 */    MCD::OPC_Decode, 132, 6, 143, 1, // Opcode: MOV16kr
/* 6001 */    MCD::OPC_FilterValue, 1, 81, 1, 0, // Skip to: 6343
/* 6006 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6009 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 6083
/* 6014 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6017 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6050
/* 6022 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6025 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6035
/* 6030 */    MCD::OPC_Decode, 204, 5, 144, 1, // Opcode: MOV16dj
/* 6035 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6045
/* 6040 */    MCD::OPC_Decode, 165, 5, 145, 1, // Opcode: MOV16aj
/* 6045 */    MCD::OPC_Decode, 180, 6, 146, 1, // Opcode: MOV16rj
/* 6050 */    MCD::OPC_FilterValue, 1, 58, 32, 0, // Skip to: 14305
/* 6055 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6058 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6068
/* 6063 */    MCD::OPC_Decode, 206, 5, 144, 1, // Opcode: MOV16do
/* 6068 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6078
/* 6073 */    MCD::OPC_Decode, 169, 5, 145, 1, // Opcode: MOV16ao
/* 6078 */    MCD::OPC_Decode, 184, 6, 146, 1, // Opcode: MOV16ro
/* 6083 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 6143
/* 6088 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6091 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6117
/* 6096 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6099 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6108
/* 6104 */    MCD::OPC_Decode, 242, 5, 54, // Opcode: MOV16jj
/* 6108 */    MCD::OPC_FilterValue, 1, 0, 32, 0, // Skip to: 14305
/* 6113 */    MCD::OPC_Decode, 140, 6, 54, // Opcode: MOV16oj
/* 6117 */    MCD::OPC_FilterValue, 1, 247, 31, 0, // Skip to: 14305
/* 6122 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6125 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6134
/* 6130 */    MCD::OPC_Decode, 244, 5, 54, // Opcode: MOV16jo
/* 6134 */    MCD::OPC_FilterValue, 1, 230, 31, 0, // Skip to: 14305
/* 6139 */    MCD::OPC_Decode, 142, 6, 54, // Opcode: MOV16oo
/* 6143 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 6203
/* 6148 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6151 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6177
/* 6156 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6159 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6168
/* 6164 */    MCD::OPC_Decode, 216, 5, 54, // Opcode: MOV16ej
/* 6168 */    MCD::OPC_FilterValue, 1, 196, 31, 0, // Skip to: 14305
/* 6173 */    MCD::OPC_Decode, 153, 6, 62, // Opcode: MOV16pj
/* 6177 */    MCD::OPC_FilterValue, 1, 187, 31, 0, // Skip to: 14305
/* 6182 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6185 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6194
/* 6190 */    MCD::OPC_Decode, 218, 5, 54, // Opcode: MOV16eo
/* 6194 */    MCD::OPC_FilterValue, 1, 170, 31, 0, // Skip to: 14305
/* 6199 */    MCD::OPC_Decode, 155, 6, 62, // Opcode: MOV16po
/* 6203 */    MCD::OPC_FilterValue, 3, 161, 31, 0, // Skip to: 14305
/* 6208 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6211 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 6277
/* 6216 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6219 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6235
/* 6224 */    MCD::OPC_CheckField, 24, 4, 8, 138, 31, 0, // Skip to: 14305
/* 6231 */    MCD::OPC_Decode, 229, 5, 70, // Opcode: MOV16fj
/* 6235 */    MCD::OPC_FilterValue, 1, 129, 31, 0, // Skip to: 14305
/* 6240 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6243 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6252
/* 6248 */    MCD::OPC_Decode, 183, 5, 28, // Opcode: MOV16bj
/* 6252 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6261
/* 6257 */    MCD::OPC_Decode, 166, 6, 17, // Opcode: MOV16qj
/* 6261 */    MCD::OPC_FilterValue, 3, 103, 31, 0, // Skip to: 14305
/* 6266 */    MCD::OPC_CheckField, 24, 4, 8, 96, 31, 0, // Skip to: 14305
/* 6273 */    MCD::OPC_Decode, 255, 5, 80, // Opcode: MOV16kj
/* 6277 */    MCD::OPC_FilterValue, 1, 87, 31, 0, // Skip to: 14305
/* 6282 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6285 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6301
/* 6290 */    MCD::OPC_CheckField, 24, 4, 8, 72, 31, 0, // Skip to: 14305
/* 6297 */    MCD::OPC_Decode, 231, 5, 70, // Opcode: MOV16fo
/* 6301 */    MCD::OPC_FilterValue, 1, 63, 31, 0, // Skip to: 14305
/* 6306 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6309 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6318
/* 6314 */    MCD::OPC_Decode, 185, 5, 28, // Opcode: MOV16bo
/* 6318 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6327
/* 6323 */    MCD::OPC_Decode, 168, 6, 17, // Opcode: MOV16qo
/* 6327 */    MCD::OPC_FilterValue, 3, 37, 31, 0, // Skip to: 14305
/* 6332 */    MCD::OPC_CheckField, 24, 4, 8, 30, 31, 0, // Skip to: 14305
/* 6339 */    MCD::OPC_Decode, 129, 6, 80, // Opcode: MOV16ko
/* 6343 */    MCD::OPC_FilterValue, 2, 81, 1, 0, // Skip to: 6685
/* 6348 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6351 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 6425
/* 6356 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6359 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6392
/* 6364 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6367 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6377
/* 6372 */    MCD::OPC_Decode, 201, 5, 144, 1, // Opcode: MOV16de
/* 6377 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6387
/* 6382 */    MCD::OPC_Decode, 160, 5, 145, 1, // Opcode: MOV16ae
/* 6387 */    MCD::OPC_Decode, 175, 6, 146, 1, // Opcode: MOV16re
/* 6392 */    MCD::OPC_FilterValue, 1, 228, 30, 0, // Skip to: 14305
/* 6397 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6400 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6410
/* 6405 */    MCD::OPC_Decode, 207, 5, 147, 1, // Opcode: MOV16dp
/* 6410 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6420
/* 6415 */    MCD::OPC_Decode, 171, 5, 148, 1, // Opcode: MOV16ap
/* 6420 */    MCD::OPC_Decode, 186, 6, 149, 1, // Opcode: MOV16rp
/* 6425 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 6485
/* 6430 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6433 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6459
/* 6438 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6441 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6450
/* 6446 */    MCD::OPC_Decode, 239, 5, 54, // Opcode: MOV16je
/* 6450 */    MCD::OPC_FilterValue, 1, 170, 30, 0, // Skip to: 14305
/* 6455 */    MCD::OPC_Decode, 137, 6, 54, // Opcode: MOV16oe
/* 6459 */    MCD::OPC_FilterValue, 1, 161, 30, 0, // Skip to: 14305
/* 6464 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6467 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6476
/* 6472 */    MCD::OPC_Decode, 245, 5, 55, // Opcode: MOV16jp
/* 6476 */    MCD::OPC_FilterValue, 1, 144, 30, 0, // Skip to: 14305
/* 6481 */    MCD::OPC_Decode, 143, 6, 55, // Opcode: MOV16op
/* 6485 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 6545
/* 6490 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6493 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 6519
/* 6498 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6501 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6510
/* 6506 */    MCD::OPC_Decode, 213, 5, 54, // Opcode: MOV16ee
/* 6510 */    MCD::OPC_FilterValue, 1, 110, 30, 0, // Skip to: 14305
/* 6515 */    MCD::OPC_Decode, 150, 6, 62, // Opcode: MOV16pe
/* 6519 */    MCD::OPC_FilterValue, 1, 101, 30, 0, // Skip to: 14305
/* 6524 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6527 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6536
/* 6532 */    MCD::OPC_Decode, 219, 5, 55, // Opcode: MOV16ep
/* 6536 */    MCD::OPC_FilterValue, 1, 84, 30, 0, // Skip to: 14305
/* 6541 */    MCD::OPC_Decode, 156, 6, 63, // Opcode: MOV16pp
/* 6545 */    MCD::OPC_FilterValue, 3, 75, 30, 0, // Skip to: 14305
/* 6550 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6553 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 6619
/* 6558 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6561 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6577
/* 6566 */    MCD::OPC_CheckField, 24, 4, 8, 52, 30, 0, // Skip to: 14305
/* 6573 */    MCD::OPC_Decode, 226, 5, 70, // Opcode: MOV16fe
/* 6577 */    MCD::OPC_FilterValue, 1, 43, 30, 0, // Skip to: 14305
/* 6582 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6585 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6594
/* 6590 */    MCD::OPC_Decode, 180, 5, 28, // Opcode: MOV16be
/* 6594 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6603
/* 6599 */    MCD::OPC_Decode, 163, 6, 17, // Opcode: MOV16qe
/* 6603 */    MCD::OPC_FilterValue, 3, 17, 30, 0, // Skip to: 14305
/* 6608 */    MCD::OPC_CheckField, 24, 4, 8, 10, 30, 0, // Skip to: 14305
/* 6615 */    MCD::OPC_Decode, 252, 5, 80, // Opcode: MOV16ke
/* 6619 */    MCD::OPC_FilterValue, 1, 1, 30, 0, // Skip to: 14305
/* 6624 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6627 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6643
/* 6632 */    MCD::OPC_CheckField, 40, 4, 8, 242, 29, 0, // Skip to: 14305
/* 6639 */    MCD::OPC_Decode, 232, 5, 71, // Opcode: MOV16fp
/* 6643 */    MCD::OPC_FilterValue, 1, 233, 29, 0, // Skip to: 14305
/* 6648 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6651 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6660
/* 6656 */    MCD::OPC_Decode, 186, 5, 81, // Opcode: MOV16bp
/* 6660 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6669
/* 6665 */    MCD::OPC_Decode, 169, 6, 82, // Opcode: MOV16qp
/* 6669 */    MCD::OPC_FilterValue, 3, 207, 29, 0, // Skip to: 14305
/* 6674 */    MCD::OPC_CheckField, 40, 4, 8, 200, 29, 0, // Skip to: 14305
/* 6681 */    MCD::OPC_Decode, 130, 6, 83, // Opcode: MOV16kp
/* 6685 */    MCD::OPC_FilterValue, 3, 191, 29, 0, // Skip to: 14305
/* 6690 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6693 */    MCD::OPC_FilterValue, 0, 192, 0, 0, // Skip to: 6890
/* 6698 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6701 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 6742
/* 6706 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6709 */    MCD::OPC_FilterValue, 8, 167, 29, 0, // Skip to: 14305
/* 6714 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6717 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6727
/* 6722 */    MCD::OPC_Decode, 202, 5, 150, 1, // Opcode: MOV16df
/* 6727 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6737
/* 6732 */    MCD::OPC_Decode, 162, 5, 151, 1, // Opcode: MOV16af
/* 6737 */    MCD::OPC_Decode, 177, 6, 152, 1, // Opcode: MOV16rf
/* 6742 */    MCD::OPC_FilterValue, 1, 134, 29, 0, // Skip to: 14305
/* 6747 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6750 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 6783
/* 6755 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6758 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6768
/* 6763 */    MCD::OPC_Decode, 198, 5, 153, 1, // Opcode: MOV16db
/* 6768 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6778
/* 6773 */    MCD::OPC_Decode, 158, 5, 154, 1, // Opcode: MOV16ab
/* 6778 */    MCD::OPC_Decode, 173, 6, 155, 1, // Opcode: MOV16rb
/* 6783 */    MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 6816
/* 6788 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6791 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6801
/* 6796 */    MCD::OPC_Decode, 208, 5, 156, 1, // Opcode: MOV16dq
/* 6801 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6811
/* 6806 */    MCD::OPC_Decode, 173, 5, 157, 1, // Opcode: MOV16aq
/* 6811 */    MCD::OPC_Decode, 188, 6, 158, 1, // Opcode: MOV16rq
/* 6816 */    MCD::OPC_FilterValue, 3, 36, 0, 0, // Skip to: 6857
/* 6821 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6824 */    MCD::OPC_FilterValue, 8, 52, 29, 0, // Skip to: 14305
/* 6829 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6832 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6842
/* 6837 */    MCD::OPC_Decode, 205, 5, 159, 1, // Opcode: MOV16dk
/* 6842 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6852
/* 6847 */    MCD::OPC_Decode, 167, 5, 160, 1, // Opcode: MOV16ak
/* 6852 */    MCD::OPC_Decode, 182, 6, 161, 1, // Opcode: MOV16rk
/* 6857 */    MCD::OPC_FilterValue, 4, 19, 29, 0, // Skip to: 14305
/* 6862 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6865 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6875
/* 6870 */    MCD::OPC_Decode, 203, 5, 156, 1, // Opcode: MOV16di
/* 6875 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6885
/* 6880 */    MCD::OPC_Decode, 164, 5, 157, 1, // Opcode: MOV16ai
/* 6885 */    MCD::OPC_Decode, 179, 6, 158, 1, // Opcode: MOV16ri
/* 6890 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 7064
/* 6895 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6898 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 6938
/* 6903 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6906 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6922
/* 6911 */    MCD::OPC_CheckField, 24, 4, 8, 219, 28, 0, // Skip to: 14305
/* 6918 */    MCD::OPC_Decode, 240, 5, 56, // Opcode: MOV16jf
/* 6922 */    MCD::OPC_FilterValue, 1, 210, 28, 0, // Skip to: 14305
/* 6927 */    MCD::OPC_CheckField, 24, 4, 8, 203, 28, 0, // Skip to: 14305
/* 6934 */    MCD::OPC_Decode, 138, 6, 56, // Opcode: MOV16of
/* 6938 */    MCD::OPC_FilterValue, 1, 194, 28, 0, // Skip to: 14305
/* 6943 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6946 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 6972
/* 6951 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6954 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6963
/* 6959 */    MCD::OPC_Decode, 236, 5, 57, // Opcode: MOV16jb
/* 6963 */    MCD::OPC_FilterValue, 1, 169, 28, 0, // Skip to: 14305
/* 6968 */    MCD::OPC_Decode, 134, 6, 57, // Opcode: MOV16ob
/* 6972 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 6998
/* 6977 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6980 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6989
/* 6985 */    MCD::OPC_Decode, 246, 5, 58, // Opcode: MOV16jq
/* 6989 */    MCD::OPC_FilterValue, 1, 143, 28, 0, // Skip to: 14305
/* 6994 */    MCD::OPC_Decode, 144, 6, 58, // Opcode: MOV16oq
/* 6998 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 7038
/* 7003 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7006 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7022
/* 7011 */    MCD::OPC_CheckField, 24, 4, 8, 119, 28, 0, // Skip to: 14305
/* 7018 */    MCD::OPC_Decode, 243, 5, 59, // Opcode: MOV16jk
/* 7022 */    MCD::OPC_FilterValue, 1, 110, 28, 0, // Skip to: 14305
/* 7027 */    MCD::OPC_CheckField, 24, 4, 8, 103, 28, 0, // Skip to: 14305
/* 7034 */    MCD::OPC_Decode, 141, 6, 59, // Opcode: MOV16ok
/* 7038 */    MCD::OPC_FilterValue, 4, 94, 28, 0, // Skip to: 14305
/* 7043 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7046 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7055
/* 7051 */    MCD::OPC_Decode, 241, 5, 58, // Opcode: MOV16ji
/* 7055 */    MCD::OPC_FilterValue, 1, 77, 28, 0, // Skip to: 14305
/* 7060 */    MCD::OPC_Decode, 139, 6, 58, // Opcode: MOV16oi
/* 7064 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 7238
/* 7069 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7072 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 7112
/* 7077 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7080 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7096
/* 7085 */    MCD::OPC_CheckField, 24, 4, 8, 45, 28, 0, // Skip to: 14305
/* 7092 */    MCD::OPC_Decode, 214, 5, 56, // Opcode: MOV16ef
/* 7096 */    MCD::OPC_FilterValue, 1, 36, 28, 0, // Skip to: 14305
/* 7101 */    MCD::OPC_CheckField, 24, 4, 8, 29, 28, 0, // Skip to: 14305
/* 7108 */    MCD::OPC_Decode, 151, 6, 64, // Opcode: MOV16pf
/* 7112 */    MCD::OPC_FilterValue, 1, 20, 28, 0, // Skip to: 14305
/* 7117 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7120 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 7146
/* 7125 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7128 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7137
/* 7133 */    MCD::OPC_Decode, 210, 5, 57, // Opcode: MOV16eb
/* 7137 */    MCD::OPC_FilterValue, 1, 251, 27, 0, // Skip to: 14305
/* 7142 */    MCD::OPC_Decode, 147, 6, 65, // Opcode: MOV16pb
/* 7146 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 7172
/* 7151 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7154 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7163
/* 7159 */    MCD::OPC_Decode, 220, 5, 58, // Opcode: MOV16eq
/* 7163 */    MCD::OPC_FilterValue, 1, 225, 27, 0, // Skip to: 14305
/* 7168 */    MCD::OPC_Decode, 157, 6, 66, // Opcode: MOV16pq
/* 7172 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 7212
/* 7177 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7180 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7196
/* 7185 */    MCD::OPC_CheckField, 24, 4, 8, 201, 27, 0, // Skip to: 14305
/* 7192 */    MCD::OPC_Decode, 217, 5, 59, // Opcode: MOV16ek
/* 7196 */    MCD::OPC_FilterValue, 1, 192, 27, 0, // Skip to: 14305
/* 7201 */    MCD::OPC_CheckField, 24, 4, 8, 185, 27, 0, // Skip to: 14305
/* 7208 */    MCD::OPC_Decode, 154, 6, 67, // Opcode: MOV16pk
/* 7212 */    MCD::OPC_FilterValue, 4, 176, 27, 0, // Skip to: 14305
/* 7217 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7220 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7229
/* 7225 */    MCD::OPC_Decode, 215, 5, 58, // Opcode: MOV16ei
/* 7229 */    MCD::OPC_FilterValue, 1, 159, 27, 0, // Skip to: 14305
/* 7234 */    MCD::OPC_Decode, 152, 6, 66, // Opcode: MOV16pi
/* 7238 */    MCD::OPC_FilterValue, 3, 150, 27, 0, // Skip to: 14305
/* 7243 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7246 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 7340
/* 7251 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7254 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7277
/* 7259 */    MCD::OPC_CheckField, 40, 4, 8, 127, 27, 0, // Skip to: 14305
/* 7266 */    MCD::OPC_CheckField, 24, 4, 8, 120, 27, 0, // Skip to: 14305
/* 7273 */    MCD::OPC_Decode, 227, 5, 72, // Opcode: MOV16ff
/* 7277 */    MCD::OPC_FilterValue, 1, 111, 27, 0, // Skip to: 14305
/* 7282 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7285 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 7301
/* 7290 */    MCD::OPC_CheckField, 24, 4, 8, 96, 27, 0, // Skip to: 14305
/* 7297 */    MCD::OPC_Decode, 181, 5, 84, // Opcode: MOV16bf
/* 7301 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 7317
/* 7306 */    MCD::OPC_CheckField, 24, 4, 8, 80, 27, 0, // Skip to: 14305
/* 7313 */    MCD::OPC_Decode, 164, 6, 85, // Opcode: MOV16qf
/* 7317 */    MCD::OPC_FilterValue, 3, 71, 27, 0, // Skip to: 14305
/* 7322 */    MCD::OPC_CheckField, 40, 4, 8, 64, 27, 0, // Skip to: 14305
/* 7329 */    MCD::OPC_CheckField, 24, 4, 8, 57, 27, 0, // Skip to: 14305
/* 7336 */    MCD::OPC_Decode, 253, 5, 86, // Opcode: MOV16kf
/* 7340 */    MCD::OPC_FilterValue, 1, 48, 27, 0, // Skip to: 14305
/* 7345 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7348 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 7414
/* 7353 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7356 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7372
/* 7361 */    MCD::OPC_CheckField, 56, 4, 8, 25, 27, 0, // Skip to: 14305
/* 7368 */    MCD::OPC_Decode, 223, 5, 73, // Opcode: MOV16fb
/* 7372 */    MCD::OPC_FilterValue, 1, 16, 27, 0, // Skip to: 14305
/* 7377 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7380 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7389
/* 7385 */    MCD::OPC_Decode, 177, 5, 87, // Opcode: MOV16bb
/* 7389 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7398
/* 7394 */    MCD::OPC_Decode, 160, 6, 88, // Opcode: MOV16qb
/* 7398 */    MCD::OPC_FilterValue, 3, 246, 26, 0, // Skip to: 14305
/* 7403 */    MCD::OPC_CheckField, 56, 4, 8, 239, 26, 0, // Skip to: 14305
/* 7410 */    MCD::OPC_Decode, 249, 5, 89, // Opcode: MOV16kb
/* 7414 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 7480
/* 7419 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7422 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7438
/* 7427 */    MCD::OPC_CheckField, 40, 4, 8, 215, 26, 0, // Skip to: 14305
/* 7434 */    MCD::OPC_Decode, 233, 5, 74, // Opcode: MOV16fq
/* 7438 */    MCD::OPC_FilterValue, 1, 206, 26, 0, // Skip to: 14305
/* 7443 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7446 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7455
/* 7451 */    MCD::OPC_Decode, 187, 5, 90, // Opcode: MOV16bq
/* 7455 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7464
/* 7460 */    MCD::OPC_Decode, 170, 6, 91, // Opcode: MOV16qq
/* 7464 */    MCD::OPC_FilterValue, 3, 180, 26, 0, // Skip to: 14305
/* 7469 */    MCD::OPC_CheckField, 40, 4, 8, 173, 26, 0, // Skip to: 14305
/* 7476 */    MCD::OPC_Decode, 131, 6, 92, // Opcode: MOV16kq
/* 7480 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 7574
/* 7485 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7488 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7511
/* 7493 */    MCD::OPC_CheckField, 40, 4, 8, 149, 26, 0, // Skip to: 14305
/* 7500 */    MCD::OPC_CheckField, 24, 4, 8, 142, 26, 0, // Skip to: 14305
/* 7507 */    MCD::OPC_Decode, 230, 5, 75, // Opcode: MOV16fk
/* 7511 */    MCD::OPC_FilterValue, 1, 133, 26, 0, // Skip to: 14305
/* 7516 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7519 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 7535
/* 7524 */    MCD::OPC_CheckField, 24, 4, 8, 118, 26, 0, // Skip to: 14305
/* 7531 */    MCD::OPC_Decode, 184, 5, 93, // Opcode: MOV16bk
/* 7535 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 7551
/* 7540 */    MCD::OPC_CheckField, 24, 4, 8, 102, 26, 0, // Skip to: 14305
/* 7547 */    MCD::OPC_Decode, 167, 6, 94, // Opcode: MOV16qk
/* 7551 */    MCD::OPC_FilterValue, 3, 93, 26, 0, // Skip to: 14305
/* 7556 */    MCD::OPC_CheckField, 40, 4, 8, 86, 26, 0, // Skip to: 14305
/* 7563 */    MCD::OPC_CheckField, 24, 4, 8, 79, 26, 0, // Skip to: 14305
/* 7570 */    MCD::OPC_Decode, 128, 6, 95, // Opcode: MOV16kk
/* 7574 */    MCD::OPC_FilterValue, 4, 70, 26, 0, // Skip to: 14305
/* 7579 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 7582 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7598
/* 7587 */    MCD::OPC_CheckField, 40, 4, 8, 55, 26, 0, // Skip to: 14305
/* 7594 */    MCD::OPC_Decode, 228, 5, 74, // Opcode: MOV16fi
/* 7598 */    MCD::OPC_FilterValue, 1, 46, 26, 0, // Skip to: 14305
/* 7603 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7606 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7615
/* 7611 */    MCD::OPC_Decode, 182, 5, 90, // Opcode: MOV16bi
/* 7615 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7624
/* 7620 */    MCD::OPC_Decode, 165, 6, 91, // Opcode: MOV16qi
/* 7624 */    MCD::OPC_FilterValue, 3, 20, 26, 0, // Skip to: 14305
/* 7629 */    MCD::OPC_CheckField, 40, 4, 8, 13, 26, 0, // Skip to: 14305
/* 7636 */    MCD::OPC_Decode, 254, 5, 92, // Opcode: MOV16ki
/* 7640 */    MCD::OPC_FilterValue, 4, 154, 5, 0, // Skip to: 9079
/* 7645 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 7648 */    MCD::OPC_FilterValue, 0, 97, 0, 0, // Skip to: 7750
/* 7653 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7656 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7666
/* 7661 */    MCD::OPC_Decode, 206, 8, 162, 1, // Opcode: NEGX8d
/* 7666 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7676
/* 7671 */    MCD::OPC_Decode, 203, 8, 162, 1, // Opcode: NEG8d
/* 7676 */    MCD::OPC_FilterValue, 4, 12, 0, 0, // Skip to: 7693
/* 7681 */    MCD::OPC_CheckField, 3, 1, 1, 217, 25, 0, // Skip to: 14305
/* 7688 */    MCD::OPC_Decode, 150, 5, 163, 1, // Opcode: LINK32
/* 7693 */    MCD::OPC_FilterValue, 6, 207, 25, 0, // Skip to: 14305
/* 7698 */    MCD::OPC_ExtractField, 16, 12,  // Inst{27-16} ...
/* 7701 */    MCD::OPC_FilterValue, 0, 19, 0, 0, // Skip to: 7725
/* 7706 */    MCD::OPC_CheckField, 31, 1, 0, 192, 25, 0, // Skip to: 14305
/* 7713 */    MCD::OPC_CheckField, 3, 1, 0, 185, 25, 0, // Skip to: 14305
/* 7720 */    MCD::OPC_Decode, 253, 9, 164, 1, // Opcode: UMULd32d32
/* 7725 */    MCD::OPC_FilterValue, 128, 16, 174, 25, 0, // Skip to: 14305
/* 7731 */    MCD::OPC_CheckField, 31, 1, 0, 167, 25, 0, // Skip to: 14305
/* 7738 */    MCD::OPC_CheckField, 3, 1, 0, 160, 25, 0, // Skip to: 14305
/* 7745 */    MCD::OPC_Decode, 193, 9, 164, 1, // Opcode: SMULd32d32
/* 7750 */    MCD::OPC_FilterValue, 4, 107, 0, 0, // Skip to: 7862
/* 7755 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7758 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7768
/* 7763 */    MCD::OPC_Decode, 204, 8, 165, 1, // Opcode: NEGX16d
/* 7768 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7778
/* 7773 */    MCD::OPC_Decode, 201, 8, 165, 1, // Opcode: NEG16d
/* 7778 */    MCD::OPC_FilterValue, 4, 12, 0, 0, // Skip to: 7795
/* 7783 */    MCD::OPC_CheckField, 3, 1, 1, 115, 25, 0, // Skip to: 14305
/* 7790 */    MCD::OPC_Decode, 221, 3, 166, 1, // Opcode: BKPT
/* 7795 */    MCD::OPC_FilterValue, 6, 52, 0, 0, // Skip to: 7852
/* 7800 */    MCD::OPC_ExtractField, 16, 12,  // Inst{27-16} ...
/* 7803 */    MCD::OPC_FilterValue, 0, 19, 0, 0, // Skip to: 7827
/* 7808 */    MCD::OPC_CheckField, 31, 1, 0, 90, 25, 0, // Skip to: 14305
/* 7815 */    MCD::OPC_CheckField, 3, 1, 0, 83, 25, 0, // Skip to: 14305
/* 7822 */    MCD::OPC_Decode, 250, 9, 164, 1, // Opcode: UDIVd32d32
/* 7827 */    MCD::OPC_FilterValue, 128, 16, 72, 25, 0, // Skip to: 14305
/* 7833 */    MCD::OPC_CheckField, 31, 1, 0, 65, 25, 0, // Skip to: 14305
/* 7840 */    MCD::OPC_CheckField, 3, 1, 0, 58, 25, 0, // Skip to: 14305
/* 7847 */    MCD::OPC_Decode, 136, 9, 164, 1, // Opcode: SDIVd32d32
/* 7852 */    MCD::OPC_FilterValue, 7, 48, 25, 0, // Skip to: 14305
/* 7857 */    MCD::OPC_Decode, 247, 9, 167, 1, // Opcode: TRAP
/* 7862 */    MCD::OPC_FilterValue, 5, 37, 0, 0, // Skip to: 7904
/* 7867 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7870 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 7887
/* 7875 */    MCD::OPC_CheckField, 9, 3, 7, 23, 25, 0, // Skip to: 14305
/* 7882 */    MCD::OPC_Decode, 149, 5, 168, 1, // Opcode: LINK16
/* 7887 */    MCD::OPC_FilterValue, 1, 13, 25, 0, // Skip to: 14305
/* 7892 */    MCD::OPC_CheckField, 9, 3, 7, 6, 25, 0, // Skip to: 14305
/* 7899 */    MCD::OPC_Decode, 255, 9, 169, 1, // Opcode: UNLK
/* 7904 */    MCD::OPC_FilterValue, 7, 71, 0, 0, // Skip to: 7980
/* 7909 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 7912 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 7929
/* 7917 */    MCD::OPC_CheckField, 9, 3, 7, 237, 24, 0, // Skip to: 14305
/* 7924 */    MCD::OPC_Decode, 207, 8, 170, 1, // Opcode: NOP
/* 7929 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 7946
/* 7934 */    MCD::OPC_CheckField, 9, 3, 7, 220, 24, 0, // Skip to: 14305
/* 7941 */    MCD::OPC_Decode, 133, 9, 170, 1, // Opcode: RTE
/* 7946 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 7963
/* 7951 */    MCD::OPC_CheckField, 9, 3, 7, 203, 24, 0, // Skip to: 14305
/* 7958 */    MCD::OPC_Decode, 134, 9, 170, 1, // Opcode: RTS
/* 7963 */    MCD::OPC_FilterValue, 6, 193, 24, 0, // Skip to: 14305
/* 7968 */    MCD::OPC_CheckField, 9, 3, 7, 186, 24, 0, // Skip to: 14305
/* 7975 */    MCD::OPC_Decode, 248, 9, 170, 1, // Opcode: TRAPV
/* 7980 */    MCD::OPC_FilterValue, 8, 40, 0, 0, // Skip to: 8025
/* 7985 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7988 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7998
/* 7993 */    MCD::OPC_Decode, 205, 8, 171, 1, // Opcode: NEGX32d
/* 7998 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 8008
/* 8003 */    MCD::OPC_Decode, 202, 8, 171, 1, // Opcode: NEG32d
/* 8008 */    MCD::OPC_FilterValue, 4, 148, 24, 0, // Skip to: 14305
/* 8013 */    MCD::OPC_CheckField, 3, 1, 0, 141, 24, 0, // Skip to: 14305
/* 8020 */    MCD::OPC_Decode, 201, 4, 172, 1, // Opcode: EXT16
/* 8025 */    MCD::OPC_FilterValue, 9, 72, 0, 0, // Skip to: 8102
/* 8030 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8033 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 8059
/* 8038 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8041 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8050
/* 8046 */    MCD::OPC_Decode, 172, 8, 16, // Opcode: MOVM16jm
/* 8050 */    MCD::OPC_FilterValue, 1, 106, 24, 0, // Skip to: 14305
/* 8055 */    MCD::OPC_Decode, 182, 8, 16, // Opcode: MOVM16om
/* 8059 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 8085
/* 8064 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8067 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8076
/* 8072 */    MCD::OPC_Decode, 177, 8, 17, // Opcode: MOVM16mj
/* 8076 */    MCD::OPC_FilterValue, 1, 80, 24, 0, // Skip to: 14305
/* 8081 */    MCD::OPC_Decode, 179, 8, 17, // Opcode: MOVM16mo
/* 8085 */    MCD::OPC_FilterValue, 7, 71, 24, 0, // Skip to: 14305
/* 8090 */    MCD::OPC_CheckField, 3, 1, 0, 64, 24, 0, // Skip to: 14305
/* 8097 */    MCD::OPC_Decode, 156, 4, 169, 1, // Opcode: CALLj
/* 8102 */    MCD::OPC_FilterValue, 10, 55, 0, 0, // Skip to: 8162
/* 8107 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8110 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 8136
/* 8115 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8118 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8127
/* 8123 */    MCD::OPC_Decode, 170, 8, 16, // Opcode: MOVM16em
/* 8127 */    MCD::OPC_FilterValue, 6, 29, 24, 0, // Skip to: 14305
/* 8132 */    MCD::OPC_Decode, 175, 8, 17, // Opcode: MOVM16me
/* 8136 */    MCD::OPC_FilterValue, 1, 20, 24, 0, // Skip to: 14305
/* 8141 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8144 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 8153
/* 8149 */    MCD::OPC_Decode, 183, 8, 18, // Opcode: MOVM16pm
/* 8153 */    MCD::OPC_FilterValue, 6, 3, 24, 0, // Skip to: 14305
/* 8158 */    MCD::OPC_Decode, 180, 8, 19, // Opcode: MOVM16mp
/* 8162 */    MCD::OPC_FilterValue, 11, 180, 0, 0, // Skip to: 8347
/* 8167 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8170 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 8236
/* 8175 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8178 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8194
/* 8183 */    MCD::OPC_CheckField, 40, 4, 8, 227, 23, 0, // Skip to: 14305
/* 8190 */    MCD::OPC_Decode, 171, 8, 20, // Opcode: MOVM16fm
/* 8194 */    MCD::OPC_FilterValue, 1, 218, 23, 0, // Skip to: 14305
/* 8199 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8202 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8211
/* 8207 */    MCD::OPC_Decode, 169, 8, 90, // Opcode: MOVM16bm
/* 8211 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8220
/* 8216 */    MCD::OPC_Decode, 184, 8, 91, // Opcode: MOVM16qm
/* 8220 */    MCD::OPC_FilterValue, 3, 192, 23, 0, // Skip to: 14305
/* 8225 */    MCD::OPC_CheckField, 40, 4, 8, 185, 23, 0, // Skip to: 14305
/* 8232 */    MCD::OPC_Decode, 173, 8, 92, // Opcode: MOVM16km
/* 8236 */    MCD::OPC_FilterValue, 6, 61, 0, 0, // Skip to: 8302
/* 8241 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8244 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8260
/* 8249 */    MCD::OPC_CheckField, 40, 4, 8, 161, 23, 0, // Skip to: 14305
/* 8256 */    MCD::OPC_Decode, 176, 8, 21, // Opcode: MOVM16mf
/* 8260 */    MCD::OPC_FilterValue, 1, 152, 23, 0, // Skip to: 14305
/* 8265 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8268 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8277
/* 8273 */    MCD::OPC_Decode, 174, 8, 22, // Opcode: MOVM16mb
/* 8277 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8286
/* 8282 */    MCD::OPC_Decode, 181, 8, 23, // Opcode: MOVM16mq
/* 8286 */    MCD::OPC_FilterValue, 3, 126, 23, 0, // Skip to: 14305
/* 8291 */    MCD::OPC_CheckField, 40, 4, 8, 119, 23, 0, // Skip to: 14305
/* 8298 */    MCD::OPC_Decode, 178, 8, 24, // Opcode: MOVM16mk
/* 8302 */    MCD::OPC_FilterValue, 7, 110, 23, 0, // Skip to: 14305
/* 8307 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 8310 */    MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 8320
/* 8315 */    MCD::OPC_Decode, 155, 4, 173, 1, // Opcode: CALLb
/* 8320 */    MCD::OPC_FilterValue, 10, 5, 0, 0, // Skip to: 8330
/* 8325 */    MCD::OPC_Decode, 158, 4, 174, 1, // Opcode: CALLq
/* 8330 */    MCD::OPC_FilterValue, 11, 82, 23, 0, // Skip to: 14305
/* 8335 */    MCD::OPC_CheckField, 24, 4, 8, 75, 23, 0, // Skip to: 14305
/* 8342 */    MCD::OPC_Decode, 157, 4, 175, 1, // Opcode: CALLk
/* 8347 */    MCD::OPC_FilterValue, 12, 59, 0, 0, // Skip to: 8411
/* 8352 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8355 */    MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 8377
/* 8360 */    MCD::OPC_CheckPredicate, 1, 52, 23, 0, // Skip to: 14305
/* 8365 */    MCD::OPC_CheckField, 3, 1, 0, 45, 23, 0, // Skip to: 14305
/* 8372 */    MCD::OPC_Decode, 199, 5, 176, 1, // Opcode: MOV16dc
/* 8377 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 8394
/* 8382 */    MCD::OPC_CheckField, 3, 1, 0, 28, 23, 0, // Skip to: 14305
/* 8389 */    MCD::OPC_Decode, 190, 5, 177, 1, // Opcode: MOV16cd
/* 8394 */    MCD::OPC_FilterValue, 4, 18, 23, 0, // Skip to: 14305
/* 8399 */    MCD::OPC_CheckField, 3, 1, 0, 11, 23, 0, // Skip to: 14305
/* 8406 */    MCD::OPC_Decode, 202, 4, 178, 1, // Opcode: EXT32
/* 8411 */    MCD::OPC_FilterValue, 13, 138, 0, 0, // Skip to: 8554
/* 8416 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8419 */    MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 8457
/* 8424 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8427 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8442
/* 8432 */    MCD::OPC_CheckPredicate, 1, 236, 22, 0, // Skip to: 14305
/* 8437 */    MCD::OPC_Decode, 237, 5, 179, 1, // Opcode: MOV16jc
/* 8442 */    MCD::OPC_FilterValue, 1, 226, 22, 0, // Skip to: 14305
/* 8447 */    MCD::OPC_CheckPredicate, 1, 221, 22, 0, // Skip to: 14305
/* 8452 */    MCD::OPC_Decode, 135, 6, 179, 1, // Opcode: MOV16oc
/* 8457 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 8485
/* 8462 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8465 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 8475
/* 8470 */    MCD::OPC_Decode, 193, 5, 177, 1, // Opcode: MOV16cj
/* 8475 */    MCD::OPC_FilterValue, 1, 193, 22, 0, // Skip to: 14305
/* 8480 */    MCD::OPC_Decode, 195, 5, 177, 1, // Opcode: MOV16co
/* 8485 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 8511
/* 8490 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8493 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8502
/* 8498 */    MCD::OPC_Decode, 188, 8, 16, // Opcode: MOVM32jm
/* 8502 */    MCD::OPC_FilterValue, 1, 166, 22, 0, // Skip to: 14305
/* 8507 */    MCD::OPC_Decode, 198, 8, 16, // Opcode: MOVM32om
/* 8511 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 8537
/* 8516 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8519 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8528
/* 8524 */    MCD::OPC_Decode, 193, 8, 17, // Opcode: MOVM32mj
/* 8528 */    MCD::OPC_FilterValue, 1, 140, 22, 0, // Skip to: 14305
/* 8533 */    MCD::OPC_Decode, 195, 8, 17, // Opcode: MOVM32mo
/* 8537 */    MCD::OPC_FilterValue, 7, 131, 22, 0, // Skip to: 14305
/* 8542 */    MCD::OPC_CheckField, 3, 1, 0, 124, 22, 0, // Skip to: 14305
/* 8549 */    MCD::OPC_Decode, 143, 5, 169, 1, // Opcode: JMP32j
/* 8554 */    MCD::OPC_FilterValue, 14, 121, 0, 0, // Skip to: 8680
/* 8559 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8562 */    MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 8600
/* 8567 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8570 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 8585
/* 8575 */    MCD::OPC_CheckPredicate, 1, 93, 22, 0, // Skip to: 14305
/* 8580 */    MCD::OPC_Decode, 211, 5, 179, 1, // Opcode: MOV16ec
/* 8585 */    MCD::OPC_FilterValue, 1, 83, 22, 0, // Skip to: 14305
/* 8590 */    MCD::OPC_CheckPredicate, 1, 78, 22, 0, // Skip to: 14305
/* 8595 */    MCD::OPC_Decode, 148, 6, 180, 1, // Opcode: MOV16pc
/* 8600 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 8628
/* 8605 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8608 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 8618
/* 8613 */    MCD::OPC_Decode, 191, 5, 177, 1, // Opcode: MOV16ce
/* 8618 */    MCD::OPC_FilterValue, 1, 50, 22, 0, // Skip to: 14305
/* 8623 */    MCD::OPC_Decode, 196, 5, 177, 1, // Opcode: MOV16cp
/* 8628 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 8654
/* 8633 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8636 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8645
/* 8641 */    MCD::OPC_Decode, 186, 8, 16, // Opcode: MOVM32em
/* 8645 */    MCD::OPC_FilterValue, 1, 23, 22, 0, // Skip to: 14305
/* 8650 */    MCD::OPC_Decode, 199, 8, 18, // Opcode: MOVM32pm
/* 8654 */    MCD::OPC_FilterValue, 6, 14, 22, 0, // Skip to: 14305
/* 8659 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8662 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 8671
/* 8667 */    MCD::OPC_Decode, 191, 8, 17, // Opcode: MOVM32me
/* 8671 */    MCD::OPC_FilterValue, 1, 253, 21, 0, // Skip to: 14305
/* 8676 */    MCD::OPC_Decode, 196, 8, 19, // Opcode: MOVM32mp
/* 8680 */    MCD::OPC_FilterValue, 15, 56, 1, 0, // Skip to: 8997
/* 8685 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8688 */    MCD::OPC_FilterValue, 1, 85, 0, 0, // Skip to: 8778
/* 8693 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8696 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 8718
/* 8701 */    MCD::OPC_CheckPredicate, 1, 223, 21, 0, // Skip to: 14305
/* 8706 */    MCD::OPC_CheckField, 24, 4, 8, 216, 21, 0, // Skip to: 14305
/* 8713 */    MCD::OPC_Decode, 224, 5, 181, 1, // Opcode: MOV16fc
/* 8718 */    MCD::OPC_FilterValue, 1, 206, 21, 0, // Skip to: 14305
/* 8723 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8726 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 8741
/* 8731 */    MCD::OPC_CheckPredicate, 1, 193, 21, 0, // Skip to: 14305
/* 8736 */    MCD::OPC_Decode, 178, 5, 182, 1, // Opcode: MOV16bc
/* 8741 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 8756
/* 8746 */    MCD::OPC_CheckPredicate, 1, 178, 21, 0, // Skip to: 14305
/* 8751 */    MCD::OPC_Decode, 161, 6, 183, 1, // Opcode: MOV16qc
/* 8756 */    MCD::OPC_FilterValue, 3, 168, 21, 0, // Skip to: 14305
/* 8761 */    MCD::OPC_CheckPredicate, 1, 163, 21, 0, // Skip to: 14305
/* 8766 */    MCD::OPC_CheckField, 24, 4, 8, 156, 21, 0, // Skip to: 14305
/* 8773 */    MCD::OPC_Decode, 250, 5, 184, 1, // Opcode: MOV16kc
/* 8778 */    MCD::OPC_FilterValue, 2, 65, 0, 0, // Skip to: 8848
/* 8783 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8786 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 8803
/* 8791 */    MCD::OPC_CheckField, 24, 4, 8, 131, 21, 0, // Skip to: 14305
/* 8798 */    MCD::OPC_Decode, 192, 5, 177, 1, // Opcode: MOV16cf
/* 8803 */    MCD::OPC_FilterValue, 1, 121, 21, 0, // Skip to: 14305
/* 8808 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8811 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 8821
/* 8816 */    MCD::OPC_Decode, 189, 5, 177, 1, // Opcode: MOV16cb
/* 8821 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 8831
/* 8826 */    MCD::OPC_Decode, 197, 5, 177, 1, // Opcode: MOV16cq
/* 8831 */    MCD::OPC_FilterValue, 3, 93, 21, 0, // Skip to: 14305
/* 8836 */    MCD::OPC_CheckField, 24, 4, 8, 86, 21, 0, // Skip to: 14305
/* 8843 */    MCD::OPC_Decode, 194, 5, 177, 1, // Opcode: MOV16ck
/* 8848 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 8914
/* 8853 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8856 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8872
/* 8861 */    MCD::OPC_CheckField, 40, 4, 8, 61, 21, 0, // Skip to: 14305
/* 8868 */    MCD::OPC_Decode, 187, 8, 20, // Opcode: MOVM32fm
/* 8872 */    MCD::OPC_FilterValue, 1, 52, 21, 0, // Skip to: 14305
/* 8877 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8880 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8889
/* 8885 */    MCD::OPC_Decode, 185, 8, 90, // Opcode: MOVM32bm
/* 8889 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8898
/* 8894 */    MCD::OPC_Decode, 200, 8, 91, // Opcode: MOVM32qm
/* 8898 */    MCD::OPC_FilterValue, 3, 26, 21, 0, // Skip to: 14305
/* 8903 */    MCD::OPC_CheckField, 40, 4, 8, 19, 21, 0, // Skip to: 14305
/* 8910 */    MCD::OPC_Decode, 189, 8, 92, // Opcode: MOVM32km
/* 8914 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 8931
/* 8919 */    MCD::OPC_CheckField, 0, 4, 12, 3, 21, 0, // Skip to: 14305
/* 8926 */    MCD::OPC_Decode, 142, 5, 170, 1, // Opcode: ILLEGAL
/* 8931 */    MCD::OPC_FilterValue, 6, 249, 20, 0, // Skip to: 14305
/* 8936 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8939 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8955
/* 8944 */    MCD::OPC_CheckField, 40, 4, 8, 234, 20, 0, // Skip to: 14305
/* 8951 */    MCD::OPC_Decode, 192, 8, 21, // Opcode: MOVM32mf
/* 8955 */    MCD::OPC_FilterValue, 1, 225, 20, 0, // Skip to: 14305
/* 8960 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8963 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8972
/* 8968 */    MCD::OPC_Decode, 190, 8, 22, // Opcode: MOVM32mb
/* 8972 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8981
/* 8977 */    MCD::OPC_Decode, 197, 8, 23, // Opcode: MOVM32mq
/* 8981 */    MCD::OPC_FilterValue, 3, 199, 20, 0, // Skip to: 14305
/* 8986 */    MCD::OPC_CheckField, 40, 4, 8, 192, 20, 0, // Skip to: 14305
/* 8993 */    MCD::OPC_Decode, 194, 8, 24, // Opcode: MOVM32mk
/* 8997 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 9013
/* 9002 */    MCD::OPC_CheckField, 3, 1, 1, 176, 20, 0, // Skip to: 14305
/* 9009 */    MCD::OPC_Decode, 147, 5, 55, // Opcode: LEA32p
/* 9013 */    MCD::OPC_FilterValue, 31, 167, 20, 0, // Skip to: 14305
/* 9018 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9021 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 9037
/* 9026 */    MCD::OPC_CheckField, 24, 4, 8, 152, 20, 0, // Skip to: 14305
/* 9033 */    MCD::OPC_Decode, 145, 5, 56, // Opcode: LEA32f
/* 9037 */    MCD::OPC_FilterValue, 1, 143, 20, 0, // Skip to: 14305
/* 9042 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9045 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 9054
/* 9050 */    MCD::OPC_Decode, 144, 5, 57, // Opcode: LEA32b
/* 9054 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 9063
/* 9059 */    MCD::OPC_Decode, 148, 5, 58, // Opcode: LEA32q
/* 9063 */    MCD::OPC_FilterValue, 3, 117, 20, 0, // Skip to: 14305
/* 9068 */    MCD::OPC_CheckField, 24, 4, 8, 110, 20, 0, // Skip to: 14305
/* 9075 */    MCD::OPC_Decode, 146, 5, 59, // Opcode: LEA32k
/* 9079 */    MCD::OPC_FilterValue, 5, 203, 2, 0, // Skip to: 9799
/* 9084 */    MCD::OPC_ExtractField, 4, 8,  // Inst{11-4} ...
/* 9087 */    MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 9097
/* 9092 */    MCD::OPC_Decode, 151, 9, 185, 1, // Opcode: SETd8t
/* 9097 */    MCD::OPC_FilterValue, 13, 12, 0, 0, // Skip to: 9114
/* 9102 */    MCD::OPC_CheckField, 3, 1, 0, 76, 20, 0, // Skip to: 14305
/* 9109 */    MCD::OPC_Decode, 167, 9, 169, 1, // Opcode: SETj8t
/* 9114 */    MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 9130
/* 9119 */    MCD::OPC_CheckField, 3, 1, 1, 59, 20, 0, // Skip to: 14305
/* 9126 */    MCD::OPC_Decode, 183, 9, 17, // Opcode: SETp8t
/* 9130 */    MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 9140
/* 9135 */    MCD::OPC_Decode, 141, 9, 185, 1, // Opcode: SETd8f
/* 9140 */    MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 9157
/* 9145 */    MCD::OPC_CheckField, 3, 1, 0, 33, 20, 0, // Skip to: 14305
/* 9152 */    MCD::OPC_Decode, 157, 9, 169, 1, // Opcode: SETj8f
/* 9157 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 9173
/* 9162 */    MCD::OPC_CheckField, 3, 1, 1, 16, 20, 0, // Skip to: 14305
/* 9169 */    MCD::OPC_Decode, 173, 9, 17, // Opcode: SETp8f
/* 9173 */    MCD::OPC_FilterValue, 44, 5, 0, 0, // Skip to: 9183
/* 9178 */    MCD::OPC_Decode, 144, 9, 185, 1, // Opcode: SETd8hi
/* 9183 */    MCD::OPC_FilterValue, 45, 12, 0, 0, // Skip to: 9200
/* 9188 */    MCD::OPC_CheckField, 3, 1, 0, 246, 19, 0, // Skip to: 14305
/* 9195 */    MCD::OPC_Decode, 160, 9, 169, 1, // Opcode: SETj8hi
/* 9200 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 9216
/* 9205 */    MCD::OPC_CheckField, 3, 1, 1, 229, 19, 0, // Skip to: 14305
/* 9212 */    MCD::OPC_Decode, 176, 9, 17, // Opcode: SETp8hi
/* 9216 */    MCD::OPC_FilterValue, 60, 5, 0, 0, // Skip to: 9226
/* 9221 */    MCD::OPC_Decode, 146, 9, 185, 1, // Opcode: SETd8ls
/* 9226 */    MCD::OPC_FilterValue, 61, 12, 0, 0, // Skip to: 9243
/* 9231 */    MCD::OPC_CheckField, 3, 1, 0, 203, 19, 0, // Skip to: 14305
/* 9238 */    MCD::OPC_Decode, 162, 9, 169, 1, // Opcode: SETj8ls
/* 9243 */    MCD::OPC_FilterValue, 62, 11, 0, 0, // Skip to: 9259
/* 9248 */    MCD::OPC_CheckField, 3, 1, 1, 186, 19, 0, // Skip to: 14305
/* 9255 */    MCD::OPC_Decode, 178, 9, 17, // Opcode: SETp8ls
/* 9259 */    MCD::OPC_FilterValue, 76, 5, 0, 0, // Skip to: 9269
/* 9264 */    MCD::OPC_Decode, 138, 9, 185, 1, // Opcode: SETd8cc
/* 9269 */    MCD::OPC_FilterValue, 77, 12, 0, 0, // Skip to: 9286
/* 9274 */    MCD::OPC_CheckField, 3, 1, 0, 160, 19, 0, // Skip to: 14305
/* 9281 */    MCD::OPC_Decode, 154, 9, 169, 1, // Opcode: SETj8cc
/* 9286 */    MCD::OPC_FilterValue, 78, 11, 0, 0, // Skip to: 9302
/* 9291 */    MCD::OPC_CheckField, 3, 1, 1, 143, 19, 0, // Skip to: 14305
/* 9298 */    MCD::OPC_Decode, 170, 9, 17, // Opcode: SETp8cc
/* 9302 */    MCD::OPC_FilterValue, 92, 5, 0, 0, // Skip to: 9312
/* 9307 */    MCD::OPC_Decode, 139, 9, 185, 1, // Opcode: SETd8cs
/* 9312 */    MCD::OPC_FilterValue, 93, 12, 0, 0, // Skip to: 9329
/* 9317 */    MCD::OPC_CheckField, 3, 1, 0, 117, 19, 0, // Skip to: 14305
/* 9324 */    MCD::OPC_Decode, 155, 9, 169, 1, // Opcode: SETj8cs
/* 9329 */    MCD::OPC_FilterValue, 94, 11, 0, 0, // Skip to: 9345
/* 9334 */    MCD::OPC_CheckField, 3, 1, 1, 100, 19, 0, // Skip to: 14305
/* 9341 */    MCD::OPC_Decode, 171, 9, 17, // Opcode: SETp8cs
/* 9345 */    MCD::OPC_FilterValue, 108, 5, 0, 0, // Skip to: 9355
/* 9350 */    MCD::OPC_Decode, 149, 9, 185, 1, // Opcode: SETd8ne
/* 9355 */    MCD::OPC_FilterValue, 109, 12, 0, 0, // Skip to: 9372
/* 9360 */    MCD::OPC_CheckField, 3, 1, 0, 74, 19, 0, // Skip to: 14305
/* 9367 */    MCD::OPC_Decode, 165, 9, 169, 1, // Opcode: SETj8ne
/* 9372 */    MCD::OPC_FilterValue, 110, 11, 0, 0, // Skip to: 9388
/* 9377 */    MCD::OPC_CheckField, 3, 1, 1, 57, 19, 0, // Skip to: 14305
/* 9384 */    MCD::OPC_Decode, 181, 9, 17, // Opcode: SETp8ne
/* 9388 */    MCD::OPC_FilterValue, 124, 5, 0, 0, // Skip to: 9398
/* 9393 */    MCD::OPC_Decode, 140, 9, 185, 1, // Opcode: SETd8eq
/* 9398 */    MCD::OPC_FilterValue, 125, 12, 0, 0, // Skip to: 9415
/* 9403 */    MCD::OPC_CheckField, 3, 1, 0, 31, 19, 0, // Skip to: 14305
/* 9410 */    MCD::OPC_Decode, 156, 9, 169, 1, // Opcode: SETj8eq
/* 9415 */    MCD::OPC_FilterValue, 126, 11, 0, 0, // Skip to: 9431
/* 9420 */    MCD::OPC_CheckField, 3, 1, 1, 14, 19, 0, // Skip to: 14305
/* 9427 */    MCD::OPC_Decode, 172, 9, 17, // Opcode: SETp8eq
/* 9431 */    MCD::OPC_FilterValue, 140, 1, 5, 0, 0, // Skip to: 9442
/* 9437 */    MCD::OPC_Decode, 152, 9, 185, 1, // Opcode: SETd8vc
/* 9442 */    MCD::OPC_FilterValue, 141, 1, 12, 0, 0, // Skip to: 9460
/* 9448 */    MCD::OPC_CheckField, 3, 1, 0, 242, 18, 0, // Skip to: 14305
/* 9455 */    MCD::OPC_Decode, 168, 9, 169, 1, // Opcode: SETj8vc
/* 9460 */    MCD::OPC_FilterValue, 142, 1, 11, 0, 0, // Skip to: 9477
/* 9466 */    MCD::OPC_CheckField, 3, 1, 1, 224, 18, 0, // Skip to: 14305
/* 9473 */    MCD::OPC_Decode, 184, 9, 17, // Opcode: SETp8vc
/* 9477 */    MCD::OPC_FilterValue, 156, 1, 5, 0, 0, // Skip to: 9488
/* 9483 */    MCD::OPC_Decode, 153, 9, 185, 1, // Opcode: SETd8vs
/* 9488 */    MCD::OPC_FilterValue, 157, 1, 12, 0, 0, // Skip to: 9506
/* 9494 */    MCD::OPC_CheckField, 3, 1, 0, 196, 18, 0, // Skip to: 14305
/* 9501 */    MCD::OPC_Decode, 169, 9, 169, 1, // Opcode: SETj8vs
/* 9506 */    MCD::OPC_FilterValue, 158, 1, 11, 0, 0, // Skip to: 9523
/* 9512 */    MCD::OPC_CheckField, 3, 1, 1, 178, 18, 0, // Skip to: 14305
/* 9519 */    MCD::OPC_Decode, 185, 9, 17, // Opcode: SETp8vs
/* 9523 */    MCD::OPC_FilterValue, 172, 1, 5, 0, 0, // Skip to: 9534
/* 9529 */    MCD::OPC_Decode, 150, 9, 185, 1, // Opcode: SETd8pl
/* 9534 */    MCD::OPC_FilterValue, 173, 1, 12, 0, 0, // Skip to: 9552
/* 9540 */    MCD::OPC_CheckField, 3, 1, 0, 150, 18, 0, // Skip to: 14305
/* 9547 */    MCD::OPC_Decode, 166, 9, 169, 1, // Opcode: SETj8pl
/* 9552 */    MCD::OPC_FilterValue, 174, 1, 11, 0, 0, // Skip to: 9569
/* 9558 */    MCD::OPC_CheckField, 3, 1, 1, 132, 18, 0, // Skip to: 14305
/* 9565 */    MCD::OPC_Decode, 182, 9, 17, // Opcode: SETp8pl
/* 9569 */    MCD::OPC_FilterValue, 188, 1, 5, 0, 0, // Skip to: 9580
/* 9575 */    MCD::OPC_Decode, 148, 9, 185, 1, // Opcode: SETd8mi
/* 9580 */    MCD::OPC_FilterValue, 189, 1, 12, 0, 0, // Skip to: 9598
/* 9586 */    MCD::OPC_CheckField, 3, 1, 0, 104, 18, 0, // Skip to: 14305
/* 9593 */    MCD::OPC_Decode, 164, 9, 169, 1, // Opcode: SETj8mi
/* 9598 */    MCD::OPC_FilterValue, 190, 1, 11, 0, 0, // Skip to: 9615
/* 9604 */    MCD::OPC_CheckField, 3, 1, 1, 86, 18, 0, // Skip to: 14305
/* 9611 */    MCD::OPC_Decode, 180, 9, 17, // Opcode: SETp8mi
/* 9615 */    MCD::OPC_FilterValue, 204, 1, 5, 0, 0, // Skip to: 9626
/* 9621 */    MCD::OPC_Decode, 142, 9, 185, 1, // Opcode: SETd8ge
/* 9626 */    MCD::OPC_FilterValue, 205, 1, 12, 0, 0, // Skip to: 9644
/* 9632 */    MCD::OPC_CheckField, 3, 1, 0, 58, 18, 0, // Skip to: 14305
/* 9639 */    MCD::OPC_Decode, 158, 9, 169, 1, // Opcode: SETj8ge
/* 9644 */    MCD::OPC_FilterValue, 206, 1, 11, 0, 0, // Skip to: 9661
/* 9650 */    MCD::OPC_CheckField, 3, 1, 1, 40, 18, 0, // Skip to: 14305
/* 9657 */    MCD::OPC_Decode, 174, 9, 17, // Opcode: SETp8ge
/* 9661 */    MCD::OPC_FilterValue, 220, 1, 5, 0, 0, // Skip to: 9672
/* 9667 */    MCD::OPC_Decode, 147, 9, 185, 1, // Opcode: SETd8lt
/* 9672 */    MCD::OPC_FilterValue, 221, 1, 12, 0, 0, // Skip to: 9690
/* 9678 */    MCD::OPC_CheckField, 3, 1, 0, 12, 18, 0, // Skip to: 14305
/* 9685 */    MCD::OPC_Decode, 163, 9, 169, 1, // Opcode: SETj8lt
/* 9690 */    MCD::OPC_FilterValue, 222, 1, 11, 0, 0, // Skip to: 9707
/* 9696 */    MCD::OPC_CheckField, 3, 1, 1, 250, 17, 0, // Skip to: 14305
/* 9703 */    MCD::OPC_Decode, 179, 9, 17, // Opcode: SETp8lt
/* 9707 */    MCD::OPC_FilterValue, 236, 1, 5, 0, 0, // Skip to: 9718
/* 9713 */    MCD::OPC_Decode, 143, 9, 185, 1, // Opcode: SETd8gt
/* 9718 */    MCD::OPC_FilterValue, 237, 1, 12, 0, 0, // Skip to: 9736
/* 9724 */    MCD::OPC_CheckField, 3, 1, 0, 222, 17, 0, // Skip to: 14305
/* 9731 */    MCD::OPC_Decode, 159, 9, 169, 1, // Opcode: SETj8gt
/* 9736 */    MCD::OPC_FilterValue, 238, 1, 11, 0, 0, // Skip to: 9753
/* 9742 */    MCD::OPC_CheckField, 3, 1, 1, 204, 17, 0, // Skip to: 14305
/* 9749 */    MCD::OPC_Decode, 175, 9, 17, // Opcode: SETp8gt
/* 9753 */    MCD::OPC_FilterValue, 252, 1, 5, 0, 0, // Skip to: 9764
/* 9759 */    MCD::OPC_Decode, 145, 9, 185, 1, // Opcode: SETd8le
/* 9764 */    MCD::OPC_FilterValue, 253, 1, 12, 0, 0, // Skip to: 9782
/* 9770 */    MCD::OPC_CheckField, 3, 1, 0, 176, 17, 0, // Skip to: 14305
/* 9777 */    MCD::OPC_Decode, 161, 9, 169, 1, // Opcode: SETj8le
/* 9782 */    MCD::OPC_FilterValue, 254, 1, 165, 17, 0, // Skip to: 14305
/* 9788 */    MCD::OPC_CheckField, 3, 1, 1, 158, 17, 0, // Skip to: 14305
/* 9795 */    MCD::OPC_Decode, 177, 9, 17, // Opcode: SETp8le
/* 9799 */    MCD::OPC_FilterValue, 6, 111, 1, 0, // Skip to: 10171
/* 9804 */    MCD::OPC_ExtractField, 8, 4,  // Inst{11-8} ...
/* 9807 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 9829
/* 9812 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9824
/* 9819 */    MCD::OPC_Decode, 222, 3, 174, 1, // Opcode: BRA16
/* 9824 */    MCD::OPC_Decode, 223, 3, 186, 1, // Opcode: BRA8
/* 9829 */    MCD::OPC_FilterValue, 1, 29, 0, 0, // Skip to: 9863
/* 9834 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 9837 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 9847
/* 9842 */    MCD::OPC_Decode, 236, 3, 174, 1, // Opcode: BSR16
/* 9847 */    MCD::OPC_FilterValue, 255, 1, 5, 0, 0, // Skip to: 9858
/* 9853 */    MCD::OPC_Decode, 237, 3, 173, 1, // Opcode: BSR32
/* 9858 */    MCD::OPC_Decode, 238, 3, 186, 1, // Opcode: BSR8
/* 9863 */    MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 9885
/* 9868 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9880
/* 9875 */    MCD::OPC_Decode, 137, 4, 174, 1, // Opcode: Bhi16
/* 9880 */    MCD::OPC_Decode, 138, 4, 186, 1, // Opcode: Bhi8
/* 9885 */    MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 9907
/* 9890 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9902
/* 9897 */    MCD::OPC_Decode, 141, 4, 174, 1, // Opcode: Bls16
/* 9902 */    MCD::OPC_Decode, 142, 4, 186, 1, // Opcode: Bls8
/* 9907 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 9929
/* 9912 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9924
/* 9919 */    MCD::OPC_Decode, 255, 3, 174, 1, // Opcode: Bcc16
/* 9924 */    MCD::OPC_Decode, 128, 4, 186, 1, // Opcode: Bcc8
/* 9929 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 9951
/* 9934 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9946
/* 9941 */    MCD::OPC_Decode, 129, 4, 174, 1, // Opcode: Bcs16
/* 9946 */    MCD::OPC_Decode, 130, 4, 186, 1, // Opcode: Bcs8
/* 9951 */    MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 9973
/* 9956 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9968
/* 9963 */    MCD::OPC_Decode, 147, 4, 174, 1, // Opcode: Bne16
/* 9968 */    MCD::OPC_Decode, 148, 4, 186, 1, // Opcode: Bne8
/* 9973 */    MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 9995
/* 9978 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9990
/* 9985 */    MCD::OPC_Decode, 131, 4, 174, 1, // Opcode: Beq16
/* 9990 */    MCD::OPC_Decode, 132, 4, 186, 1, // Opcode: Beq8
/* 9995 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 10017
/* 10000 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10012
/* 10007 */   MCD::OPC_Decode, 151, 4, 174, 1, // Opcode: Bvc16
/* 10012 */   MCD::OPC_Decode, 152, 4, 186, 1, // Opcode: Bvc8
/* 10017 */   MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 10039
/* 10022 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10034
/* 10029 */   MCD::OPC_Decode, 153, 4, 174, 1, // Opcode: Bvs16
/* 10034 */   MCD::OPC_Decode, 154, 4, 186, 1, // Opcode: Bvs8
/* 10039 */   MCD::OPC_FilterValue, 10, 17, 0, 0, // Skip to: 10061
/* 10044 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10056
/* 10051 */   MCD::OPC_Decode, 149, 4, 174, 1, // Opcode: Bpl16
/* 10056 */   MCD::OPC_Decode, 150, 4, 186, 1, // Opcode: Bpl8
/* 10061 */   MCD::OPC_FilterValue, 11, 17, 0, 0, // Skip to: 10083
/* 10066 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10078
/* 10073 */   MCD::OPC_Decode, 145, 4, 174, 1, // Opcode: Bmi16
/* 10078 */   MCD::OPC_Decode, 146, 4, 186, 1, // Opcode: Bmi8
/* 10083 */   MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 10105
/* 10088 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10100
/* 10095 */   MCD::OPC_Decode, 133, 4, 174, 1, // Opcode: Bge16
/* 10100 */   MCD::OPC_Decode, 134, 4, 186, 1, // Opcode: Bge8
/* 10105 */   MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 10127
/* 10110 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10122
/* 10117 */   MCD::OPC_Decode, 143, 4, 174, 1, // Opcode: Blt16
/* 10122 */   MCD::OPC_Decode, 144, 4, 186, 1, // Opcode: Blt8
/* 10127 */   MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 10149
/* 10132 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10144
/* 10139 */   MCD::OPC_Decode, 135, 4, 174, 1, // Opcode: Bgt16
/* 10144 */   MCD::OPC_Decode, 136, 4, 186, 1, // Opcode: Bgt8
/* 10149 */   MCD::OPC_FilterValue, 15, 55, 16, 0, // Skip to: 14305
/* 10154 */   MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 10166
/* 10161 */   MCD::OPC_Decode, 139, 4, 174, 1, // Opcode: Ble16
/* 10166 */   MCD::OPC_Decode, 140, 4, 186, 1, // Opcode: Ble8
/* 10171 */   MCD::OPC_FilterValue, 8, 110, 2, 0, // Skip to: 10798
/* 10176 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10179 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10196
/* 10184 */   MCD::OPC_CheckField, 3, 1, 0, 18, 16, 0, // Skip to: 14305
/* 10191 */   MCD::OPC_Decode, 236, 8, 187, 1, // Opcode: OR8dd
/* 10196 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 10213
/* 10201 */   MCD::OPC_CheckField, 3, 1, 0, 1, 16, 0, // Skip to: 14305
/* 10208 */   MCD::OPC_Decode, 239, 8, 188, 1, // Opcode: OR8dj
/* 10213 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 10230
/* 10218 */   MCD::OPC_CheckField, 3, 1, 1, 240, 15, 0, // Skip to: 14305
/* 10225 */   MCD::OPC_Decode, 241, 8, 189, 1, // Opcode: OR8dp
/* 10230 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 10307
/* 10235 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10238 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10255
/* 10243 */   MCD::OPC_CheckField, 24, 4, 8, 215, 15, 0, // Skip to: 14305
/* 10250 */   MCD::OPC_Decode, 237, 8, 190, 1, // Opcode: OR8df
/* 10255 */   MCD::OPC_FilterValue, 1, 205, 15, 0, // Skip to: 14305
/* 10260 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10263 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10273
/* 10268 */   MCD::OPC_Decode, 242, 8, 191, 1, // Opcode: OR8dq
/* 10273 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10290
/* 10278 */   MCD::OPC_CheckField, 24, 4, 8, 180, 15, 0, // Skip to: 14305
/* 10285 */   MCD::OPC_Decode, 240, 8, 192, 1, // Opcode: OR8dk
/* 10290 */   MCD::OPC_FilterValue, 4, 170, 15, 0, // Skip to: 14305
/* 10295 */   MCD::OPC_CheckField, 24, 8, 0, 163, 15, 0, // Skip to: 14305
/* 10302 */   MCD::OPC_Decode, 238, 8, 193, 1, // Opcode: OR8di
/* 10307 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 10329
/* 10312 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10324
/* 10319 */   MCD::OPC_Decode, 208, 8, 194, 1, // Opcode: OR16dd
/* 10324 */   MCD::OPC_Decode, 215, 8, 195, 1, // Opcode: OR16dr
/* 10329 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 10346
/* 10334 */   MCD::OPC_CheckField, 3, 1, 0, 124, 15, 0, // Skip to: 14305
/* 10341 */   MCD::OPC_Decode, 211, 8, 196, 1, // Opcode: OR16dj
/* 10346 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 10363
/* 10351 */   MCD::OPC_CheckField, 3, 1, 1, 107, 15, 0, // Skip to: 14305
/* 10358 */   MCD::OPC_Decode, 213, 8, 197, 1, // Opcode: OR16dp
/* 10363 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 10433
/* 10368 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10371 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10388
/* 10376 */   MCD::OPC_CheckField, 24, 4, 8, 82, 15, 0, // Skip to: 14305
/* 10383 */   MCD::OPC_Decode, 209, 8, 198, 1, // Opcode: OR16df
/* 10388 */   MCD::OPC_FilterValue, 1, 72, 15, 0, // Skip to: 14305
/* 10393 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10396 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10406
/* 10401 */   MCD::OPC_Decode, 214, 8, 199, 1, // Opcode: OR16dq
/* 10406 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10423
/* 10411 */   MCD::OPC_CheckField, 24, 4, 8, 47, 15, 0, // Skip to: 14305
/* 10418 */   MCD::OPC_Decode, 212, 8, 200, 1, // Opcode: OR16dk
/* 10423 */   MCD::OPC_FilterValue, 4, 37, 15, 0, // Skip to: 14305
/* 10428 */   MCD::OPC_Decode, 210, 8, 199, 1, // Opcode: OR16di
/* 10433 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 10455
/* 10438 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10450
/* 10445 */   MCD::OPC_Decode, 222, 8, 201, 1, // Opcode: OR32dd
/* 10450 */   MCD::OPC_Decode, 229, 8, 202, 1, // Opcode: OR32dr
/* 10455 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 10472
/* 10460 */   MCD::OPC_CheckField, 3, 1, 0, 254, 14, 0, // Skip to: 14305
/* 10467 */   MCD::OPC_Decode, 225, 8, 203, 1, // Opcode: OR32dj
/* 10472 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 10489
/* 10477 */   MCD::OPC_CheckField, 3, 1, 1, 237, 14, 0, // Skip to: 14305
/* 10484 */   MCD::OPC_Decode, 227, 8, 204, 1, // Opcode: OR32dp
/* 10489 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 10559
/* 10494 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10497 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10514
/* 10502 */   MCD::OPC_CheckField, 24, 4, 8, 212, 14, 0, // Skip to: 14305
/* 10509 */   MCD::OPC_Decode, 223, 8, 205, 1, // Opcode: OR32df
/* 10514 */   MCD::OPC_FilterValue, 1, 202, 14, 0, // Skip to: 14305
/* 10519 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10522 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10532
/* 10527 */   MCD::OPC_Decode, 228, 8, 206, 1, // Opcode: OR32dq
/* 10532 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10549
/* 10537 */   MCD::OPC_CheckField, 24, 4, 8, 177, 14, 0, // Skip to: 14305
/* 10544 */   MCD::OPC_Decode, 226, 8, 207, 1, // Opcode: OR32dk
/* 10549 */   MCD::OPC_FilterValue, 4, 167, 14, 0, // Skip to: 14305
/* 10554 */   MCD::OPC_Decode, 224, 8, 208, 1, // Opcode: OR32di
/* 10559 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 10576
/* 10564 */   MCD::OPC_CheckField, 3, 1, 0, 150, 14, 0, // Skip to: 14305
/* 10571 */   MCD::OPC_Decode, 249, 9, 209, 1, // Opcode: UDIVd32d16
/* 10576 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 10593
/* 10581 */   MCD::OPC_CheckField, 0, 4, 12, 133, 14, 0, // Skip to: 14305
/* 10588 */   MCD::OPC_Decode, 251, 9, 206, 1, // Opcode: UDIVd32i16
/* 10593 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 10609
/* 10598 */   MCD::OPC_CheckField, 3, 1, 0, 116, 14, 0, // Skip to: 14305
/* 10605 */   MCD::OPC_Decode, 245, 8, 40, // Opcode: OR8jd
/* 10609 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 10625
/* 10614 */   MCD::OPC_CheckField, 3, 1, 1, 100, 14, 0, // Skip to: 14305
/* 10621 */   MCD::OPC_Decode, 247, 8, 41, // Opcode: OR8pd
/* 10625 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 10648
/* 10630 */   MCD::OPC_CheckField, 24, 4, 8, 84, 14, 0, // Skip to: 14305
/* 10637 */   MCD::OPC_CheckField, 3, 1, 0, 77, 14, 0, // Skip to: 14305
/* 10644 */   MCD::OPC_Decode, 243, 8, 42, // Opcode: OR8fd
/* 10648 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 10665
/* 10653 */   MCD::OPC_CheckField, 3, 1, 0, 61, 14, 0, // Skip to: 14305
/* 10660 */   MCD::OPC_Decode, 218, 8, 210, 1, // Opcode: OR16jd
/* 10665 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 10682
/* 10670 */   MCD::OPC_CheckField, 3, 1, 1, 44, 14, 0, // Skip to: 14305
/* 10677 */   MCD::OPC_Decode, 220, 8, 211, 1, // Opcode: OR16pd
/* 10682 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 10706
/* 10687 */   MCD::OPC_CheckField, 24, 4, 8, 27, 14, 0, // Skip to: 14305
/* 10694 */   MCD::OPC_CheckField, 3, 1, 0, 20, 14, 0, // Skip to: 14305
/* 10701 */   MCD::OPC_Decode, 216, 8, 212, 1, // Opcode: OR16fd
/* 10706 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 10723
/* 10711 */   MCD::OPC_CheckField, 3, 1, 0, 3, 14, 0, // Skip to: 14305
/* 10718 */   MCD::OPC_Decode, 232, 8, 213, 1, // Opcode: OR32jd
/* 10723 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 10740
/* 10728 */   MCD::OPC_CheckField, 3, 1, 1, 242, 13, 0, // Skip to: 14305
/* 10735 */   MCD::OPC_Decode, 234, 8, 214, 1, // Opcode: OR32pd
/* 10740 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 10764
/* 10745 */   MCD::OPC_CheckField, 24, 4, 8, 225, 13, 0, // Skip to: 14305
/* 10752 */   MCD::OPC_CheckField, 3, 1, 0, 218, 13, 0, // Skip to: 14305
/* 10759 */   MCD::OPC_Decode, 230, 8, 215, 1, // Opcode: OR32fd
/* 10764 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 10781
/* 10769 */   MCD::OPC_CheckField, 3, 1, 0, 201, 13, 0, // Skip to: 14305
/* 10776 */   MCD::OPC_Decode, 135, 9, 209, 1, // Opcode: SDIVd32d16
/* 10781 */   MCD::OPC_FilterValue, 31, 191, 13, 0, // Skip to: 14305
/* 10786 */   MCD::OPC_CheckField, 0, 4, 12, 184, 13, 0, // Skip to: 14305
/* 10793 */   MCD::OPC_Decode, 137, 9, 206, 1, // Opcode: SDIVd32i16
/* 10798 */   MCD::OPC_FilterValue, 9, 217, 2, 0, // Skip to: 11532
/* 10803 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10806 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10823
/* 10811 */   MCD::OPC_CheckField, 3, 1, 0, 159, 13, 0, // Skip to: 14305
/* 10818 */   MCD::OPC_Decode, 231, 9, 187, 1, // Opcode: SUB8dd
/* 10823 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 10840
/* 10828 */   MCD::OPC_CheckField, 3, 1, 0, 142, 13, 0, // Skip to: 14305
/* 10835 */   MCD::OPC_Decode, 234, 9, 188, 1, // Opcode: SUB8dj
/* 10840 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 10857
/* 10845 */   MCD::OPC_CheckField, 3, 1, 1, 125, 13, 0, // Skip to: 14305
/* 10852 */   MCD::OPC_Decode, 236, 9, 189, 1, // Opcode: SUB8dp
/* 10857 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 10934
/* 10862 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10865 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10882
/* 10870 */   MCD::OPC_CheckField, 24, 4, 8, 100, 13, 0, // Skip to: 14305
/* 10877 */   MCD::OPC_Decode, 232, 9, 190, 1, // Opcode: SUB8df
/* 10882 */   MCD::OPC_FilterValue, 1, 90, 13, 0, // Skip to: 14305
/* 10887 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10890 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10900
/* 10895 */   MCD::OPC_Decode, 237, 9, 191, 1, // Opcode: SUB8dq
/* 10900 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10917
/* 10905 */   MCD::OPC_CheckField, 24, 4, 8, 65, 13, 0, // Skip to: 14305
/* 10912 */   MCD::OPC_Decode, 235, 9, 192, 1, // Opcode: SUB8dk
/* 10917 */   MCD::OPC_FilterValue, 4, 55, 13, 0, // Skip to: 14305
/* 10922 */   MCD::OPC_CheckField, 24, 8, 0, 48, 13, 0, // Skip to: 14305
/* 10929 */   MCD::OPC_Decode, 233, 9, 193, 1, // Opcode: SUB8di
/* 10934 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 10956
/* 10939 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10951
/* 10946 */   MCD::OPC_Decode, 195, 9, 194, 1, // Opcode: SUB16dd
/* 10951 */   MCD::OPC_Decode, 202, 9, 195, 1, // Opcode: SUB16dr
/* 10956 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 10973
/* 10961 */   MCD::OPC_CheckField, 3, 1, 0, 9, 13, 0, // Skip to: 14305
/* 10968 */   MCD::OPC_Decode, 198, 9, 196, 1, // Opcode: SUB16dj
/* 10973 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 10990
/* 10978 */   MCD::OPC_CheckField, 3, 1, 1, 248, 12, 0, // Skip to: 14305
/* 10985 */   MCD::OPC_Decode, 200, 9, 197, 1, // Opcode: SUB16dp
/* 10990 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 11060
/* 10995 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10998 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11015
/* 11003 */   MCD::OPC_CheckField, 24, 4, 8, 223, 12, 0, // Skip to: 14305
/* 11010 */   MCD::OPC_Decode, 196, 9, 198, 1, // Opcode: SUB16df
/* 11015 */   MCD::OPC_FilterValue, 1, 213, 12, 0, // Skip to: 14305
/* 11020 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11023 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11033
/* 11028 */   MCD::OPC_Decode, 201, 9, 199, 1, // Opcode: SUB16dq
/* 11033 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11050
/* 11038 */   MCD::OPC_CheckField, 24, 4, 8, 188, 12, 0, // Skip to: 14305
/* 11045 */   MCD::OPC_Decode, 199, 9, 200, 1, // Opcode: SUB16dk
/* 11050 */   MCD::OPC_FilterValue, 4, 178, 12, 0, // Skip to: 14305
/* 11055 */   MCD::OPC_Decode, 197, 9, 199, 1, // Opcode: SUB16di
/* 11060 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 11082
/* 11065 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11077
/* 11072 */   MCD::OPC_Decode, 217, 9, 201, 1, // Opcode: SUB32dd
/* 11077 */   MCD::OPC_Decode, 224, 9, 202, 1, // Opcode: SUB32dr
/* 11082 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 11099
/* 11087 */   MCD::OPC_CheckField, 3, 1, 0, 139, 12, 0, // Skip to: 14305
/* 11094 */   MCD::OPC_Decode, 220, 9, 203, 1, // Opcode: SUB32dj
/* 11099 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 11116
/* 11104 */   MCD::OPC_CheckField, 3, 1, 1, 122, 12, 0, // Skip to: 14305
/* 11111 */   MCD::OPC_Decode, 222, 9, 204, 1, // Opcode: SUB32dp
/* 11116 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 11186
/* 11121 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11124 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11141
/* 11129 */   MCD::OPC_CheckField, 24, 4, 8, 97, 12, 0, // Skip to: 14305
/* 11136 */   MCD::OPC_Decode, 218, 9, 205, 1, // Opcode: SUB32df
/* 11141 */   MCD::OPC_FilterValue, 1, 87, 12, 0, // Skip to: 14305
/* 11146 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11149 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11159
/* 11154 */   MCD::OPC_Decode, 223, 9, 206, 1, // Opcode: SUB32dq
/* 11159 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11176
/* 11164 */   MCD::OPC_CheckField, 24, 4, 8, 62, 12, 0, // Skip to: 14305
/* 11171 */   MCD::OPC_Decode, 221, 9, 207, 1, // Opcode: SUB32dk
/* 11176 */   MCD::OPC_FilterValue, 4, 52, 12, 0, // Skip to: 14305
/* 11181 */   MCD::OPC_Decode, 219, 9, 208, 1, // Opcode: SUB32di
/* 11186 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 11203
/* 11191 */   MCD::OPC_CheckField, 3, 1, 0, 35, 12, 0, // Skip to: 14305
/* 11198 */   MCD::OPC_Decode, 246, 9, 187, 1, // Opcode: SUBX8dd
/* 11203 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 11219
/* 11208 */   MCD::OPC_CheckField, 3, 1, 0, 18, 12, 0, // Skip to: 14305
/* 11215 */   MCD::OPC_Decode, 240, 9, 40, // Opcode: SUB8jd
/* 11219 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 11235
/* 11224 */   MCD::OPC_CheckField, 3, 1, 1, 2, 12, 0, // Skip to: 14305
/* 11231 */   MCD::OPC_Decode, 242, 9, 41, // Opcode: SUB8pd
/* 11235 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 11258
/* 11240 */   MCD::OPC_CheckField, 24, 4, 8, 242, 11, 0, // Skip to: 14305
/* 11247 */   MCD::OPC_CheckField, 3, 1, 0, 235, 11, 0, // Skip to: 14305
/* 11254 */   MCD::OPC_Decode, 238, 9, 42, // Opcode: SUB8fd
/* 11258 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 11275
/* 11263 */   MCD::OPC_CheckField, 3, 1, 0, 219, 11, 0, // Skip to: 14305
/* 11270 */   MCD::OPC_Decode, 244, 9, 194, 1, // Opcode: SUBX16dd
/* 11275 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 11292
/* 11280 */   MCD::OPC_CheckField, 3, 1, 0, 202, 11, 0, // Skip to: 14305
/* 11287 */   MCD::OPC_Decode, 205, 9, 210, 1, // Opcode: SUB16jd
/* 11292 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 11309
/* 11297 */   MCD::OPC_CheckField, 3, 1, 1, 185, 11, 0, // Skip to: 14305
/* 11304 */   MCD::OPC_Decode, 207, 9, 211, 1, // Opcode: SUB16pd
/* 11309 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 11333
/* 11314 */   MCD::OPC_CheckField, 24, 4, 8, 168, 11, 0, // Skip to: 14305
/* 11321 */   MCD::OPC_CheckField, 3, 1, 0, 161, 11, 0, // Skip to: 14305
/* 11328 */   MCD::OPC_Decode, 203, 9, 212, 1, // Opcode: SUB16fd
/* 11333 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 11350
/* 11338 */   MCD::OPC_CheckField, 3, 1, 0, 144, 11, 0, // Skip to: 14305
/* 11345 */   MCD::OPC_Decode, 245, 9, 201, 1, // Opcode: SUBX32dd
/* 11350 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 11367
/* 11355 */   MCD::OPC_CheckField, 3, 1, 0, 127, 11, 0, // Skip to: 14305
/* 11362 */   MCD::OPC_Decode, 227, 9, 213, 1, // Opcode: SUB32jd
/* 11367 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 11384
/* 11372 */   MCD::OPC_CheckField, 3, 1, 1, 110, 11, 0, // Skip to: 14305
/* 11379 */   MCD::OPC_Decode, 229, 9, 214, 1, // Opcode: SUB32pd
/* 11384 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 11408
/* 11389 */   MCD::OPC_CheckField, 24, 4, 8, 93, 11, 0, // Skip to: 14305
/* 11396 */   MCD::OPC_CheckField, 3, 1, 0, 86, 11, 0, // Skip to: 14305
/* 11403 */   MCD::OPC_Decode, 225, 9, 215, 1, // Opcode: SUB32fd
/* 11408 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 11418
/* 11413 */   MCD::OPC_Decode, 216, 9, 216, 1, // Opcode: SUB32ar
/* 11418 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 11435
/* 11423 */   MCD::OPC_CheckField, 3, 1, 0, 59, 11, 0, // Skip to: 14305
/* 11430 */   MCD::OPC_Decode, 212, 9, 217, 1, // Opcode: SUB32aj
/* 11435 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 11452
/* 11440 */   MCD::OPC_CheckField, 3, 1, 1, 42, 11, 0, // Skip to: 14305
/* 11447 */   MCD::OPC_Decode, 214, 9, 218, 1, // Opcode: SUB32ap
/* 11452 */   MCD::OPC_FilterValue, 31, 32, 11, 0, // Skip to: 14305
/* 11457 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11460 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11477
/* 11465 */   MCD::OPC_CheckField, 24, 4, 8, 17, 11, 0, // Skip to: 14305
/* 11472 */   MCD::OPC_Decode, 210, 9, 219, 1, // Opcode: SUB32af
/* 11477 */   MCD::OPC_FilterValue, 1, 7, 11, 0, // Skip to: 14305
/* 11482 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11485 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 11495
/* 11490 */   MCD::OPC_Decode, 209, 9, 220, 1, // Opcode: SUB32ab
/* 11495 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11505
/* 11500 */   MCD::OPC_Decode, 215, 9, 221, 1, // Opcode: SUB32aq
/* 11505 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11522
/* 11510 */   MCD::OPC_CheckField, 24, 4, 8, 228, 10, 0, // Skip to: 14305
/* 11517 */   MCD::OPC_Decode, 213, 9, 222, 1, // Opcode: SUB32ak
/* 11522 */   MCD::OPC_FilterValue, 4, 218, 10, 0, // Skip to: 14305
/* 11527 */   MCD::OPC_Decode, 211, 9, 220, 1, // Opcode: SUB32ai
/* 11532 */   MCD::OPC_FilterValue, 11, 100, 1, 0, // Skip to: 11893
/* 11537 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11540 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 11550
/* 11545 */   MCD::OPC_Decode, 189, 4, 223, 1, // Opcode: CMP8dd
/* 11550 */   MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 11566
/* 11555 */   MCD::OPC_CheckField, 3, 1, 0, 183, 10, 0, // Skip to: 14305
/* 11562 */   MCD::OPC_Decode, 192, 4, 46, // Opcode: CMP8dj
/* 11566 */   MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 11582
/* 11571 */   MCD::OPC_CheckField, 3, 1, 1, 167, 10, 0, // Skip to: 14305
/* 11578 */   MCD::OPC_Decode, 194, 4, 47, // Opcode: CMP8dp
/* 11582 */   MCD::OPC_FilterValue, 3, 52, 0, 0, // Skip to: 11639
/* 11587 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11590 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11606
/* 11595 */   MCD::OPC_CheckField, 24, 4, 8, 143, 10, 0, // Skip to: 14305
/* 11602 */   MCD::OPC_Decode, 190, 4, 48, // Opcode: CMP8df
/* 11606 */   MCD::OPC_FilterValue, 1, 134, 10, 0, // Skip to: 14305
/* 11611 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11614 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 11623
/* 11619 */   MCD::OPC_Decode, 195, 4, 50, // Opcode: CMP8dq
/* 11623 */   MCD::OPC_FilterValue, 3, 117, 10, 0, // Skip to: 14305
/* 11628 */   MCD::OPC_CheckField, 24, 4, 8, 110, 10, 0, // Skip to: 14305
/* 11635 */   MCD::OPC_Decode, 193, 4, 51, // Opcode: CMP8dk
/* 11639 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 11649
/* 11644 */   MCD::OPC_Decode, 169, 4, 224, 1, // Opcode: CMP16dr
/* 11649 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 11666
/* 11654 */   MCD::OPC_CheckField, 3, 1, 0, 84, 10, 0, // Skip to: 14305
/* 11661 */   MCD::OPC_Decode, 165, 4, 144, 1, // Opcode: CMP16dj
/* 11666 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11683
/* 11671 */   MCD::OPC_CheckField, 3, 1, 1, 67, 10, 0, // Skip to: 14305
/* 11678 */   MCD::OPC_Decode, 167, 4, 147, 1, // Opcode: CMP16dp
/* 11683 */   MCD::OPC_FilterValue, 7, 55, 0, 0, // Skip to: 11743
/* 11688 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11691 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11708
/* 11696 */   MCD::OPC_CheckField, 24, 4, 8, 42, 10, 0, // Skip to: 14305
/* 11703 */   MCD::OPC_Decode, 163, 4, 150, 1, // Opcode: CMP16df
/* 11708 */   MCD::OPC_FilterValue, 1, 32, 10, 0, // Skip to: 14305
/* 11713 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11716 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11726
/* 11721 */   MCD::OPC_Decode, 168, 4, 156, 1, // Opcode: CMP16dq
/* 11726 */   MCD::OPC_FilterValue, 3, 14, 10, 0, // Skip to: 14305
/* 11731 */   MCD::OPC_CheckField, 24, 4, 8, 7, 10, 0, // Skip to: 14305
/* 11738 */   MCD::OPC_Decode, 166, 4, 159, 1, // Opcode: CMP16dk
/* 11743 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 11753
/* 11748 */   MCD::OPC_Decode, 182, 4, 225, 1, // Opcode: CMP32dr
/* 11753 */   MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 11769
/* 11758 */   MCD::OPC_CheckField, 3, 1, 0, 236, 9, 0, // Skip to: 14305
/* 11765 */   MCD::OPC_Decode, 178, 4, 111, // Opcode: CMP32dj
/* 11769 */   MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 11785
/* 11774 */   MCD::OPC_CheckField, 3, 1, 1, 220, 9, 0, // Skip to: 14305
/* 11781 */   MCD::OPC_Decode, 180, 4, 112, // Opcode: CMP32dp
/* 11785 */   MCD::OPC_FilterValue, 11, 52, 0, 0, // Skip to: 11842
/* 11790 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11793 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11809
/* 11798 */   MCD::OPC_CheckField, 24, 4, 8, 196, 9, 0, // Skip to: 14305
/* 11805 */   MCD::OPC_Decode, 176, 4, 114, // Opcode: CMP32df
/* 11809 */   MCD::OPC_FilterValue, 1, 187, 9, 0, // Skip to: 14305
/* 11814 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11817 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 11826
/* 11822 */   MCD::OPC_Decode, 181, 4, 118, // Opcode: CMP32dq
/* 11826 */   MCD::OPC_FilterValue, 3, 170, 9, 0, // Skip to: 14305
/* 11831 */   MCD::OPC_CheckField, 24, 4, 8, 163, 9, 0, // Skip to: 14305
/* 11838 */   MCD::OPC_Decode, 179, 4, 120, // Opcode: CMP32dk
/* 11842 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 11859
/* 11847 */   MCD::OPC_CheckField, 3, 1, 0, 147, 9, 0, // Skip to: 14305
/* 11854 */   MCD::OPC_Decode, 132, 10, 226, 1, // Opcode: XOR8dd
/* 11859 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 11876
/* 11864 */   MCD::OPC_CheckField, 3, 1, 0, 130, 9, 0, // Skip to: 14305
/* 11871 */   MCD::OPC_Decode, 128, 10, 227, 1, // Opcode: XOR16dd
/* 11876 */   MCD::OPC_FilterValue, 24, 120, 9, 0, // Skip to: 14305
/* 11881 */   MCD::OPC_CheckField, 3, 1, 0, 113, 9, 0, // Skip to: 14305
/* 11888 */   MCD::OPC_Decode, 130, 10, 228, 1, // Opcode: XOR32dd
/* 11893 */   MCD::OPC_FilterValue, 12, 110, 2, 0, // Skip to: 12520
/* 11898 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11901 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11918
/* 11906 */   MCD::OPC_CheckField, 3, 1, 0, 88, 9, 0, // Skip to: 14305
/* 11913 */   MCD::OPC_Decode, 178, 3, 187, 1, // Opcode: AND8dd
/* 11918 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 11935
/* 11923 */   MCD::OPC_CheckField, 3, 1, 0, 71, 9, 0, // Skip to: 14305
/* 11930 */   MCD::OPC_Decode, 181, 3, 188, 1, // Opcode: AND8dj
/* 11935 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 11952
/* 11940 */   MCD::OPC_CheckField, 3, 1, 1, 54, 9, 0, // Skip to: 14305
/* 11947 */   MCD::OPC_Decode, 183, 3, 189, 1, // Opcode: AND8dp
/* 11952 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 12029
/* 11957 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11960 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11977
/* 11965 */   MCD::OPC_CheckField, 24, 4, 8, 29, 9, 0, // Skip to: 14305
/* 11972 */   MCD::OPC_Decode, 179, 3, 190, 1, // Opcode: AND8df
/* 11977 */   MCD::OPC_FilterValue, 1, 19, 9, 0, // Skip to: 14305
/* 11982 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11985 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11995
/* 11990 */   MCD::OPC_Decode, 184, 3, 191, 1, // Opcode: AND8dq
/* 11995 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12012
/* 12000 */   MCD::OPC_CheckField, 24, 4, 8, 250, 8, 0, // Skip to: 14305
/* 12007 */   MCD::OPC_Decode, 182, 3, 192, 1, // Opcode: AND8dk
/* 12012 */   MCD::OPC_FilterValue, 4, 240, 8, 0, // Skip to: 14305
/* 12017 */   MCD::OPC_CheckField, 24, 8, 0, 233, 8, 0, // Skip to: 14305
/* 12024 */   MCD::OPC_Decode, 180, 3, 193, 1, // Opcode: AND8di
/* 12029 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 12051
/* 12034 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12046
/* 12041 */   MCD::OPC_Decode, 150, 3, 194, 1, // Opcode: AND16dd
/* 12046 */   MCD::OPC_Decode, 157, 3, 195, 1, // Opcode: AND16dr
/* 12051 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 12068
/* 12056 */   MCD::OPC_CheckField, 3, 1, 0, 194, 8, 0, // Skip to: 14305
/* 12063 */   MCD::OPC_Decode, 153, 3, 196, 1, // Opcode: AND16dj
/* 12068 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 12085
/* 12073 */   MCD::OPC_CheckField, 3, 1, 1, 177, 8, 0, // Skip to: 14305
/* 12080 */   MCD::OPC_Decode, 155, 3, 197, 1, // Opcode: AND16dp
/* 12085 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 12155
/* 12090 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12093 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12110
/* 12098 */   MCD::OPC_CheckField, 24, 4, 8, 152, 8, 0, // Skip to: 14305
/* 12105 */   MCD::OPC_Decode, 151, 3, 198, 1, // Opcode: AND16df
/* 12110 */   MCD::OPC_FilterValue, 1, 142, 8, 0, // Skip to: 14305
/* 12115 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12118 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12128
/* 12123 */   MCD::OPC_Decode, 156, 3, 199, 1, // Opcode: AND16dq
/* 12128 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12145
/* 12133 */   MCD::OPC_CheckField, 24, 4, 8, 117, 8, 0, // Skip to: 14305
/* 12140 */   MCD::OPC_Decode, 154, 3, 200, 1, // Opcode: AND16dk
/* 12145 */   MCD::OPC_FilterValue, 4, 107, 8, 0, // Skip to: 14305
/* 12150 */   MCD::OPC_Decode, 152, 3, 199, 1, // Opcode: AND16di
/* 12155 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 12177
/* 12160 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12172
/* 12167 */   MCD::OPC_Decode, 164, 3, 201, 1, // Opcode: AND32dd
/* 12172 */   MCD::OPC_Decode, 171, 3, 202, 1, // Opcode: AND32dr
/* 12177 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 12194
/* 12182 */   MCD::OPC_CheckField, 3, 1, 0, 68, 8, 0, // Skip to: 14305
/* 12189 */   MCD::OPC_Decode, 167, 3, 203, 1, // Opcode: AND32dj
/* 12194 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 12211
/* 12199 */   MCD::OPC_CheckField, 3, 1, 1, 51, 8, 0, // Skip to: 14305
/* 12206 */   MCD::OPC_Decode, 169, 3, 204, 1, // Opcode: AND32dp
/* 12211 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 12281
/* 12216 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12219 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12236
/* 12224 */   MCD::OPC_CheckField, 24, 4, 8, 26, 8, 0, // Skip to: 14305
/* 12231 */   MCD::OPC_Decode, 165, 3, 205, 1, // Opcode: AND32df
/* 12236 */   MCD::OPC_FilterValue, 1, 16, 8, 0, // Skip to: 14305
/* 12241 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12244 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12254
/* 12249 */   MCD::OPC_Decode, 170, 3, 206, 1, // Opcode: AND32dq
/* 12254 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12271
/* 12259 */   MCD::OPC_CheckField, 24, 4, 8, 247, 7, 0, // Skip to: 14305
/* 12266 */   MCD::OPC_Decode, 168, 3, 207, 1, // Opcode: AND32dk
/* 12271 */   MCD::OPC_FilterValue, 4, 237, 7, 0, // Skip to: 14305
/* 12276 */   MCD::OPC_Decode, 166, 3, 208, 1, // Opcode: AND32di
/* 12281 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 12298
/* 12286 */   MCD::OPC_CheckField, 3, 1, 0, 220, 7, 0, // Skip to: 14305
/* 12293 */   MCD::OPC_Decode, 252, 9, 209, 1, // Opcode: UMULd32d16
/* 12298 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 12315
/* 12303 */   MCD::OPC_CheckField, 0, 4, 12, 203, 7, 0, // Skip to: 14305
/* 12310 */   MCD::OPC_Decode, 254, 9, 206, 1, // Opcode: UMULd32i16
/* 12315 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 12331
/* 12320 */   MCD::OPC_CheckField, 3, 1, 0, 186, 7, 0, // Skip to: 14305
/* 12327 */   MCD::OPC_Decode, 187, 3, 40, // Opcode: AND8jd
/* 12331 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 12347
/* 12336 */   MCD::OPC_CheckField, 3, 1, 1, 170, 7, 0, // Skip to: 14305
/* 12343 */   MCD::OPC_Decode, 189, 3, 41, // Opcode: AND8pd
/* 12347 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 12370
/* 12352 */   MCD::OPC_CheckField, 24, 4, 8, 154, 7, 0, // Skip to: 14305
/* 12359 */   MCD::OPC_CheckField, 3, 1, 0, 147, 7, 0, // Skip to: 14305
/* 12366 */   MCD::OPC_Decode, 185, 3, 42, // Opcode: AND8fd
/* 12370 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 12387
/* 12375 */   MCD::OPC_CheckField, 3, 1, 0, 131, 7, 0, // Skip to: 14305
/* 12382 */   MCD::OPC_Decode, 160, 3, 210, 1, // Opcode: AND16jd
/* 12387 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 12404
/* 12392 */   MCD::OPC_CheckField, 3, 1, 1, 114, 7, 0, // Skip to: 14305
/* 12399 */   MCD::OPC_Decode, 162, 3, 211, 1, // Opcode: AND16pd
/* 12404 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 12428
/* 12409 */   MCD::OPC_CheckField, 24, 4, 8, 97, 7, 0, // Skip to: 14305
/* 12416 */   MCD::OPC_CheckField, 3, 1, 0, 90, 7, 0, // Skip to: 14305
/* 12423 */   MCD::OPC_Decode, 158, 3, 212, 1, // Opcode: AND16fd
/* 12428 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 12445
/* 12433 */   MCD::OPC_CheckField, 3, 1, 0, 73, 7, 0, // Skip to: 14305
/* 12440 */   MCD::OPC_Decode, 174, 3, 213, 1, // Opcode: AND32jd
/* 12445 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 12462
/* 12450 */   MCD::OPC_CheckField, 3, 1, 1, 56, 7, 0, // Skip to: 14305
/* 12457 */   MCD::OPC_Decode, 176, 3, 214, 1, // Opcode: AND32pd
/* 12462 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 12486
/* 12467 */   MCD::OPC_CheckField, 24, 4, 8, 39, 7, 0, // Skip to: 14305
/* 12474 */   MCD::OPC_CheckField, 3, 1, 0, 32, 7, 0, // Skip to: 14305
/* 12481 */   MCD::OPC_Decode, 172, 3, 215, 1, // Opcode: AND32fd
/* 12486 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 12503
/* 12491 */   MCD::OPC_CheckField, 3, 1, 0, 15, 7, 0, // Skip to: 14305
/* 12498 */   MCD::OPC_Decode, 192, 9, 209, 1, // Opcode: SMULd32d16
/* 12503 */   MCD::OPC_FilterValue, 31, 5, 7, 0, // Skip to: 14305
/* 12508 */   MCD::OPC_CheckField, 0, 4, 12, 254, 6, 0, // Skip to: 14305
/* 12515 */   MCD::OPC_Decode, 194, 9, 206, 1, // Opcode: SMULd32i16
/* 12520 */   MCD::OPC_FilterValue, 13, 217, 2, 0, // Skip to: 13254
/* 12525 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 12528 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12545
/* 12533 */   MCD::OPC_CheckField, 3, 1, 0, 229, 6, 0, // Skip to: 14305
/* 12540 */   MCD::OPC_Decode, 134, 3, 187, 1, // Opcode: ADD8dd
/* 12545 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 12562
/* 12550 */   MCD::OPC_CheckField, 3, 1, 0, 212, 6, 0, // Skip to: 14305
/* 12557 */   MCD::OPC_Decode, 137, 3, 188, 1, // Opcode: ADD8dj
/* 12562 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 12579
/* 12567 */   MCD::OPC_CheckField, 3, 1, 1, 195, 6, 0, // Skip to: 14305
/* 12574 */   MCD::OPC_Decode, 139, 3, 189, 1, // Opcode: ADD8dp
/* 12579 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 12656
/* 12584 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12587 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12604
/* 12592 */   MCD::OPC_CheckField, 24, 4, 8, 170, 6, 0, // Skip to: 14305
/* 12599 */   MCD::OPC_Decode, 135, 3, 190, 1, // Opcode: ADD8df
/* 12604 */   MCD::OPC_FilterValue, 1, 160, 6, 0, // Skip to: 14305
/* 12609 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12612 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12622
/* 12617 */   MCD::OPC_Decode, 140, 3, 191, 1, // Opcode: ADD8dq
/* 12622 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12639
/* 12627 */   MCD::OPC_CheckField, 24, 4, 8, 135, 6, 0, // Skip to: 14305
/* 12634 */   MCD::OPC_Decode, 138, 3, 192, 1, // Opcode: ADD8dk
/* 12639 */   MCD::OPC_FilterValue, 4, 125, 6, 0, // Skip to: 14305
/* 12644 */   MCD::OPC_CheckField, 24, 8, 0, 118, 6, 0, // Skip to: 14305
/* 12651 */   MCD::OPC_Decode, 136, 3, 193, 1, // Opcode: ADD8di
/* 12656 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 12678
/* 12661 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12673
/* 12668 */   MCD::OPC_Decode, 226, 2, 194, 1, // Opcode: ADD16dd
/* 12673 */   MCD::OPC_Decode, 233, 2, 195, 1, // Opcode: ADD16dr
/* 12678 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 12695
/* 12683 */   MCD::OPC_CheckField, 3, 1, 0, 79, 6, 0, // Skip to: 14305
/* 12690 */   MCD::OPC_Decode, 229, 2, 196, 1, // Opcode: ADD16dj
/* 12695 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 12712
/* 12700 */   MCD::OPC_CheckField, 3, 1, 1, 62, 6, 0, // Skip to: 14305
/* 12707 */   MCD::OPC_Decode, 231, 2, 197, 1, // Opcode: ADD16dp
/* 12712 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 12782
/* 12717 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12720 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12737
/* 12725 */   MCD::OPC_CheckField, 24, 4, 8, 37, 6, 0, // Skip to: 14305
/* 12732 */   MCD::OPC_Decode, 227, 2, 198, 1, // Opcode: ADD16df
/* 12737 */   MCD::OPC_FilterValue, 1, 27, 6, 0, // Skip to: 14305
/* 12742 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12745 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12755
/* 12750 */   MCD::OPC_Decode, 232, 2, 199, 1, // Opcode: ADD16dq
/* 12755 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12772
/* 12760 */   MCD::OPC_CheckField, 24, 4, 8, 2, 6, 0, // Skip to: 14305
/* 12767 */   MCD::OPC_Decode, 230, 2, 200, 1, // Opcode: ADD16dk
/* 12772 */   MCD::OPC_FilterValue, 4, 248, 5, 0, // Skip to: 14305
/* 12777 */   MCD::OPC_Decode, 228, 2, 199, 1, // Opcode: ADD16di
/* 12782 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 12804
/* 12787 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12799
/* 12794 */   MCD::OPC_Decode, 248, 2, 201, 1, // Opcode: ADD32dd
/* 12799 */   MCD::OPC_Decode, 255, 2, 202, 1, // Opcode: ADD32dr
/* 12804 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 12821
/* 12809 */   MCD::OPC_CheckField, 3, 1, 0, 209, 5, 0, // Skip to: 14305
/* 12816 */   MCD::OPC_Decode, 251, 2, 203, 1, // Opcode: ADD32dj
/* 12821 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 12838
/* 12826 */   MCD::OPC_CheckField, 3, 1, 1, 192, 5, 0, // Skip to: 14305
/* 12833 */   MCD::OPC_Decode, 253, 2, 204, 1, // Opcode: ADD32dp
/* 12838 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 12908
/* 12843 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12846 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12863
/* 12851 */   MCD::OPC_CheckField, 24, 4, 8, 167, 5, 0, // Skip to: 14305
/* 12858 */   MCD::OPC_Decode, 249, 2, 205, 1, // Opcode: ADD32df
/* 12863 */   MCD::OPC_FilterValue, 1, 157, 5, 0, // Skip to: 14305
/* 12868 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12871 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12881
/* 12876 */   MCD::OPC_Decode, 254, 2, 206, 1, // Opcode: ADD32dq
/* 12881 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12898
/* 12886 */   MCD::OPC_CheckField, 24, 4, 8, 132, 5, 0, // Skip to: 14305
/* 12893 */   MCD::OPC_Decode, 252, 2, 207, 1, // Opcode: ADD32dk
/* 12898 */   MCD::OPC_FilterValue, 4, 122, 5, 0, // Skip to: 14305
/* 12903 */   MCD::OPC_Decode, 250, 2, 208, 1, // Opcode: ADD32di
/* 12908 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 12925
/* 12913 */   MCD::OPC_CheckField, 3, 1, 0, 105, 5, 0, // Skip to: 14305
/* 12920 */   MCD::OPC_Decode, 149, 3, 187, 1, // Opcode: ADDX8dd
/* 12925 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 12941
/* 12930 */   MCD::OPC_CheckField, 3, 1, 0, 88, 5, 0, // Skip to: 14305
/* 12937 */   MCD::OPC_Decode, 143, 3, 40, // Opcode: ADD8jd
/* 12941 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 12957
/* 12946 */   MCD::OPC_CheckField, 3, 1, 1, 72, 5, 0, // Skip to: 14305
/* 12953 */   MCD::OPC_Decode, 145, 3, 41, // Opcode: ADD8pd
/* 12957 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 12980
/* 12962 */   MCD::OPC_CheckField, 24, 4, 8, 56, 5, 0, // Skip to: 14305
/* 12969 */   MCD::OPC_CheckField, 3, 1, 0, 49, 5, 0, // Skip to: 14305
/* 12976 */   MCD::OPC_Decode, 141, 3, 42, // Opcode: ADD8fd
/* 12980 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 12997
/* 12985 */   MCD::OPC_CheckField, 3, 1, 0, 33, 5, 0, // Skip to: 14305
/* 12992 */   MCD::OPC_Decode, 147, 3, 194, 1, // Opcode: ADDX16dd
/* 12997 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 13014
/* 13002 */   MCD::OPC_CheckField, 3, 1, 0, 16, 5, 0, // Skip to: 14305
/* 13009 */   MCD::OPC_Decode, 236, 2, 210, 1, // Opcode: ADD16jd
/* 13014 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 13031
/* 13019 */   MCD::OPC_CheckField, 3, 1, 1, 255, 4, 0, // Skip to: 14305
/* 13026 */   MCD::OPC_Decode, 238, 2, 211, 1, // Opcode: ADD16pd
/* 13031 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 13055
/* 13036 */   MCD::OPC_CheckField, 24, 4, 8, 238, 4, 0, // Skip to: 14305
/* 13043 */   MCD::OPC_CheckField, 3, 1, 0, 231, 4, 0, // Skip to: 14305
/* 13050 */   MCD::OPC_Decode, 234, 2, 212, 1, // Opcode: ADD16fd
/* 13055 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 13072
/* 13060 */   MCD::OPC_CheckField, 3, 1, 0, 214, 4, 0, // Skip to: 14305
/* 13067 */   MCD::OPC_Decode, 148, 3, 201, 1, // Opcode: ADDX32dd
/* 13072 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 13089
/* 13077 */   MCD::OPC_CheckField, 3, 1, 0, 197, 4, 0, // Skip to: 14305
/* 13084 */   MCD::OPC_Decode, 130, 3, 213, 1, // Opcode: ADD32jd
/* 13089 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 13106
/* 13094 */   MCD::OPC_CheckField, 3, 1, 1, 180, 4, 0, // Skip to: 14305
/* 13101 */   MCD::OPC_Decode, 132, 3, 214, 1, // Opcode: ADD32pd
/* 13106 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 13130
/* 13111 */   MCD::OPC_CheckField, 24, 4, 8, 163, 4, 0, // Skip to: 14305
/* 13118 */   MCD::OPC_CheckField, 3, 1, 0, 156, 4, 0, // Skip to: 14305
/* 13125 */   MCD::OPC_Decode, 128, 3, 215, 1, // Opcode: ADD32fd
/* 13130 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 13140
/* 13135 */   MCD::OPC_Decode, 247, 2, 216, 1, // Opcode: ADD32ar
/* 13140 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 13157
/* 13145 */   MCD::OPC_CheckField, 3, 1, 0, 129, 4, 0, // Skip to: 14305
/* 13152 */   MCD::OPC_Decode, 243, 2, 217, 1, // Opcode: ADD32aj
/* 13157 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 13174
/* 13162 */   MCD::OPC_CheckField, 3, 1, 1, 112, 4, 0, // Skip to: 14305
/* 13169 */   MCD::OPC_Decode, 245, 2, 218, 1, // Opcode: ADD32ap
/* 13174 */   MCD::OPC_FilterValue, 31, 102, 4, 0, // Skip to: 14305
/* 13179 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 13182 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 13199
/* 13187 */   MCD::OPC_CheckField, 24, 4, 8, 87, 4, 0, // Skip to: 14305
/* 13194 */   MCD::OPC_Decode, 241, 2, 219, 1, // Opcode: ADD32af
/* 13199 */   MCD::OPC_FilterValue, 1, 77, 4, 0, // Skip to: 14305
/* 13204 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 13207 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13217
/* 13212 */   MCD::OPC_Decode, 240, 2, 220, 1, // Opcode: ADD32ab
/* 13217 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 13227
/* 13222 */   MCD::OPC_Decode, 246, 2, 221, 1, // Opcode: ADD32aq
/* 13227 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 13244
/* 13232 */   MCD::OPC_CheckField, 24, 4, 8, 42, 4, 0, // Skip to: 14305
/* 13239 */   MCD::OPC_Decode, 244, 2, 222, 1, // Opcode: ADD32ak
/* 13244 */   MCD::OPC_FilterValue, 4, 32, 4, 0, // Skip to: 14305
/* 13249 */   MCD::OPC_Decode, 242, 2, 220, 1, // Opcode: ADD32ai
/* 13254 */   MCD::OPC_FilterValue, 14, 47, 1, 0, // Skip to: 13562
/* 13259 */   MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 13262 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 13272
/* 13267 */   MCD::OPC_Decode, 196, 3, 229, 1, // Opcode: ASR8di
/* 13272 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 13282
/* 13277 */   MCD::OPC_Decode, 156, 5, 229, 1, // Opcode: LSR8di
/* 13282 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 13292
/* 13287 */   MCD::OPC_Decode, 132, 9, 229, 1, // Opcode: ROR8di
/* 13292 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 13302
/* 13297 */   MCD::OPC_Decode, 195, 3, 226, 1, // Opcode: ASR8dd
/* 13302 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 13312
/* 13307 */   MCD::OPC_Decode, 155, 5, 226, 1, // Opcode: LSR8dd
/* 13312 */   MCD::OPC_FilterValue, 7, 5, 0, 0, // Skip to: 13322
/* 13317 */   MCD::OPC_Decode, 131, 9, 226, 1, // Opcode: ROR8dd
/* 13322 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 13332
/* 13327 */   MCD::OPC_Decode, 192, 3, 230, 1, // Opcode: ASR16di
/* 13332 */   MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 13342
/* 13337 */   MCD::OPC_Decode, 152, 5, 230, 1, // Opcode: LSR16di
/* 13342 */   MCD::OPC_FilterValue, 11, 5, 0, 0, // Skip to: 13352
/* 13347 */   MCD::OPC_Decode, 128, 9, 230, 1, // Opcode: ROR16di
/* 13352 */   MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 13362
/* 13357 */   MCD::OPC_Decode, 191, 3, 227, 1, // Opcode: ASR16dd
/* 13362 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 13372
/* 13367 */   MCD::OPC_Decode, 151, 5, 227, 1, // Opcode: LSR16dd
/* 13372 */   MCD::OPC_FilterValue, 15, 5, 0, 0, // Skip to: 13382
/* 13377 */   MCD::OPC_Decode, 255, 8, 227, 1, // Opcode: ROR16dd
/* 13382 */   MCD::OPC_FilterValue, 16, 5, 0, 0, // Skip to: 13392
/* 13387 */   MCD::OPC_Decode, 194, 3, 231, 1, // Opcode: ASR32di
/* 13392 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 13402
/* 13397 */   MCD::OPC_Decode, 154, 5, 231, 1, // Opcode: LSR32di
/* 13402 */   MCD::OPC_FilterValue, 19, 5, 0, 0, // Skip to: 13412
/* 13407 */   MCD::OPC_Decode, 130, 9, 231, 1, // Opcode: ROR32di
/* 13412 */   MCD::OPC_FilterValue, 20, 5, 0, 0, // Skip to: 13422
/* 13417 */   MCD::OPC_Decode, 193, 3, 228, 1, // Opcode: ASR32dd
/* 13422 */   MCD::OPC_FilterValue, 21, 5, 0, 0, // Skip to: 13432
/* 13427 */   MCD::OPC_Decode, 153, 5, 228, 1, // Opcode: LSR32dd
/* 13432 */   MCD::OPC_FilterValue, 23, 5, 0, 0, // Skip to: 13442
/* 13437 */   MCD::OPC_Decode, 129, 9, 228, 1, // Opcode: ROR32dd
/* 13442 */   MCD::OPC_FilterValue, 33, 5, 0, 0, // Skip to: 13452
/* 13447 */   MCD::OPC_Decode, 191, 9, 229, 1, // Opcode: SHL8di
/* 13452 */   MCD::OPC_FilterValue, 35, 5, 0, 0, // Skip to: 13462
/* 13457 */   MCD::OPC_Decode, 254, 8, 229, 1, // Opcode: ROL8di
/* 13462 */   MCD::OPC_FilterValue, 37, 5, 0, 0, // Skip to: 13472
/* 13467 */   MCD::OPC_Decode, 190, 9, 226, 1, // Opcode: SHL8dd
/* 13472 */   MCD::OPC_FilterValue, 39, 5, 0, 0, // Skip to: 13482
/* 13477 */   MCD::OPC_Decode, 253, 8, 226, 1, // Opcode: ROL8dd
/* 13482 */   MCD::OPC_FilterValue, 41, 5, 0, 0, // Skip to: 13492
/* 13487 */   MCD::OPC_Decode, 187, 9, 230, 1, // Opcode: SHL16di
/* 13492 */   MCD::OPC_FilterValue, 43, 5, 0, 0, // Skip to: 13502
/* 13497 */   MCD::OPC_Decode, 250, 8, 230, 1, // Opcode: ROL16di
/* 13502 */   MCD::OPC_FilterValue, 45, 5, 0, 0, // Skip to: 13512
/* 13507 */   MCD::OPC_Decode, 186, 9, 227, 1, // Opcode: SHL16dd
/* 13512 */   MCD::OPC_FilterValue, 47, 5, 0, 0, // Skip to: 13522
/* 13517 */   MCD::OPC_Decode, 249, 8, 227, 1, // Opcode: ROL16dd
/* 13522 */   MCD::OPC_FilterValue, 49, 5, 0, 0, // Skip to: 13532
/* 13527 */   MCD::OPC_Decode, 189, 9, 231, 1, // Opcode: SHL32di
/* 13532 */   MCD::OPC_FilterValue, 51, 5, 0, 0, // Skip to: 13542
/* 13537 */   MCD::OPC_Decode, 252, 8, 231, 1, // Opcode: ROL32di
/* 13542 */   MCD::OPC_FilterValue, 53, 5, 0, 0, // Skip to: 13552
/* 13547 */   MCD::OPC_Decode, 188, 9, 228, 1, // Opcode: SHL32dd
/* 13552 */   MCD::OPC_FilterValue, 55, 236, 2, 0, // Skip to: 14305
/* 13557 */   MCD::OPC_Decode, 251, 8, 228, 1, // Opcode: ROL32dd
/* 13562 */   MCD::OPC_FilterValue, 15, 226, 2, 0, // Skip to: 14305
/* 13567 */   MCD::OPC_ExtractField, 16, 7,  // Inst{22-16} ...
/* 13570 */   MCD::OPC_FilterValue, 0, 130, 0, 0, // Skip to: 13705
/* 13575 */   MCD::OPC_ExtractField, 29, 3,  // Inst{31-29} ...
/* 13578 */   MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 13601
/* 13583 */   MCD::OPC_CheckPredicate, 2, 205, 2, 0, // Skip to: 14305
/* 13588 */   MCD::OPC_CheckField, 0, 12, 128, 4, 197, 2, 0, // Skip to: 14305
/* 13596 */   MCD::OPC_Decode, 235, 4, 232, 1, // Opcode: FMOV80fp_fp
/* 13601 */   MCD::OPC_FilterValue, 4, 47, 0, 0, // Skip to: 13653
/* 13606 */   MCD::OPC_ExtractField, 3, 9,  // Inst{11-3} ...
/* 13609 */   MCD::OPC_FilterValue, 64, 17, 0, 0, // Skip to: 13631
/* 13614 */   MCD::OPC_CheckPredicate, 2, 174, 2, 0, // Skip to: 14305
/* 13619 */   MCD::OPC_CheckField, 23, 3, 0, 167, 2, 0, // Skip to: 14305
/* 13626 */   MCD::OPC_Decode, 238, 4, 233, 1, // Opcode: FMOVE32fpcs_d
/* 13631 */   MCD::OPC_FilterValue, 65, 157, 2, 0, // Skip to: 14305
/* 13636 */   MCD::OPC_CheckPredicate, 2, 152, 2, 0, // Skip to: 14305
/* 13641 */   MCD::OPC_CheckField, 23, 3, 0, 145, 2, 0, // Skip to: 14305
/* 13648 */   MCD::OPC_Decode, 239, 4, 234, 1, // Opcode: FMOVE32fpi_a
/* 13653 */   MCD::OPC_FilterValue, 5, 135, 2, 0, // Skip to: 14305
/* 13658 */   MCD::OPC_ExtractField, 3, 9,  // Inst{11-3} ...
/* 13661 */   MCD::OPC_FilterValue, 64, 17, 0, 0, // Skip to: 13683
/* 13666 */   MCD::OPC_CheckPredicate, 2, 122, 2, 0, // Skip to: 14305
/* 13671 */   MCD::OPC_CheckField, 23, 3, 0, 115, 2, 0, // Skip to: 14305
/* 13678 */   MCD::OPC_Decode, 237, 4, 235, 1, // Opcode: FMOVE32d_fpcs
/* 13683 */   MCD::OPC_FilterValue, 65, 105, 2, 0, // Skip to: 14305
/* 13688 */   MCD::OPC_CheckPredicate, 2, 100, 2, 0, // Skip to: 14305
/* 13693 */   MCD::OPC_CheckField, 23, 3, 0, 93, 2, 0, // Skip to: 14305
/* 13700 */   MCD::OPC_Decode, 236, 4, 236, 1, // Opcode: FMOVE32a_fpi
/* 13705 */   MCD::OPC_FilterValue, 24, 25, 0, 0, // Skip to: 13735
/* 13710 */   MCD::OPC_CheckPredicate, 2, 78, 2, 0, // Skip to: 14305
/* 13715 */   MCD::OPC_CheckField, 29, 3, 0, 71, 2, 0, // Skip to: 14305
/* 13722 */   MCD::OPC_CheckField, 0, 12, 128, 4, 63, 2, 0, // Skip to: 14305
/* 13730 */   MCD::OPC_Decode, 205, 4, 232, 1, // Opcode: FABS80fp_fp
/* 13735 */   MCD::OPC_FilterValue, 26, 25, 0, 0, // Skip to: 13765
/* 13740 */   MCD::OPC_CheckPredicate, 2, 48, 2, 0, // Skip to: 14305
/* 13745 */   MCD::OPC_CheckField, 29, 3, 0, 41, 2, 0, // Skip to: 14305
/* 13752 */   MCD::OPC_CheckField, 0, 12, 128, 4, 33, 2, 0, // Skip to: 14305
/* 13760 */   MCD::OPC_Decode, 245, 4, 232, 1, // Opcode: FNEG80fp_fp
/* 13765 */   MCD::OPC_FilterValue, 32, 25, 0, 0, // Skip to: 13795
/* 13770 */   MCD::OPC_CheckPredicate, 2, 18, 2, 0, // Skip to: 14305
/* 13775 */   MCD::OPC_CheckField, 29, 3, 0, 11, 2, 0, // Skip to: 14305
/* 13782 */   MCD::OPC_CheckField, 0, 12, 128, 4, 3, 2, 0, // Skip to: 14305
/* 13790 */   MCD::OPC_Decode, 220, 4, 237, 1, // Opcode: FDIV80fp_fp
/* 13795 */   MCD::OPC_FilterValue, 34, 25, 0, 0, // Skip to: 13825
/* 13800 */   MCD::OPC_CheckPredicate, 2, 244, 1, 0, // Skip to: 14305
/* 13805 */   MCD::OPC_CheckField, 29, 3, 0, 237, 1, 0, // Skip to: 14305
/* 13812 */   MCD::OPC_CheckField, 0, 12, 128, 4, 229, 1, 0, // Skip to: 14305
/* 13820 */   MCD::OPC_Decode, 208, 4, 237, 1, // Opcode: FADD80fp_fp
/* 13825 */   MCD::OPC_FilterValue, 35, 25, 0, 0, // Skip to: 13855
/* 13830 */   MCD::OPC_CheckPredicate, 2, 214, 1, 0, // Skip to: 14305
/* 13835 */   MCD::OPC_CheckField, 29, 3, 0, 207, 1, 0, // Skip to: 14305
/* 13842 */   MCD::OPC_CheckField, 0, 12, 128, 4, 199, 1, 0, // Skip to: 14305
/* 13850 */   MCD::OPC_Decode, 242, 4, 237, 1, // Opcode: FMUL80fp_fp
/* 13855 */   MCD::OPC_FilterValue, 40, 25, 0, 0, // Skip to: 13885
/* 13860 */   MCD::OPC_CheckPredicate, 2, 184, 1, 0, // Skip to: 14305
/* 13865 */   MCD::OPC_CheckField, 29, 3, 0, 177, 1, 0, // Skip to: 14305
/* 13872 */   MCD::OPC_CheckField, 0, 12, 128, 4, 169, 1, 0, // Skip to: 14305
/* 13880 */   MCD::OPC_Decode, 141, 5, 237, 1, // Opcode: FSUB80fp_fp
/* 13885 */   MCD::OPC_FilterValue, 64, 25, 0, 0, // Skip to: 13915
/* 13890 */   MCD::OPC_CheckPredicate, 3, 154, 1, 0, // Skip to: 14305
/* 13895 */   MCD::OPC_CheckField, 29, 3, 0, 147, 1, 0, // Skip to: 14305
/* 13902 */   MCD::OPC_CheckField, 0, 12, 128, 4, 139, 1, 0, // Skip to: 14305
/* 13910 */   MCD::OPC_Decode, 129, 5, 232, 1, // Opcode: FSMOV80fp_fp
/* 13915 */   MCD::OPC_FilterValue, 68, 25, 0, 0, // Skip to: 13945
/* 13920 */   MCD::OPC_CheckPredicate, 3, 124, 1, 0, // Skip to: 14305
/* 13925 */   MCD::OPC_CheckField, 29, 3, 0, 117, 1, 0, // Skip to: 14305
/* 13932 */   MCD::OPC_CheckField, 0, 12, 128, 4, 109, 1, 0, // Skip to: 14305
/* 13940 */   MCD::OPC_Decode, 223, 4, 232, 1, // Opcode: FDMOV80fp_fp
/* 13945 */   MCD::OPC_FilterValue, 88, 25, 0, 0, // Skip to: 13975
/* 13950 */   MCD::OPC_CheckPredicate, 3, 94, 1, 0, // Skip to: 14305
/* 13955 */   MCD::OPC_CheckField, 29, 3, 0, 87, 1, 0, // Skip to: 14305
/* 13962 */   MCD::OPC_CheckField, 0, 12, 128, 4, 79, 1, 0, // Skip to: 14305
/* 13970 */   MCD::OPC_Decode, 248, 4, 232, 1, // Opcode: FSABS80fp_fp
/* 13975 */   MCD::OPC_FilterValue, 90, 25, 0, 0, // Skip to: 14005
/* 13980 */   MCD::OPC_CheckPredicate, 3, 64, 1, 0, // Skip to: 14305
/* 13985 */   MCD::OPC_CheckField, 29, 3, 0, 57, 1, 0, // Skip to: 14305
/* 13992 */   MCD::OPC_CheckField, 0, 12, 128, 4, 49, 1, 0, // Skip to: 14305
/* 14000 */   MCD::OPC_Decode, 135, 5, 232, 1, // Opcode: FSNEG80fp_fp
/* 14005 */   MCD::OPC_FilterValue, 92, 25, 0, 0, // Skip to: 14035
/* 14010 */   MCD::OPC_CheckPredicate, 3, 34, 1, 0, // Skip to: 14305
/* 14015 */   MCD::OPC_CheckField, 29, 3, 0, 27, 1, 0, // Skip to: 14305
/* 14022 */   MCD::OPC_CheckField, 0, 12, 128, 4, 19, 1, 0, // Skip to: 14305
/* 14030 */   MCD::OPC_Decode, 211, 4, 232, 1, // Opcode: FDABS80fp_fp
/* 14035 */   MCD::OPC_FilterValue, 94, 25, 0, 0, // Skip to: 14065
/* 14040 */   MCD::OPC_CheckPredicate, 3, 4, 1, 0, // Skip to: 14305
/* 14045 */   MCD::OPC_CheckField, 29, 3, 0, 253, 0, 0, // Skip to: 14305
/* 14052 */   MCD::OPC_CheckField, 0, 12, 128, 4, 245, 0, 0, // Skip to: 14305
/* 14060 */   MCD::OPC_Decode, 229, 4, 232, 1, // Opcode: FDNEG80fp_fp
/* 14065 */   MCD::OPC_FilterValue, 96, 25, 0, 0, // Skip to: 14095
/* 14070 */   MCD::OPC_CheckPredicate, 3, 230, 0, 0, // Skip to: 14305
/* 14075 */   MCD::OPC_CheckField, 29, 3, 0, 223, 0, 0, // Skip to: 14305
/* 14082 */   MCD::OPC_CheckField, 0, 12, 128, 4, 215, 0, 0, // Skip to: 14305
/* 14090 */   MCD::OPC_Decode, 254, 4, 237, 1, // Opcode: FSDIV80fp_fp
/* 14095 */   MCD::OPC_FilterValue, 98, 25, 0, 0, // Skip to: 14125
/* 14100 */   MCD::OPC_CheckPredicate, 3, 200, 0, 0, // Skip to: 14305
/* 14105 */   MCD::OPC_CheckField, 29, 3, 0, 193, 0, 0, // Skip to: 14305
/* 14112 */   MCD::OPC_CheckField, 0, 12, 128, 4, 185, 0, 0, // Skip to: 14305
/* 14120 */   MCD::OPC_Decode, 251, 4, 237, 1, // Opcode: FSADD80fp_fp
/* 14125 */   MCD::OPC_FilterValue, 99, 25, 0, 0, // Skip to: 14155
/* 14130 */   MCD::OPC_CheckPredicate, 3, 170, 0, 0, // Skip to: 14305
/* 14135 */   MCD::OPC_CheckField, 29, 3, 0, 163, 0, 0, // Skip to: 14305
/* 14142 */   MCD::OPC_CheckField, 0, 12, 128, 4, 155, 0, 0, // Skip to: 14305
/* 14150 */   MCD::OPC_Decode, 132, 5, 237, 1, // Opcode: FSMUL80fp_fp
/* 14155 */   MCD::OPC_FilterValue, 100, 25, 0, 0, // Skip to: 14185
/* 14160 */   MCD::OPC_CheckPredicate, 3, 140, 0, 0, // Skip to: 14305
/* 14165 */   MCD::OPC_CheckField, 29, 3, 0, 133, 0, 0, // Skip to: 14305
/* 14172 */   MCD::OPC_CheckField, 0, 12, 128, 4, 125, 0, 0, // Skip to: 14305
/* 14180 */   MCD::OPC_Decode, 217, 4, 237, 1, // Opcode: FDDIV80fp_fp
/* 14185 */   MCD::OPC_FilterValue, 102, 25, 0, 0, // Skip to: 14215
/* 14190 */   MCD::OPC_CheckPredicate, 3, 110, 0, 0, // Skip to: 14305
/* 14195 */   MCD::OPC_CheckField, 29, 3, 0, 103, 0, 0, // Skip to: 14305
/* 14202 */   MCD::OPC_CheckField, 0, 12, 128, 4, 95, 0, 0, // Skip to: 14305
/* 14210 */   MCD::OPC_Decode, 214, 4, 237, 1, // Opcode: FDADD80fp_fp
/* 14215 */   MCD::OPC_FilterValue, 103, 25, 0, 0, // Skip to: 14245
/* 14220 */   MCD::OPC_CheckPredicate, 3, 80, 0, 0, // Skip to: 14305
/* 14225 */   MCD::OPC_CheckField, 29, 3, 0, 73, 0, 0, // Skip to: 14305
/* 14232 */   MCD::OPC_CheckField, 0, 12, 128, 4, 65, 0, 0, // Skip to: 14305
/* 14240 */   MCD::OPC_Decode, 226, 4, 237, 1, // Opcode: FDMUL80fp_fp
/* 14245 */   MCD::OPC_FilterValue, 104, 25, 0, 0, // Skip to: 14275
/* 14250 */   MCD::OPC_CheckPredicate, 3, 50, 0, 0, // Skip to: 14305
/* 14255 */   MCD::OPC_CheckField, 29, 3, 0, 43, 0, 0, // Skip to: 14305
/* 14262 */   MCD::OPC_CheckField, 0, 12, 128, 4, 35, 0, 0, // Skip to: 14305
/* 14270 */   MCD::OPC_Decode, 138, 5, 237, 1, // Opcode: FSSUB80fp_fp
/* 14275 */   MCD::OPC_FilterValue, 108, 25, 0, 0, // Skip to: 14305
/* 14280 */   MCD::OPC_CheckPredicate, 3, 20, 0, 0, // Skip to: 14305
/* 14285 */   MCD::OPC_CheckField, 29, 3, 0, 13, 0, 0, // Skip to: 14305
/* 14292 */   MCD::OPC_CheckField, 0, 12, 128, 4, 5, 0, 0, // Skip to: 14305
/* 14300 */   MCD::OPC_Decode, 232, 4, 237, 1, // Opcode: FDSUB80fp_fp
/* 14305 */   MCD::OPC_Fail,
  0
};

static const uint8_t InstrLenTable[] = {
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
16,
32,
16,
16,
32,
16,
32,
32,
48,
16,
32,
16,
32,
32,
48,
32,
48,
16,
16,
32,
16,
32,
32,
48,
16,
32,
32,
48,
16,
32,
32,
48,
32,
48,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
48,
16,
32,
32,
32,
32,
32,
64,
32,
32,
16,
32,
32,
32,
16,
48,
32,
48,
48,
48,
80,
32,
48,
16,
32,
32,
32,
16,
64,
48,
64,
64,
64,
64,
16,
32,
32,
16,
32,
32,
32,
48,
32,
48,
48,
48,
16,
16,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
32,
32,
32,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
16,
16,
48,
32,
32,
32,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
16,
32,
16,
32,
32,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
64,
80,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
80,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
16,
16,
32,
16,
48,
16,
32,
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[M68k::FeatureISA20]);
  case 1:
    return (Bits[M68k::FeatureISA10]);
  case 2:
    return (Bits[M68k::FeatureISA881]);
  case 3:
    return (Bits[M68k::FeatureISA40]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 119:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 133:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 135:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 136:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 137:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 138:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 139:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 140:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 141:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 142:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 143:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 144:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 145:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 146:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 147:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 148:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 149:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 150:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 151:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 152:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 153:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 154:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 155:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 156:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 157:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 158:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 159:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 160:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 161:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 162:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 163:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 164:
    tmp = fieldFromInstruction(insn, 28, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 165:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 166:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 167:
    tmp = fieldFromInstruction(insn, 0, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 168:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 169:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 170:
    return S;
  case 171:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 172:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 173:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 174:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 175:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 176:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 177:
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 178:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 179:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 180:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 181:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 182:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 183:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 184:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 185:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 186:
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 187:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 188:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 189:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 190:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 191:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 192:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 193:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 194:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 195:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 196:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 197:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 198:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 199:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 200:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 201:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 202:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 203:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 204:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 205:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 206:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 207:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 208:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 209:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 210:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 211:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 212:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 213:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 214:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 215:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 216:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 217:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 218:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 219:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 220:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 221:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 222:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 223:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 224:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 225:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 226:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 227:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 228:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 229:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 230:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 231:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 232:
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 233:
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPCSCRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 234:
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPICRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 235:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPCSCRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 236:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPICRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 237:
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI,
                                      llvm::function_ref<void(APInt &, uint64_t)> makeUp) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      makeUp(insn, Start + Len);
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      uint64_t Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      makeUp(insn, Start + Len);
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      Len = InstrLenTable[Opc];
      makeUp(insn, Len);
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      uint64_t PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      uint64_t NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
